////////////////////////////
//
//	Clip-4-Win UDC definitions
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
////////////////////////////

#ifndef	C4W_UDC_CH
#define	C4W_UDC_CH

#ifdef	NO_C4WCLASS
#xtranslate _IF_(.T., [<t>], [<f>])	=> <t>
#xtranslate _IF_(.F., [<t>], [<f>])	=> <f>
#else
  #ifndef  NO_TOPCLASS
    #include "TopClass.ch"
  #endif   // NO_TOPCLASS
#endif	// NO_C4WCLASS

#include "font.ch"
#include "menu.ch"

#ifndef	DLG_DEFSTYLE
#define	DLG_DEFSTYLE	DS_MODALFRAME + WS_POPUP + WS_VISIBLE + WS_CAPTION
#endif

#ifndef	CTL_DEFSTYLE	// default style added to controls in dynamic dialogs
#define	CTL_DEFSTYLE	WS_VISIBLE + WS_CHILD
#endif


// Internal use:

#xtranslate :Add( <p,...> , )	=>	:Add( <p> )

#command _ADD_ [<clauses,...>]						;
         FROM <l>,<t> TO <r>,<b>					;
         [<more,...>]							;
      => _ADD_ [<clauses>]						;
         AT <l>,<t> SIZE (<r>-<l>),(<b>-<t>)				;
         [<more>]

#command _ADD_ [<clauses,...>]						;
         WIDTH <w>  HEIGHT <h>						;
         [<more,...>]							;
      => _ADD_ [<clauses>]						;
         SIZE <w>,<h>							;
         [<more>]


#ifdef	NO_C4WCLASS

        //////////////////// NON-OO COMMANDS ////////////////////

#xtranslate _AI_(<w>, [<o>], [<nId>], [<x>])				;
         => <x>
#xtranslate _AI_(WGet, [<o>], <nId>, <oGet>)				;
         => {|hDlg| [<o> :=] C4W_WGet(hDlg, <nId>, <oGet>)}
#xtranslate _AI_(WBListBox, [<o>], <nId>, <a>)				;
         => {|hDlg| [<o> :=] C4W_BListBox(hDlg, <nId>, <a>)}

/*
 *  This is the one that should get used to create the controls for a
 *  dynamic dialog.  Normally, it's used with the INIT DIALOG command.
 *  Although the AT and SIZE clauses appear optional, you should use them!
 *
 *  Note: TEXT/TITLE <c> pre-loads <c> (must be a string) when the dialog
 *        item is created; INITIAL/ITEMS <x> occurs later & need not be a
 *        string.  See source\dialogf2.prg.
 */

#command _ADD_ <nId>,<class>,<cnWClass>,<nStDef>			;
         [<clauses1,...>]						;
         AT CHAR <x>,<y>  SIZE <w>,<h>					;
         [<clauses2,...>]						;
      => _ADD_ <nId>,<class>,<cnWClass>,<nStDef>			;
         [<clauses1>]							;
         AT 2+(<x>)*5,2+(<y>)*12  SIZE (<w>)*5,(<h>)*12			;
         [<clauses2>]

         // <class> is usually ignored; <a> and <x> are ignored;
         // <o> is meaningless; <aDlg> is needed
#command _ADD_ <nId>,<class>,<cnWClass>,<nStDef> [<cmd>]		;
         [<obj: OBJECT, OBJ> <o>]					;
         [<init: INITIAL, ITEMS> <x>]					;
         [ACTION <a>]							;
         [VALID <v>]							;
         [<in: IN DIALOG, IN, OF> <aDlg>]				;
         [STYLE <nSt>]							;
         [AT <nX>,<y>] [SIZE <w>,<h>]					;
         [<txt: TEXT, TITLE> <c>]					;
      => AppendDialog(_IF_(<.in.>, <aDlg>, aDlg), <nId>, <cnWClass>,	;
                      _IF_(<.nSt.>, <nSt>, <nStDef> + CTL_DEFSTYLE),	;
                      <nX>, <y>, <w>, <h> [, <c>])			;
       ; IF <.a.>							;
       ;    _Add_Dialog(_IF_(<.in.>, <aDlg>, aDlg), <nId>, <cnWClass>,	;
                        <x>, <{a}> [, <{v}>] )				;
       ; END								;
       ; _ADD_D _IF_(<.in.>, <aDlg>, aDlg),<nId>,<class>,<cnWClass>,<x>,<cmd> ;
         [OBJ <o>]

/*
 *  This is the one that should get used for pre-existing controls
 *  (e.g. in a resource dialog).
 */

#command _ADD_ <nId>,<class>,[<cnWClass>],<nStDef> [<cmd>]		;
         [<obj: OBJECT, OBJ> <o>]					;
         [<init: TEXT, INITIAL, ITEMS> <x>]				;
         [ACTION <a>]							;
         [VALID <v>]							;
         [<in: IN DIALOG, IN, OF> <aDlg>]				;
      => IF <.a.>							;
       ;    _Add_Dialog(_IF_(<.in.>, <aDlg>, aDlg), <nId>, <cnWClass>,	;
                        <x>, <{a}> [, <{v}>] )				;
       ; END								;
       ; _ADD_D _IF_(<.in.>, <aDlg>, aDlg),<nId>,<class>,<cnWClass>,<x>,<cmd> ;
         [OBJ <o>] [VALID <v>]

#command _ADD_D <aDlg>,<nId>,<class>,<cnWClass>,[<x>],[<cmd>]		;
         [OBJ <o>] [VALID <v>]						;
      => IF <.x.> .OR. <.cmd.>						;
       ;    _Add_Dialog(<aDlg>, <nId>, <cnWClass>,			;
                        _AI_(<class>, <o>, <nId>, <x>),			;
                        [ {|hDlg, hCtrl, nCode, nId|			;
                           <cmd>(hDlg, hCtrl, nCode, nId) } ]		;
                        [, <{v}>] )					;
       ; END

#command _ADD_D <aDlg>,<nId>,<class>,<cnWClass>,[<x>],<cmd>( [<p,...>] );
         [OBJ <o>] [VALID <v>]						;
      => _Add_Dialog(<aDlg>, <nId>, <cnWClass>,				;
                     _AI_(<class>, <o>, <nId>, <x>),			;
                     {|hDlg, hCtrl, nCode, nId|				;
                      <cmd>( [<p>,] hDlg, hCtrl, nCode, nId ) }		;
                     [, <{v}>] )


#command CREATE APPLICATION <hApp>					;
         [<clauses,...>]						;
      => CREATE APPLICATION <hApp>					;
         WINDOW <hApp> [<clauses>]


#command CREATE APPLICATION [<hApp>]					;
         WINDOW <hWnd>							;
         [<No3d: NO3D, NO 3D>]						;
         [<bwcc: BWCC, BORLAND>]					;
         [ON CLOSE <CFn>]						;
         [ON EXIT <EFn>]						;
         [<clauses,...>]						;
      => C4W_AppInit(<hApp>, !<.No3d.>, <.bwcc.>)			;
       ; CREATE WINDOW <hWnd> [<clauses>]				;
       ; C4W_AppMain(<hApp>, <hWnd>, <{CFn}>, <{EFn}>)  // appmain.prg


#command CREATE DIALOG <aDlg> RESOURCE <cnId>				;
         [<vbx: VBX>]							;
         [INSTANCE <h>]							;
      => IF <.vbx.>							;
       ;    VBXInit()							;
       ; END								;
       ; <aDlg> := _Create_Dialog(<cnId>, <h>,				;
                                  _IF_(<.vbx.>,				;
                                       {|hDlg|				;
                                        VBXInitDialog(hDlg,		;
                                                      _IF_(<.h.>, <h>,	;
                                                           _GetInstance()),;
                                                      <cnId>)},		;
                                      ))

#command CREATE DIALOG <aDlg>						;
         [<clauses1,...>]						;
         AT CHAR <x>,<y>  SIZE <w>,<h>					;
         [<clauses2,...>]						;
      => CREATE DIALOG <aDlg>						;
         [<clauses1>]							;
         AT 2+(<x>)*5,2+(<y>)*12  SIZE (<w>)*5,(<h>)*12			;
         [<clauses2>]

#command CREATE DIALOG <aDlg>						;
         [TITLE <c>]							;
         [STYLE <nSt>]							;
         [<at: AT, FROM> <x>,<y>]  [SIZE <w>,<h>]			;
         [POINTSIZE <nPt>]  [FONTNAME <cFace>]				;
         [<in: IN WINDOW, IN DIALOG, IN, OF> <hWnd>]			;
      => <aDlg> := CreateDialog(<c>, _IF_(<.nSt.>, <nSt>, DLG_DEFSTYLE),;
                                <x>, <y>, <w>, <h>, <nPt> [, <cFace>])


#command CREATE WINDOW <hWnd>						;
         [CLASS <class>]						;
         [<mdi: MDI>]							;
         [TITLE <c>]							;
         [STYLE <nSt>]							;
         [<at: AT, FROM> <x>,<y>]  [SIZE <w>,<h>]			;
         [<in: IN WINDOW, IN DIALOG, IN, OF> <hPWnd>]			;
         [ON INIT <IFn>]						;
         [ON <msg> <MFn>( <p,...> )]					;
         [ON <msg2> <MFn2>()]						;
         [MENU <hMenu>]							;
         [ID <nId>]							;
         [ICON <hIco>]							;
         [CURSOR <hCurs>]						;
         [BRUSH <hBr>]							;
         [INSTANCE <hInst>]						;
      => IF !GetClassInfo(_GetInstance(), _IF_(<.class.>, <class>, "C4W"));
       ;    IF !<.class.> .or. !GetClassInfo(0, <class>)		;
       ;       RegisterClass(CS_SAVEBITS + CS_DBLCLKS, <hInst>, <hIco>,	;
                             <hCurs>, <hBr>, _IF_(<.class.>, <class>, "C4W"));
       ;    END								;
       ; END								;
       ; <hWnd> := CreateWindow(_IF_(<.class.>, <class>, "C4W"), <c>,	;
                                _IF_(<.nSt.>, <nSt>, WS_OVERLAPPEDWINDOW),;
                                <x>, <y>, <w>, <h>,			;
                                _IF_(<.hPWnd.>, <hPWnd>, 0),		;
                                _IF_(<.hMenu.>, <hMenu>,		;
                                     _IF_(<.nId.>, <nId>, 0)),		;
                                <hInst>)				;
      [; <IFn>]								;
       ; C4W_HndlMsg(<hWnd>,						;
                     { [{|hWnd, nMsg, nwParam, nlParam|			;
                         <MFn>( <p>, hWnd, nMsg, nwParam, nlParam)},]	;
                       [{|hWnd, nMsg, nwParam, nlParam|			;
                         <MFn2>( hWnd, nMsg, nwParam, nlParam)},] },	;
                     { [<msg>,] [<msg2>,] })


#command SHOW DIALOG <aDlg>						;
         [<m: MODELESS>]						;
         [ON INIT <b>]							;
         [<in: IN WINDOW, IN DIALOG, IN, OF> <hWnd>]			;
         [RESULT <nh>]							;
      => [<nh> :=]							;
         _Show_Dialog(<aDlg>, !<.m.>, <hWnd>, <{b}>)


#else

        //////////////////// OO COMMANDS ////////////////////

/*
 *  This is the one that should get used to create the controls for a
 *  dynamic dialog.  Normally, it's used with the INIT DIALOG command.
 *  Although the AT and SIZE clauses appear optional, you should use them!
 *
 *  Note: TEXT/TITLE <c> pre-loads <c> (must be a string) when the dialog
 *        item is created; INITIAL/ITEMS <x> occurs later & need not be a
 *        string.
 */

#command _ADD_ <nId>,<class>,<cnWClass>,<nStDef> [<cmd>]		;
         [<obj: OBJECT, OBJ> <o>]					;
         [<init: INITIAL, ITEMS> <x>]					;
         [ACTION <a>]							;
         [VALID <v>]							;
         [<in: IN DIALOG, IN, OF> <oDlg>]				;
         [STYLE <nSt>]							;
         [AT <nX>,<y>] [SIZE <w>,<h>]					;
         [<txt: TEXT, TITLE> <c>]					;
      => AppendDialog(_IF_(<.in.>, <oDlg>, SELF):cnId_aDlg, <nId>,	;
                      <cnWClass>,					;
                      _IF_(<.nSt.>, <nSt>, <nStDef> + CTL_DEFSTYLE),	;
                      <nX>, <y>, <w>, <h> [, <c>])			;
       ; _IF_(<.in.>, <oDlg>, SELF)					;
         :Add( [<o> :=]							;
               <class>\{_IF_(<.in.>, <oDlg>, SELF), <nId> [, <x>]},	;
               _IF_(<.a.>, <{a}>, <(cmd)>) [, <{v}>] )

/*
 *  This is the one that should get used for pre-existing controls
 *  (e.g. in a resource dialog).
 */

#command _ADD_ <nId>,<class>,[<cnWClass>],<nStDef> [<cmd>]		;
         [<obj: OBJECT, OBJ> <o>]					;
         [<init: TEXT, INITIAL, ITEMS> <x>]				;
         [ACTION <a>]							;
         [VALID <v>]							;
         [<in: IN WINDOW, IN DIALOG, IN, OF> <oWnd>]			;
      => _IF_(<.in.>, <oWnd>, SELF)					;
         :Add( [<o> :=]							;
               <class>{_IF_(<.in.>, <oWnd>, SELF), <nId> [, <x>]},	;
               _IF_(<.a.>, <{a}>, <(cmd)>) [, <{v}>] )


#command CREATE APPLICATION <oApp>					;
         [CLASS <class>]						;
         [<mdi: MDI>]							;
         [WINDOW <oWnd>]						;
         [TITLE <c>]							;
         [ON INIT <IFn>]						;
         [<at: AT, FROM> <x>,<y>]  [SIZE <w>,<h>]			;
      => <oApp> := _IF_(<.class.>, <class>,				;
                        _IF_(<.mdi.>, WMDIApp, WApp)) {<c>, .F.}	;
       ; ( [<oWnd> :=] <oApp>:oWnd ):Create(<c>, , <x>, <y>, <w>, <h>)	;
      [; <IFn>]								;
       ; <oApp>:Start()							;
       ; <oApp>:Quit()


#command CREATE DIALOG <oDlg>						;
         [CLASS <class>]						;
         [TITLE <c>]							;
         [STYLE <nSt>]							;
         [<vbx: VBX>]							;
         [<at: AT, FROM> <x>,<y>]  [SIZE <w>,<h>]			;
         [POINTSIZE <nPt>]  [FONTNAME <cFace>]				;
         [<in: IN WINDOW, IN DIALOG, IN, OF> <oWnd>]			;
      => <oDlg> := _IF_(<.class.>, <class>,				;
                        _IF_(<.vbx.>, WVBXDialog, WDialog)		;
                       ){_IF_(<.in.>, <oWnd>, SELF),			;
                         CreateDialog(<c>,				;
                                      _IF_(<.nSt.>, <nSt>, DLG_DEFSTYLE),;
                                      <x>, <y>, <w>, <h>, <nPt>, <cFace>),;
                         .F.}


#command CREATE WINDOW <oWnd>						;
         [CLASS <class>]						;
         [<mdi: MDI>]							;
         [TITLE <c>]							;
         [MENU <cnMenuId>]						;
         [<at: AT, FROM> <x>,<y>]  [SIZE <w>,<h>]			;
         [<in: IN WINDOW, IN DIALOG, IN APPLICATION, IN, OF> <oParent>]	;
      => <oWnd> := _IF_(<.class.>, <class>,				;
                        _IF_(<.mdi.>, WMDIFrame, WSDIWindow))		;
                   {_IF_(<.in.>, <oParent>, SELF), <c>, <cnMenuId>, .F.} ;
                   :Create(<c>, , <x>, <y>, <w>, <h>)


#command INIT DIALOG <oDlg>						;
         [TITLE <c>]							;
         [STYLE <nSt>]							;
         [<at: AT, FROM> <x>,<y>]  [SIZE <w>,<h>]			;
         [POINTSIZE <nPt>]  [FONTNAME <cFace>]				;
         [<in: IN WINDOW, IN DIALOG, IN, OF> <oWnd>]			;
      => <oDlg>:cnId_aDlg := CreateDialog(<c>,				;
                                   _IF_(<.nSt.>, <nSt>, DLG_DEFSTYLE),	;
                                   <x>, <y>, <w>, <h>, <nPt> [,<cFace>])

	// various clauses are ignored...
#command SHOW DIALOG <oDlg>						;
         [<m: MODELESS>]						;
         [ON INIT <b>]							;
         [<in: IN WINDOW, IN DIALOG, IN, OF> <hWnd>]			;
         [RESULT <nh>]							;
      => [<nh> :=]							;
         _IF_(<.nh.>, <oDlg>:Create():Result, <oDlg>:Create())

#endif	// NO_C4WCLASS

/*
 *    IN ALPHABETICAL ORDER
 *    =====================
 */


// 3DBORDER  (using CTL3D.DLL):

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          3DBORDER							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WSSControl,DLG_STATIC,SS_GRAYFRAME		;
          [<clauses>] <obj> <o>


// 3DFRAME  (using CTL3D.DLL):

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          3DFRAME							;
          [<dn: DOWN>]							;
          [<up: UP>]							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WSSControl,DLG_STATIC,				;
          _IF_(<.up.>, SS_WHITEFRAME, SS_BLACKFRAME)			;
          [<clauses>] <obj> <o>


// BITMAP:
//
// E.g.	  @ ID 101  OBJECT ::oCtrl  BITMAP  RESOURCE IDB_PHOTO

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          BITMAP <name: FILE, FILENAME> <c>				;
          [<st: STRETCH>]						;
          [<clauses,...>]						;
       => _ADD_ <nId>,_IF_(<.st.>,WBitmapFStretch,WBitmapFile),		;
                DLG_BUTTON,BS_OWNERDRAW  INIT <c>			;
          [<clauses>] <obj> <o>

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          BITMAP <name: RESOURCE, RESID, RESNAME> <cn>			;
          [<st: STRETCH>]						;
          [<clauses,...>]						;
       => _ADD_ <nId>,_IF_(<.st.>,WBitmapStretch,WBitmap),		;
                DLG_BUTTON,BS_OWNERDRAW  INIT <cn>			;
          [<clauses>] <obj> <o>


// BITMAP BUTTON == BUTTON BITMAP

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          BITMAP BUTTON							;
          [<clauses,...>]						;
       => @ ID <nId> <obj> <o> BUTTON BITMAP [<clauses>]


// BLACKFRAME:

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          BLACKFRAME							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WSSControl,DLG_STATIC,SS_BLACKFRAME		;
          [<clauses>] <obj> <o>


// BLISTBOX:

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          BLISTBOX							;
          COLUMNS <aCols>						;
          [GOTOPBLOCK <bGoTop>]						;
          [GOBOTTOMBLOCK <bGoBottom>]					;
          [SKIPBLOCK <bSkip>]						;
          [ALIAS <cAlias>]						;
          [FONT <hBFont>]						;
          [UPDATEBLOCKS <aUpdate>]					;
          [AUTOGOTOP <lGoTop>]						;
          [<clauses,...>]						;
       => _ADD_ <nId>,WBListBox,DLG_LISTBOX,				;
          LBS_NOTIFY + LBS_OWNERDRAWVARIABLE + LBS_NOINTEGRALHEIGHT	;
          + WS_TABSTOP + WS_CLIPCHILDREN				;
          ; // + WS_VISIBLE + WS_CHILD from CTL_DEFSTYLE		;
          ITEMS { <aCols>, <bGoTop>, <bGoBottom>, <bSkip>, <cAlias>,	;
                  <hBFont>, <aUpdate>, <lGoTop> }			;
          [<clauses>] <obj> <o>


// [PUSH] BUTTON:

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <btn: PUSHBUTTON, BUTTON>					;
          [<clauses,...>]						;
       => _ADD_ <nId>,WPushButton,DLG_BUTTON,BS_PUSHBUTTON + WS_TABSTOP	;
          [<clauses>] <obj> <o>


// BUTTON BITMAP:

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          BUTTON BITMAP <name: RESOURCE, RESID, RESNAME> <cn>		;
          [<tog: TOGGLE>]						;
          [HELP <oH>]							;
          [<dn: DOWNBMP>]						;
          [<gray: GRAYBMP>]						;
          [<grdn: GRAYDOWNBMP>]						;
          [<clauses,...>]						;
       => _ADD_ <nId>,WButtonBitmap,DLG_BUTTON,BS_OWNERDRAW + WS_TABSTOP ;
          INIT {<.tog.>, <cn>, <oH>, <.dn.>, <.gray.>, <.grdn.>}	;
          [<clauses>] <obj> <o>


// BUTTON SPIN:    (defaults to VERTICAL)

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          BUTTON SPIN							;
          [<v: VERT, VERTICAL>]						;
          [<h: HORIZ, HORIZONTAL>]					;
          [HELP <oH>]							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WSpinButton,DLG_BUTTON,BS_OWNERDRAW		;
          INIT {_IF_(<.v.>, .F., <.h.>), <oH>}				;
          [<clauses>] <obj> <o>


// CHECKBOX:

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          CHECKBOX							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WCheckBox,DLG_BUTTON,BS_AUTOCHECKBOX + WS_TABSTOP	;
          [<clauses>] <obj> <o>


// COMBOBOX:
//
// E.g.		@ ID 100 OBJECT ::oCB COMBOBOX ITEMS aItems

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <cb: COMBOBOX, DROPDOWNLIST>					;
          [<clauses,...>]						;
       => _ADD_ <nId>,WComboBox,DLG_COMBOBOX,CBS_DROPDOWNLIST + WS_TABSTOP ;
          [<clauses>] <obj> <o>


// Generic CONTROL:
//
// E.g.	  @ ID 101  OBJECT ::oCtrl  CONTROL WProgressBar		;
//             WCLASS "Button"  STYLE BS_OWNERDRAW+CTL_DEFSTYLE  TITLE cStr
//
// Note: If you don't specify STYLE, CTL_DEFSTYLE is added automatically!

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          CONTROL <class> [WCLASS <cnWClass>]				;
          [<clauses,...>]						;
       => _ADD_ <nId>,<class>,<cnWClass>,0				;
          [<clauses>] <obj> <o>


// EDIT Control:
//
// E.g.		@ ID 101 OBJECT ::oEdit EDIT INITIAL cStr

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          EDIT								;
          [<clauses,...>]						;
       => _ADD_ <nId>,WEdit,DLG_EDIT,ES_AUTOHSCROLL + WS_BORDER + WS_TABSTOP ;
          [<clauses>] <obj> <o>


// Multi-Line EDIT Control:
//
// E.g.		@ ID 101 OBJECT ::oEdit MULTILINE EDIT INITIAL cStr

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <m: MULTILINE, MULTI> EDIT					;
          [<clauses,...>]						;
       => _ADD_ <nId>,WMLEdit,DLG_EDIT,					;
          ES_LEFT + ES_MULTILINE + ES_WANTRETURN + ES_AUTOHSCROLL	;
          + WS_BORDER + WS_TABSTOP					;
          [<clauses>] <obj> <o>


// (Windowed) GET:

/*#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          GET <var>							;
          [PICTURE <pic>]						;
          [VALID <valid>]						;
          [WHEN <when>]							;
          [<in: IN WINDOW, IN DIALOG, IN, OF> <oWnd>]			;
       => SetPos(500, 1)						;
        ; ::Add( [<o> :=]						;
                 WGet{_IF_(<.in.>, <oWnd>, SELF), <nId>,		;
                      _GET_( <var>, <(var)>, <pic>, <{valid}>, <{when}> )},;
                 {|oDlg, oCtrl| oCtrl:Valid} )
*/

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          GET <var>							;
          [PICTURE <pic>]						;
          [VALID <valid>]						;
          [WHEN <when>]							;
          [<in: IN WINDOW, IN DIALOG, IN, OF> <oWnd>]			;
          [<clauses,...>]						;
       => SetPos(500, 1)						;
        ; _ADD_ <nId>,WGet,DLG_EDIT,ES_AUTOHSCROLL + WS_BORDER + WS_TABSTOP ;
          INITIAL __GET( {|x| IIF(x == NIL, <var>, <var> := x)},	;
                         <(var)>, <pic>, <{valid}>, <{when}> )		;
          /* VALID {|oDlg, oCtrl| oCtrl:Valid} */			;
          [<clauses>] <obj> <o>


// GRAYFRAME:

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          GRAYFRAME							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WSSControl,DLG_STATIC,SS_GRAYFRAME		;
          [<clauses>] <obj> <o>


// GROUPBOX:

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          GROUPBOX							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WGroupBox,DLG_BUTTON,BS_GROUPBOX + WS_TABSTOP	;
          [<clauses>] <obj> <o>


// ICON:		(Windows needs the named icon as a resource)

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          ICON [<name: RESOURCE NAME, RESNAME> <c>]			;
          [<clauses,...>]						;
       => _ADD_ <nId>,WSSControl,DLG_STATIC,SS_ICON  [TEXT <c>]		;
          [<clauses>] <obj> <o>


// LISTBOX:
//
// E.g.		@ ID 100 OBJECT ::oPick LISTBOX ITEMS aItems

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          LISTBOX							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WListBox,DLG_LISTBOX,				;
          LBS_USETABSTOPS + LBS_NOTIFY + WS_TABSTOP			;
          [<clauses>] <obj> <o>


// PROGRESSBAR:
//
// E.g.	  @ ID 101  OBJECT ::oCtrl  PROGRESSBAR

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          PROGRESSBAR							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WProgressBar,DLG_BUTTON,BS_OWNERDRAW		;
          [<clauses>] <obj> <o>


// RADIOBUTTON:

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <btn: RADIOBUTTON, RADIO>					;
          [<clauses,...>]						;
       => _ADD_ <nId>,WRadioButton,DLG_BUTTON,BS_AUTORADIOBUTTON + WS_TABSTOP ;
          [<clauses>] <obj> <o>


// RAISEDFRAME  (with 3-D):

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          RAISEDFRAME							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WSSControl,DLG_STATIC,SS_WHITEFRAME		;
          [<clauses>] <obj> <o>


// SAY ("Static" Text Control):		(in source\oo\classes\text.prg)
//
// E.g.		@ ID 101 OBJECT ::oSay SAY cStr

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <say: SAY, TEXT, LEFTTEXT, TITLE>				;
          [<clauses,...>]						;
       => _ADD_ <nId>,WLeftText,DLG_STATIC,SS_LEFT			;
          [<clauses>] <obj> <o>

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <say: SAYCENTER, SAYCENTRE, CENTERTEXT, CENTRETEXT>		;
          [<clauses,...>]						;
       => _ADD_ <nId>,WCenterText,DLG_STATIC,SS_CENTER			;
          [<clauses>] <obj> <o>

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <say: SAYRIGHT, RIGHTTEXT>					;
          [<clauses,...>]						;
       => _ADD_ <nId>,WRightText,DLG_STATIC,SS_RIGHT			;
          [<clauses>] <obj> <o>

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <say: SAY, TEXT, LEFTTEXT, TITLE> <c>				;
          [<clauses,...>]						;
       => _ADD_ <nId>,WLeftText,DLG_STATIC,SS_LEFT  TEXT <c>		;
          [<clauses>] <obj> <o>

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <say: SAYCENTER, SAYCENTRE, CENTERTEXT, CENTRETEXT> <c>	;
          [<clauses,...>]						;
       => _ADD_ <nId>,WCenterText,DLG_STATIC,SS_CENTER  TEXT <c>	;
          [<clauses>] <obj> <o>

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <say: SAYRIGHT, RIGHTTEXT> <c>				;
          [<clauses,...>]						;
       => _ADD_ <nId>,WRightText,DLG_STATIC,SS_RIGHT  TEXT <c>		;
          [<clauses>] <obj> <o>


// SCROLLBAR (ANY):

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          SCROLLBAR							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WScrollBar,DLG_SCROLLBAR,WS_TABSTOP		;
          [<clauses>] <obj> <o>


// SCROLLBAR (HORIZ):

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <sb: HSCROLLBAR, HORIZ SCROLLBAR>				;
          [<clauses,...>]						;
       => _ADD_ <nId>,WHScrollBar,DLG_SCROLLBAR,SBS_HORZ + WS_TABSTOP	;
          [<clauses>] <obj> <o>


// SCROLLBAR (VERT):

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          <sb: VSCROLLBAR, VERT SCROLLBAR>				;
          [<clauses,...>]						;
       => _ADD_ <nId>,WVScrollBar,DLG_SCROLLBAR,SBS_VERT + WS_TABSTOP	;
          [<clauses>] <obj> <o>


// SPIN BUTTON == BUTTON SPIN

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          SPIN BUTTON							;
          [<clauses,...>]						;
       => @ ID <nId> <obj> <o> BUTTON SPIN [<clauses>]


// SSCONTROL (Static Control):		(in source\oo\classes\text.prg)

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          SSCONTROL <c>							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WSSControl,DLG_STATIC,0  TEXT <c>			;
          [<clauses>] <obj> <o>


// SUNKENFRAME  (using 3-D):

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          SUNKENFRAME							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WSSControl,DLG_STATIC,SS_BLACKFRAME		;
          [<clauses>] <obj> <o>


// VBX:		(using BIVBXnnn.DLL)

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          VBX								;
          [FILENAME <cFile>]						;
          [CLASS <cClass>]						;
          [ON <ev1> {|[<p1,...>]| <a1,...>}]				;
          [ON <event> <action>]						;
          [<clauses,...>]						;
       => _ADD_ <nId>,WVBXControl,"VBControl",0				;
          INIT {<(cFile)>, <(cClass)>,					;
                { [<(ev1)>, {|<p1>| <a1>}, ] [<(event)>, <{action}>, ] } } ;
          [<clauses>] <obj> <o>


// WHITEFRAME:

#xcommand @ ID <nId> [<obj: OBJECT, OBJ> <o>]				;
          WHITEFRAME							;
          [<clauses,...>]						;
       => _ADD_ <nId>,WSSControl,DLG_STATIC,SS_WHITEFRAME		;
          [<clauses>] <obj> <o>

#endif	// C4W_UDC_CH
