////////////////////////////
//
//	Clip-4-Win DRAWITEMSTRUCT definitions
//
//	Copyright (C) 1993 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
////////////////////////////

#ifndef	C4W_DIS_CH
#define	C4W_DIS_CH


// Array elements of aDIS[], which is used with owner-draw buttons etc.
//
// (these correspond to the members of the Windows DRAWITEMSTRUCT structure)

#define	DIS_CtlType	1	// one of ODT_BUTTON etc.
#define	DIS_CtlID	2	// the id (not for a menu)
#define	DIS_itemID	3	// menu-item id or listbox/combobox item #
				// (-ve if empty)
#define	DIS_itemAction	4	// action needed; one or more of ODA_*
#define	DIS_itemState	5	// state; one or more of ODS_*
#define	DIS_hwndItem	6	// window handle (or menu handle)
#define	DIS_hDC		7	// hDC for output
#define	DIS_rcLeft	8	// \
#define	DIS_rcTop	9	//  \___ x1,y1 and x2,y2 of rectangle to draw
#define	DIS_rcRight	10	//  /
#define	DIS_rcBottom	11	// /
#define	DIS_itemData	12	// value last assigned to listbox/combobox

#define	DIS_LENGTH	12	// length of array

#define	DIS_STRUCT_DEF	"uint[7],int[4],dword" // for a2bin(), bin2a()

// Value & Bit settings for Owner Draw items

// types of control
#define ODT_MENU	1
#define ODT_LISTBOX	2
#define ODT_COMBOBOX	3
#define ODT_BUTTON	4

// actions
#define ODA_DRAWENTIRE	1
#define ODA_SELECT	2
#define ODA_FOCUS	4

// states
#define ODS_SELECTED	1
#define ODS_GRAYED	2
#define ODS_DISABLED	4
#define ODS_CHECKED	8
#define ODS_FOCUS	16

#endif	// C4W_DIS_CH
