////////////////////////////
//
//	Clip-4-Win MENU definitions
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	NOTE: Some of the apparent possibiities are due to the pre-processor
//	      but aren't actually sensible/valid.  Also, the OO versions
//	      currently implement more of the options than the non-class ones.
//	      The syntax is deliberately almost identical so you can convert
//	      if you want.  Both are based on the syntax used by the resource
//	      compiler (and also VO).
//
////////////////////////////

#ifndef	C4W_MENU_CH
#define	C4W_MENU_CH

#ifdef	NO_C4WCLASS

// Use CreateMenu()/AppendMenu() etc. - See MENUF2.PRG

#xcommand MENU [<hMenu>] [RESOURCE <cnResId>]				;
          [DLL <cDLL>] [INSTANCE <hInst>]				;
          [<in: IN WINDOW, IN, OF> <hWnd>]				;
									;
       => [<hMenu> :=]							;
          _Menu_Begin( <cnResId>, <hWnd>, <cDLL>, <hInst> )

#xcommand POPUP [<hPopup> TEXT] <cText> [ID <cnId>]			;
          [<in: IN MENU, IN, OF> <hMenu>]				;
									;
       => [<hPopup> :=]							;
          _Popup_Begin( <cText>, <hMenu> [, <cnId>] )

#xcommand MENUITEM [<hMenuItem> TEXT] <cText> [ID <cnId>]		;
          [COMMAND <cCmd>] [ACTION <bAction>]				;
          [HELP <oHelp>] [ACCELERATOR <oAccel>]				;
          [<chk: CHECKED>] [<dis: DISABLED>] [<gray: GRAYED>]		;
          [<in: IN MENU, IN, OF> <hMenu>]				;
									;
       => [<hMenuItem> :=]						;
          _Menu_Append( <cText>, <hMenu>, <cnId>, [ {|| <cCmd>()} ], <{bAction}>,;
                        <oHelp>, <oAccel>,				;
                        <.chk.>, <.dis.>, <.gray.>)

#xcommand MENUITEM [<hMenuItem>] [ID <cnId>]				;
          [COMMAND <cCmd>] [ACTION <bAction>]				;
          [HELP <oHelp>] [ACCELERATOR <oAccel>]				;
          [<chk: CHECKED>] [<dis: DISABLED>] [<gray: GRAYED>]		;
          BITMAP FILE <cBmpFile>					;
          [<in: IN MENU, IN, OF> <hMenu>]				;
									;
       => [<hMenuItem> :=]						;
          _Menu_Append( , <hMenu>, <cnId>, [ {|| <cCmd>()} ], <{bAction}>,;
                        <oHelp>, <oAccel>,				;
                        <.chk.>, <.dis.>, <.gray.>, <cBmpFile>)

#xcommand MENUITEM [<hMenuItem>] [ID <cnId>]				;
          [COMMAND <cCmd>] [ACTION <bAction>]				;
          [HELP <oHelp>] [ACCELERATOR <oAccel>]				;
          [<chk: CHECKED>] [<dis: DISABLED>] [<gray: GRAYED>]		;
          BITMAP RESOURCE <cnResId>					;
          [DLL <cDLL>] [INSTANCE <hInst>]				;
          [<in: IN MENU, IN, OF> <hMenu>]				;
									;
       => [<hMenuItem> :=]						;
          _Menu_Append( , <hMenu>, <cnId>, [ {|| <cCmd>()} ], <{bAction}>,;
                        <oHelp>, <oAccel>,				;
                        <.chk.>, <.dis.>, <.gray.>, , 			;
                        <cnResId>, <cDLL>, <hInst> )

#xcommand MENUITEM SEPARATOR [<in: IN MENU, IN, OF> <hMenu>]		;
       => _Menu_Append( [, <hMenu>] )

#xcommand ENDPOPUP							;
       => _Popup_End()

#xcommand ENDMENU							;
       => _Menu_End()

#command MDIWINDOWPOPUP							;
      => POPUP   "&Window"						;
       ;    MENUITEM "&Cascade"       COMMAND Cascade			;
               HELP DoHelp("Cascade child windows")			;
       ;    MENUITEM "&Tile"          COMMAND Tile			;
               HELP DoHelp("Tile child windows")				;
       ;    MENUITEM "Arrange &Icons" COMMAND ArrangeIcons		;
               HELP DoHelp("Arrange Icons of Minimised Children")	;
       ;    MENUITEM "Close &All"     COMMAND CloseAll			;
               HELP DoHelp("Close all child windows")			;
       ;    ENDPOPUP

#else	// NO_C4WCLASS

// Use classes - See MENUFN.PRG which uses WMenu, WPopup, WMenuItem, etc.

#xcommand MENU [<oMenu>] [RESOURCE <cnResId>]				;
          [DLL <cDLL>] [INSTANCE <hInst>]				;
          [<in: IN WINDOW, IN, OF> <oWnd>]				;
									;
       => [<oMenu> :=]							;
          _MenuBegin( <cnResId>, <oWnd>, <cDLL>, <hInst> )

#xcommand POPUP [<oPopup> TEXT] <cText> [ID <cnId>]			;
          [<in: IN MENU, IN, OF> <oMenu>]				;
									;
       => [<oPopup> :=]							;
          _PopupBegin( <cText> [, <oMenu>] )	// <cnId> isn't used

#xcommand MENUITEM [<oMenuItem> TEXT] <cText> [ID <nId>]		;
          [COMMAND <cCmd>] [ACTION <bAction>]				;
          [HELP <oHelp>] [ACCELERATOR <oAccel>]				;
          [<chk: CHECKED>] [<dis: DISABLED>] [<gray: GRAYED>]		;
          [<in: IN MENU, IN, OF> <oMenu>]				;
									;
       => [<oMenuItem> :=]						;
          _MenuAppend( <cText>, <oMenu>, <nId>, <(cCmd)>, <{bAction}>,	;
                       <oHelp>, <oAccel>,				;
                       <.chk.>, <.dis.>, <.gray.>)

#xcommand MENUITEM [<oMenuItem>] [ID <nId>]				;
          [COMMAND <cCmd>] [ACTION <bAction>]				;
          [HELP <oHelp>] [ACCELERATOR <oAccel>]				;
          [<chk: CHECKED>] [<dis: DISABLED>] [<gray: GRAYED>]		;
          BITMAP FILE <cBmpFile>					;
          [<in: IN MENU, IN, OF> <oMenu>]				;
									;
       => [<oMenuItem> :=]						;
          _MenuAppend( , <oMenu>, <nId>, <(cCmd)>, <{bAction}>,		;
                       <oHelp>, <oAccel>,				;
                       <.chk.>, <.dis.>, <.gray.>, <cBmpFile>)

#xcommand MENUITEM [<oMenuItem>] [ID <nId>]				;
          [COMMAND <cCmd>] [ACTION <bAction>]				;
          [HELP <oHelp>] [ACCELERATOR <oAccel>]				;
          [<chk: CHECKED>] [<dis: DISABLED>] [<gray: GRAYED>]		;
          BITMAP RESOURCE <cnResId>					;
          [DLL <cDLL>] [INSTANCE <hInst>]				;
          [<in: IN MENU, IN, OF> <oMenu>]				;
									;
       => [<oMenuItem> :=]						;
          _MenuAppend( , <oMenu>, <nId>, <(cCmd)>, <{bAction}>,		;
                       <oHelp>, <oAccel>,				;
                       <.chk.>, <.dis.>, <.gray.>, , 			;
                       <cnResId>, <cDLL>, <hInst> )

#xcommand MENUITEM SEPARATOR [<in: IN MENU, IN, OF> <oMenu>]		;
       => _MenuAppend( [, <oMenu>] )

#xcommand ENDPOPUP							;
       => _PopupEnd()

#xcommand ENDMENU							;
       => _MenuEnd()

#command MDIWINDOWPOPUP							;
      => POPUP   "&Window"						;
       ;    MENUITEM "&Cascade"       COMMAND Cascade			;
               HELP WHelp{"Cascade child windows"}			;
       ;    MENUITEM "&Tile"          COMMAND Tile			;
               HELP WHelp{"Tile child windows"}				;
       ;    MENUITEM "Arrange &Icons" COMMAND ArrangeIcons		;
               HELP WHelp{"Arrange Icons of Minimised Children"}	;
       ;    MENUITEM "Close &All"     COMMAND CloseAll			;
               HELP WHelp{"Close all child windows"}			;
       ;    ENDPOPUP

#endif	// NO_C4WCLASS

#endif	// C4W_MENU_CH

