////////////////////////////
//
//	Clip-4-Win TextMetric definitions
//
//	Copyright (C) 1993 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
////////////////////////////

#ifndef	C4W_TEXTMETR_CH
#define	C4W_TEXTMETR_CH


// Array elements of aTextMetric[], which is used with GetTextMetrics():
//
// (these correspond to the members of the Windows TEXTMETRIC structure)

#define	TM_Height		1
#define	TM_Ascent		2
#define	TM_Descent		3
#define	TM_InternalLeading	4
#define	TM_ExternalLeading	5
#define	TM_AveCharWidth		6
#define	TM_MaxCharWidth		7
#define	TM_Weight		8
#define	TM_Italic		9
#define	TM_Underlined		10
#define	TM_StruckOut		11
#define	TM_FirstChar		12
#define	TM_LastChar		13
#define	TM_DefaultChar		14
#define	TM_BreakChar		15
#define	TM_PitchAndFamily	16
#define	TM_CharSet		17
#define	TM_Overhang		18
#define	TM_DigitizedAspectX	19
#define	TM_DigitizedAspectY	20


// Array elements of aNewTextMetric[], which is used with EnumFontFamilies():
//
// (these correspond to the members of the Windows NEWTEXTMETRIC structure)

// (elements 1-20 are the same as TM_*, above)

#define	NTM_Flags		21
#define	NTM_SizeEM		22
#define	NTM_CellHeight		23
#define	NTM_AvgWidth		24


// TM_Weight values:
#include "font.ch"			// especially the FW_* values

// TM_PitchAndFamily values:
#define TMPF_FIXED_PITCH	1
#define TMPF_VECTOR		2
#define TMPF_DEVICE		8
// Win 3.1:
#define TMPF_TRUETYPE		4
// end of Win 3.1

// TM_CharSet values:
//	See font.ch *_CHARSET values

// NTM_Flags field values:
#define NTM_REGULAR	64
#define NTM_BOLD	32
#define NTM_ITALIC	1


#endif	// C4W_TEXTMETR_CH
