//	unwindow.h - can use with C to rename Windows API functions
//
//	Written by:	John M. Skelton, Sep-92.
//	Modified by:	John M. Skelton, Oct-93.
//
//	Copyright (C) 1992,1993 Skelton Software, Kendal Cottage, Hillam, LS25 5HP, UK.
//	All Rights Reserved.
//
//	To use:
//		#include "unwindow.h"
//		#include <windows.h>
//		#include <commdlg.h>	// if wanted, also dde.h, and so on
//		// we have to get NULL and WORD "right" (for Windows)
//		#undef	NULL		// ready for extend.h/.api
//		#include "extend.h"	// or .api
//		#define	CLIPNULL 0L	// Clipper's value for NULL
//		#undef	NULL		// get rid of Clipper's value
//		#define	NULL	0	// use the Windows value
//		#define	CLIPWORD 128	// Clipper's value for WORD
//		#undef	WORD		// make the Windows typedef visible
//
//	Remember to compile with appropriate C compiler options for
//	linking with a large-model program, and no C stack checking.

#define	AbortDoc	_AbortDoc
#define	AddAtom		_AddAtom
#define	AnsiLower	_AnsiLower
#define	AnsiNext	_AnsiNext
#define	AnsiPrev	_AnsiPrev
#define	AnsiToOem	_AnsiToOem
#define	AnsiUpper	_AnsiUpper
#define	AnyPopup	_AnyPopup
#define	AppendMenu	_AppendMenu
#define	Arc		_Arc
#define	BeginPaint	_BeginPaint
#define	BitBlt		_BitBlt
#define	Catch		_Catch
#define	ChangeMenu	_ChangeMenu
#define	ChooseFont	_ChooseFont
#define	Chord		_Chord
#define	ClipCursor	_ClipCursor
#define	CloseComm	_CloseComm
#define	CloseSound	_CloseSound
#define	CombineRgn	_CombineRgn
#define	CopyCursor	_CopyCursor
#define	CopyIcon	_CopyIcon
#define	CopyRect	_CopyRect
#define	CreateDC	_CreateDC
#define	CreateFont	_CreateFont
#define	CreateIC	_CreateIC
#define	CreateIcon	_CreateIcon
#define	CreateMenu	_CreateMenu
#define	CreatePen	_CreatePen
#define	DebugBreak	_DebugBreak
#define	DefDlgProc	_DefDlgProc
#define	DeleteAtom	_DeleteAtom
#define	DeleteDC	_DeleteDC
#define	DeleteMenu	_DeleteMenu
#define	DialogBox	_DialogBox
#define	DlgDirList	_DlgDirList
#define	DPtoLP		_DPtoLP
#define	DragFinish	_DragFinish
#define	DrawIcon	_DrawIcon
#define	DrawText	_DrawText
#define	Ellipse		_Ellipse
#define	EndDialog	_EndDialog
#define	EndDoc		_EndDoc
#define	EndPage		_EndPage
#define	EndPaint	_EndPaint
#define	EnumFonts	_EnumFonts
#define	EnumFonts	_EnumFonts
#define	EnumProps	_EnumProps
#define	EqualRect	_EqualRect
#define	EqualRgn	_EqualRgn
#define	Escape		_Escape
#define	ExtTextOut	_ExtTextOut
#define	FatalExit	_FatalExit
#define	FillRect	_FillRect
#define	FillRgn		_FillRgn
#define	FindAtom	_FindAtom
#define	FindText	_FindText
#define	FindWindow	_FindWindow
#define	FloodFill	_FloodFill
#define	FlushComm	_FlushComm
#define	FrameRect	_FrameRect
#define	FrameRgn	_FrameRgn
#define	FreeModule	_FreeModule
#define	GetBkColor	_GetBkColor
#define	GetBkMode	_GetBkMode
#define	GetCapture	_GetCapture
#define	GetClipBox	_GetClipBox
#define	GetCursor	_GetCursor	// Win 3.1
#define	GetDC		_GetDC
#define	GetDCEx		_GetDCEx
#define	GetDCOrg	_GetDCOrg
#define	GetDIBits	_GetDIBits
#define	GetDlgItem	_GetDlgItem
#define	GetFocus	_GetFocus
#define	GetMapMode	_GetMapMode
#define	GetMenu		_GetMenu
#define	GetMessage	_GetMessage
#define	GetObject	_GetObject
#define	GetParent	_GetParent
#define	GetPixel	_GetPixel
#define	GetProp		_GetProp
#define	GetRgnBox	_GetRgnBox
#define	GetROP2		_GetROP2
#define	GetSubMenu	_GetSubMenu
#define	GetVersion	_GetVersion
#define	GetWindow	_GetWindow
#define	GlobalFix	_GlobalFix
#define	GlobalFree	_GlobalFree
#define	GlobalLock	_GlobalLock
#define	GlobalLock	_GlobalLock
#define	GlobalSize	_GlobalSize
#define	GlobalWire	_GlobalWire
#define	GlobalWire	_GlobalWire
#define	GrayString	_GrayString
#define	HideCaret	_HideCaret
#define	hmemcpy		_hmemcpy
#define	InsertMenu	_InsertMenu
#define	InvertRect	_InvertRect
#define	InvertRgn	_InvertRgn
#define	IsChild		_IsChild
#define	IsIconic	_IsIconic
#define	IsMenu		_IsMenu		// Win 3.1
#define	IsTask		_IsTask
#define	IsWindow	_IsWindow
#define	IsZoomed	_IsZoomed
#define	KillTimer	_KillTimer
#define	LineDDA		_LineDDA
#define	LineTo		_LineTo
#define	LoadBitmap	_LoadBitmap
#define	LoadCursor	_LoadCursor
#define	LoadIcon	_LoadIcon
#define	LoadMenu	_LoadMenu
#define	LoadModule	_LoadModule
#define	LoadString	_LoadString
#define	LocalAlloc	_LocalAlloc
#define	LocalFlags	_LocalFlags
#define	LocalFree	_LocalFree
#define	LocalInit	_LocalInit
#define	LocalLock	_LocalLock
#define	LocalLock	_LocalLock
#define	LocalSize	_LocalSize
#define	LockInput	_LockInput
#define	LogError	_LogError
#define	LPtoDP		_LPtoDP
#define	lstrcat		_lstrcat
#define	lstrcmp		_lstrcmp
#define	lstrcmpi	_lstrcmpi
#define	lstrcpy		_lstrcpy
#define	lstrcpyn	_lstrcpyn
#define	lstrlen		_lstrlen
#define	MessageBox	_MessageBox
#define	ModifyMenu	_ModifyMenu
#define	MoveTo		_MoveTo
#define	MoveToEx	_MoveToEx
#define	MoveWindow	_MoveWindow
#define	MulDiv		_MulDiv
#define	OemKeyScan	_OemKeyScan
#define	OemToAnsi	_OemToAnsi
#define	OffsetRect	_OffsetRect
#define	OffsetRgn	_OffsetRgn
#define	OpenComm	_OpenComm
#define	OpenDriver	_OpenDriver
#define	OpenFile	_OpenFile
#define	OpenIcon	_OpenIcon
#define	OpenSound	_OpenSound
#define	PaintRgn	_PaintRgn
#define	PatBlt		_PatBlt
#define	Pie		_Pie
#define	Polygon		_Polygon
#define	Polyline	_Polyline
#define	PrintDlg	_PrintDlg
#define	ProfClear	_ProfClear
#define	ProfFinish	_ProfFinish
#define	ProfFlush	_ProfFlush
#define	ProfInsChk	_ProfInsChk
#define	ProfSetup	_ProfSetup
#define	ProfStart	_ProfStart
#define	ProfStop	_ProfStop
#define	PtInRect	_PtInRect
#define	PtInRegion	_PtInRegion
#define	PtVisible	_PtVisible
#define	QueryAbort	_QueryAbort
#define	ReadComm	_ReadComm
#define	Rectangle	_Rectangle
#define	RegEnumKey	_RegEnumKey
#define	RegOpenKey	_RegOpenKey
#define	ReleaseDC	_ReleaseDC
#define	RemoveMenu	_RemoveMenu
#define	RemoveProp	_RemoveProp
#define	RestoreDC	_RestoreDC
#define	RoundRect	_RoundRect
#define	SaveDC		_SaveDC
#define	ScrollDC	_ScrollDC
#define	SetBkColor	_SetBkColor
#define	SetBkMode	_SetBkMode
#define	SetCapture	_SetCapture
#define	SetCursor	_SetCursor
#define	SetDIBits	_SetDIBits
#define	SetFocus	_SetFocus
#define	SetMapMode	_SetMapMode
#define	SetMenu		_SetMenu
#define	SetParent	_SetParent
#define	SetPixel	_SetPixel
#define	SetProp		_SetProp
#define	SetRect		_SetRect
#define	SetRectRgn	_SetRectRgn
#define	SetROP2		_SetROP2
#define	SetTimer	_SetTimer
#define	ShowCaret	_ShowCaret
#define	ShowCursor	_ShowCursor
#define	ShowWindow	_ShowWindow
#define	SpoolFile	_SpoolFile
#define	StartDoc	_StartDoc
#define	StartPage	_StartPage
#define	StartSound	_StartSound
#define	StopSound	_StopSound
#define	StretchBlt	_StretchBlt
#define	TextOut		_TextOut
#define	Throw		_Throw
#define	ToAscii		_ToAscii
#define	UnionRect	_UnionRect
#define	VkKeyScan	_VkKeyScan
#define	WinExec		_WinExec
#define	WinHelp		_WinHelp
#define	WinMain		_WinMain
#define	WriteComm	_WriteComm
#define	wsprintf	_wsprintf
#define	wvsprintf	_wvsprintf
#define	Yield		_Yield
#define	_hread		__hread
#define	_hwrite		__hwrite
#define	_lclose		__lclose
#define	_lcreat		__lcreat
#define	_llseek		__llseek
#define	_lopen		__lopen
#define	_lread		__lread
#define	_lwrite		__lwrite
