//	AppMain.prg - default main event loop
//
//	Written by:	John M. Skelton,  Jun-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.

#include "windows.ch"
#include "setemode.ch"

static	hCtl3d
static	hBWCC


function C4W_AppInit(hApp, lCtl3d, lBWCC)
if lCtl3d
	Ctl3d(.T.)
endif
if lBWCC
	BWCC(.T.)
endif

set confirm on
set scoreboard off
SetColor("n/w,+w/n,+w,+w,+w/n")

/*
 *  The C4W_AutoClose() function allows us to make the user confirm their
 *  decision to quit the app, even if they try to close the window
 *  with ALT-F4 (or via the System menu).  It will cause the EVENT_CLOSE
 *  event to be generated, which we can then react to (see below)
 */
C4W_AutoClose(.F.)       // don't automatically close windows

/*
 *  Use the following if you want Windows to have any idle time.
 *  Leaving this out may disable screen savers and/or power
 *  management features, and may result in 100% CPU utilisation.
 *  In practice, you want this line of code unless you've got a
 *  special reason of your own to leave it out.
 */
C4W_UsePeekMessage(.F.)  // not PeekMessage() - just wait using GetMessage()

// suppress DOS errors & LoadLibrary() errors
SetErrorMode(SEM_FAILCRITICALERRORS + SEM_NOOPENFILEERRORBOX)

SetHandleCount(50)	// you can use more; Windows default is only 20
return nil


function C4W_AppMain(hApp, hWnd, bClose, bExit)
local	nEvent, hCurrWnd, hInst := _GetInstance()

HideCaret(hWnd)
ShowWindow(hWnd, _GetnCmdShow())
UpdateWindow(hWnd)

do while .T.
   do while (nEvent := ChkEvent()) == EVENT_NONE
   enddo

   HandleEvent(nEvent)

   do case
   case nEvent == EVENT_CLOSE
      hCurrWnd := _LasthWnd()
      if bClose != nil
         eval(bClose, hCurrWnd, hWnd)	// user block to handle it
      elseif hCurrWnd == hWnd
         if MessageBox( , "Really want to exit ?", "Clip-4-Win App", ;
                       MB_YESNO) == IDYES
            PostQuitMessage(0)
         endif
      else
         DestroyWindow(hCurrWnd)
         SetFocus(hWnd)
      endif

   case nEvent == EVENT_QUIT
      Ctl3d(.F.)			// make sure it's off
      BWCC(.F.)

      if IsWindow(hWnd)
         DestroyWindow(hWnd)
      endif

      if bExit == nil
         exit
      else
         eval(bExit, hWnd)		// user block to handle it
      endif
   endcase
enddo

return nil


function BWCC(lOn)
if lOn == nil
	// will return current on/off status
elseif lOn .and. hBWCC == nil
	if (hBWCC := LoadLibrary("BWCC.dll")) < 32
		MessageBox( , "Unable to find BWCC.DLL", "Error", MB_ICONSTOP)
		hBWCC := nil
	endif
elseif !lOn .and. hBWCC != nil
	FreeLibrary(hBWCC)
	hBWCC := nil
endif
return hBWCC != nil


function Ctl3d(lOn)
local	hInst := _GetInstance()

if lOn == nil
	// will return current on/off status
elseif lOn .and. hCtl3d == nil
	hCtl3d := LoadLibrary("ctl3d.dll")
	if hCtl3d == nil .or. hCtl3d < 32
		MessageBox( , "Unable to find CTL3D.DLL", "Error", MB_ICONSTOP)
		hCtl3d := nil
	else
		CallDLL(GetProcAddress(hCtl3d, "Ctl3dRegister", "P",	;
				       "void", "int"), hInst)
		CallDLL(GetProcAddress(hCtl3d, "Ctl3dAutoSubclass", "P",;
				       "void", "int"), hInst)
	endif
elseif !lOn .and. hCtl3d != nil
	CallDLL(GetProcAddress(hCtl3d, "Ctl3dUnregister", "P", "void", "int"),;
		hInst)
	FreeLibrary(hCtl3d)
	hCtl3d := nil
endif
return hCtl3d != nil


function C4W_HndlMsg(hWnd, abAction, aMsg)
local	nProc

if len(aMsg) == 0
	return nil
endif

nProc =									;
    SubClassWindow(hWnd,						;
		   {|hWnd, nMsg, nwParam, nlParam, i, nRet|		;
		    iif((i := ascan(aMsg, nMsg)) == 0			;
		        .or. (nRet := eval(abAction[i],			;
		                           hWnd, nMsg,			;
		                           nwParam, nlParam)) == nil,	;
		        CallWindowProc(nProc, hWnd, nMsg, nwParam, nlParam), ;
		        nRet)},						;
		   aMsg)
return nProc


exit procedure C4W_AMExit()
BWCC(.F.)
Ctl3d(.F.)
return
