////////////////////////////
//
//	Clip-4-Win button demo
//
//	Copyright (C) 1992 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//
//	Compile:	button /n /w
//	Link:		/se:600 button winsetup,,,,clip4win.def
//
////////////////////////////


#include "windows.ch"


// these need to be different so we know which button was selected
#define	BTN1	1
#define	BTN2	2

#define	nstr(i)	 alltrim(str(i))


static	hWnd, hInst, hPrevInst, nCmdShow
static	cAppName := "Clip-4-Win"


function main()
local	hDefPushButton, hPushButton
local	ev, nButton


hWnd = WinSetup(cAppName, "Clip-4-Win button demo")
hInst = _GetInstance()


hPushButton = CreateWindow("button",		;	// button class name
			      "&PushButton",	;	// title text
			      WS_CHILD		;	// child window
			      + WS_VISIBLE	;	// ... that can be seen
			      + WS_TABSTOP	;	// ... allow Tab/backtab
			      + WS_GROUP	;	// ... start of group (for left/right)
			      + BS_PUSHBUTTON,	;	// ... a push button
			      100, 150,		;	// x,y position
			      150, 20,		;	// width, height
			      hWnd,		;	// parent window
			      BTN2,		;	// unique child id
			      hInst)			// parent's instance

hDefPushButton = CreateWindow("button",		;	// button class name
			      "&DefPushButton",	;	// title text
			      WS_CHILD		;	// child window
			      + WS_VISIBLE	;	// ... that can be seen
			      + WS_TABSTOP	;	// ... allow Tab/backtab
;// don't start a new group   + WS_GROUP	;	// ... start of group (for left/right)
			      + BS_DEFPUSHBUTTON, ;	// ... default button
			      350, 150,		;	// x,y position
			      150, 20,		;	// width, height
			      hWnd,		;	// parent window
			      BTN1,		;	// unique child id
			      hInst)			// parent's instance

SetFocus(hDefPushButton)

do while .t.
	if empty(hDefPushButton) .and. empty(hPushButton)
		MessageBox( , "Press ENTER to exit", "All buttons pressed", MB_OK)
		quit
	endif

	// show how to support dialog-like behaviour in the main window
	do while (ev := ChkEvent({hWnd})) == EVENT_NONE
	enddo

	do case
	case ev == EVENT_CONTROL
		nButton = _lastwParam()
		MessageBox( , "Button number: " + nstr(nButton), "Info", MB_OK)
		if nButton == BTN1
			DestroyWindow(hDefPushButton)
			hDefPushButton = nil
			if !empty(hPushButton)
				SetFocus(hPushButton)
			endif
		endif
		if nButton == BTN2
			DestroyWindow(hPushButton)
			hPushButton = nil
			if !empty(hDefPushButton)
				SetFocus(hDefPushButton)
			endif
		endif
	endcase
enddo

return 0


