////////////////////////////
//
//	Clip-4-Win sample source
//
//	Copyright (C) 1992 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	The Clipboard is shown here.
//
////////////////////////////

#define	WIN_WANT_CLIPBOARD
#include "windows.ch"


static	hWnd, hInst, hPrevInst, nCmdShow
static	cAppName := "Clip-4-Win"
static	cTitle := "Clip-4-Win Clipboard Demo"	// caption for title bar
static	cText := ""


function main()
local	ev, hDC, aRect

hWnd = WinSetup(cAppName, cTitle)
DoMenu(hWnd)
HideCaret(hWnd)

do while .t.
	do while (ev := ChkEvent()) == EVENT_NONE
	enddo
	do case
	case ev == EVENT_REDRAW
		hDC = GetDC(hWnd)
		DrawText(hDC, cText)
		ReleaseDC(hWnd, hDC)
	endcase
enddo

return 0


procedure DoPrint()
local	hPrintDC, hCursor, hOldCursor

// display printer dialog box, so the user can choose the settings
hPrintDC = GetPrintDC()
if empty(hPrintDC)
	// cancelled by the user
	return
endif

hCursor = LoadCursor( , IDC_WAIT)
hOldCursor = SetCursor(hCursor)

StartDoc(hPrintDC, "ClipboardOutput")
StartPage(hPrintDC)

DrawText(hPrintDC, cText)

EndPage(hPrintDC)
EndDoc(hPrintDC)

DeleteDC(hPrintDC)

SetCursor(hOldCursor)

return


procedure DoExit()
quit
return


procedure DoCut()
	if OpenClipboard(hWnd)
		EmptyClipboard()
		SetClipboardData(CF_TEXT, cText)
		cText = ""
		CloseClipboard()
		InvalidateRect(hWnd)
	else
		MessageBox( , "Clipboard not available", "Info", MB_OK)
	endif
return


procedure DoPaste()
	if OpenClipboard(hWnd)
		cText = GetClipboardData(CF_TEXT)
		CloseClipboard()
		InvalidateRect(hWnd)
	else
		MessageBox( , "Clipboard not available", "Info", MB_OK)
	endif
return


procedure DoAbout()
MessageBox( , "Try Edit...Cut/Paste", "About", MB_OK)
return


procedure DoMenu(hWnd)
local	hMenu, hPopupMenu

if (hMenu := GetMenu(hWnd)) != nil
	DestroyMenu(hMenu)
endif
// do new one (forget old value)
hMenu = CreateMenu()
hPopupMenu = CreatePopupMenu()
AppendMenu(hMenu, "file", MF_ENABLED + MF_POPUP, "&File", hPopupMenu)
AppendMenu(hPopupMenu, "new",    MF_GRAYED + MF_STRING, "&New", {|| qout("new")})
AppendMenu(hPopupMenu, "open",   MF_GRAYED + MF_STRING, "&Open", {|| qout("open")})
AppendMenu(hPopupMenu, "save",   MF_GRAYED + MF_STRING, "&Save", {|| qout("save")})
AppendMenu(hPopupMenu, "saveas", MF_GRAYED + MF_STRING, "Save &As", {|| qout("save as")})
AppendMenu(hPopupMenu, "", MF_SEPARATOR)
AppendMenu(hPopupMenu, "print",  MF_ENABLED + MF_STRING, "&Print", {|| DoPrint()})
AppendMenu(hPopupMenu, "", MF_SEPARATOR)
AppendMenu(hPopupMenu, "exit",   MF_ENABLED + MF_STRING, "E&xit", {|| DoExit()})
hPopupMenu = CreatePopupMenu()
AppendMenu(hMenu, "edit", MF_ENABLED + MF_POPUP, "&Edit", hPopupMenu)
AppendMenu(hPopupMenu, "cut",    MF_ENABLED + MF_STRING, "Cu&t", {|| DoCut()})
AppendMenu(hPopupMenu, "paste",  MF_ENABLED + MF_STRING, "&Paste", {|| DoPaste()})
hPopupMenu = CreatePopupMenu()
AppendMenu(hMenu, "help", MF_ENABLED + MF_POPUP, "&Help", hPopupMenu)
AppendMenu(hPopupMenu, "about",  MF_ENABLED + MF_STRING, "&About", {|| DoAbout()})
SetMenu(hWnd, hMenu)
return


function nstr(n)
return alltrim(str(n)) + " "


