////////////////////////////
//
//	Clip-4-Win program to write out a font array (see FONT.CH)
//
//	Written by:	John M. Skelton,  Jul-95.
//
//	Copyright (C) 1995 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.
//
//	Compile and link:  c4wbuild fontarr
//
////////////////////////////

#define	WIN_WANT_ALL
#include "windows.ch"
#include "font.ch"
#define	NO_C4WCLASS
#include "commands.ch"

#define	CRLF	chr(13) + chr(10)


function main()
local	oApp, oWnd

CREATE APPLICATION oApp  WINDOW oWnd  TITLE "Clip-4-Win - Write Font Array" ;
	ON INIT DoIt(oWnd)

return 0


static function DoIt(hWnd)
DoFont(hWnd)
quit
return nil


static function DoFont(hWnd)
local	aFont := array(14), nColour, cFile, cStr

if (aFont := ChooseFont(aFont, , , @nColour)) == nil
	return nil
endif

if (cFile := GetSaveFileName(hWnd, "*.prg", "Specify PRG to write")) == nil
	return nil
endif

cStr = "/*"						+ CRLF		;
     + " *  NOTE: See INCLUDE\FONT.CH for the useful CREATE FONT" + CRLF;
     + " *        command.  The optional DC clause scales the font" + CRLF;
     + " *        according to the resolution of the device."	+ CRLF	;
     + " */"						+ CRLF		;
     + "local	aFont := " + AsString(aFont)		+ CRLF		;
     + "local	nColour := " + AsString(nColour)	+ CRLF		;
     + "local	hDC, hFont, hOldFont"			+ CRLF		;
     +							  CRLF		;
     + "// YOUR CODE HERE!!"				+ CRLF		;
     + "//"						+ CRLF		;
     + "// Don't forget:"				+ CRLF		;
     + "//      match CreateFont() and DeleteObject()"	+ CRLF		;
     + "//      match SelectObject() with SelectObject()" + CRLF	;
     + "//            (to re-select the original GDI object)" + CRLF	;
     + "//      match GetDC() and ReleaseDC()"		+ CRLF		;
     + "//      match GetPrintDC() and DeleteDC()"	+ CRLF		;
     + "//      match PrintDlg() and DeleteDC()"	+ CRLF		;
     + "//"						+ CRLF		;
     + "// E.g."					+ CRLF		;
     + "//      hFont := CreateFont(aFont)"		+ CRLF		;
     + "//      hDC   := GetDC(hWnd)"			+ CRLF		;
     + "//      hOldFont := SelectObject(hDC, hFont)"	+ CRLF		;
     + "//"						+ CRLF		;
     + "//      ... output: DrawText(), MoveTo(), LineTo() etc." + CRLF	;
     + "//"						+ CRLF		;
     + "//      SelectObject(hDC, hOldFont)"		+ CRLF		;
     + "//      ReleaseDC(hWnd, hDC)"			+ CRLF		;
     + "//      DeleteObject(hFont)"			+ CRLF		;
     +							  CRLF

memowrit(cFile, cStr)

return nil


static function AsString(x)
local	v := valtype(x), i, c

do case
case v == "C"
	return '"' + x + '"'
case v == "N"
	return ltrim(str(x))
case v == "L"
	if x
		return ".T."
	else
		return ".F."
	endif
case v == "D"
	return dtoc(x)
case v == "U"
	return "NIL"
case v == "A"
	for i = 1 to len(x)
		c = iif(i == 1, "{ ", c + ", ")
		c += AsString(x[i])
	next i
	return c + " }"
case v == "O"
	return "<Object " + x:classname() + ">"
case v == "B"
	return "<Block>"
otherwise
	return ""
end case

return x

