////////////////////////////
//
//	Adapted from a Clip-4-Win WODBC sample for Terry Wysocki
//
//	This one largely avoids using the *nice* Application Classes.
//
//	Copyright (C) 1995 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Compile and link:	rmake odbctiny
//
////////////////////////////

/*
"When I ran your program, a dialog came up that asked me for my data source
name, whereby I selected TRW, which I had pre-defined in the Control Panel ODBC
section.  How can I tell the program that data source name without the dialog?"

The cDSN param to WODBC:Init().  You have to get the name exactly right.

"What purpose is the MyWindow Class? Is it necessary for ODBC access or was it
in your example below for purposes of the blistbox?"

You wanted a non-OO sample, so it's to provide a fake OO framework.
*/

#define	WIN_WANT_ALL
#include "windows.ch"
#include "topclass.ch"
#define	NO_C4WCLASS
#include "commands.ch"
#include "dll.ch"


function main()
local	oApp, oWnd
CREATE APPLICATION oApp  WINDOW oWnd  TITLE "Clip-4-Win ODBC Demo" ;
	ON INIT MenuSetup(oWnd)
return nil


static Function TRWread(hWnd) // processes the selected table
   static oDummy
   local oTable
   local n
   if oDummy==nil
      oDummy := MyWindow{hWnd}
   endif
   oTable= WODBC{oDummy, "select * from usertable", "Workplace Manager"}
   ?'Opened Workplace Manager '
   oTable:GoTop()                       //dbGoTop()
   do while !oTable:Eof                 //eof()
      ?"Recno:",str(oTable:Recno,3),otable:fieldget(1),oTable:fieldget(2),oTable:fieldget(3)
      oTable:skip()                     //dbskip()
   enddo
   ?'Closing table...'
   oTable:Axit()  //JMS: Don't forget this!
   oDummy:Axit()
   ??'Closed'
return nil


static function MenuSetup(hWnd)
MENU IN hWnd
    POPUP "&File"
        MENUITEM "&Users"       ACTION TRWread(hWnd,'usertable')
        MENUITEM "&Requests"    ACTION TRWread(hWnd,'requesttable')
        MENUITEM SEPARATOR
        MENUITEM "E&xit"	ACTION PostQuitMessage()
    ENDPOPUP
ENDMENU
return nil


CLASS MyWindow
	EXPORT hWnd	AS INT
	EXPORT oWnd	AS OBJECT
	EXPORT App	AS OBJECT
	EXPORT hCtl3d	AS INT

	ACCESS Ctl3D			INLINE .t.
	ACCESS MDI			INLINE .f.
	ACCESS Modal			INLINE .t.

	METHOD Axit()			INLINE FreeLibrary(::hCtl3D)

	METHOD AddDialog(oDlg)		INLINE nil
	METHOD DelDialog(oDlg)		INLINE nil

	METHOD DestroyChild(oDlg)	INLINE nil

	METHOD Init(hWnd)						;
	       INLINE ::hWnd := hWnd,					;
	              ::App := self,					;
	              ::oWnd := self,					;
	              ::hCtl3D := LoadLibrary("ctl3d.dll"),		;
	              self
ENDCLASS
