////////////////////////////
//
//	Clip-4-Win (SDI) OO browser sample
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Compile and link:  rmake /dNORC brow
//
//	or:                rmake /dRC brow  (if you have a resource compiler)
//
////////////////////////////

#include "windows.ch"
#include "topclass.ch"
#include "commands.ch"

#define	StripPath(c)	iif("\" $ c, substr(c, rat("\", c) + 1), c)

procedure main()
local	oApp

oApp := BrowseApp{"Clip-4-Win Browser Sample"}
oApp:oWnd:MenuSetup()

oApp:Start()

oApp:Quit()

return


CLASS BrowseApp INHERIT WApp
	METHOD Create(cText)	INLINE ::oWnd := MainWindow{self, cText}
ENDCLASS


CLASS MainWindow INHERIT WSDIWindow
	METHOD Browse()

	METHOD Exit()							;
	       INLINE ::oApp:Quit()

	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              self

	METHOD MenuSetup()
ENDCLASS


METHOD Browse() CLASS MainWindow
local	cFile, oBrowse
local	cTitle,   ; // title for browse window
	cAlias      // name of database/alias

if (cFile := GetOpenFileName( , "*.dbf", "Select a database")) == nil
	return nil
endif

if select(StripPath(cFile)) == 0
	use (cFile) new shared
else
	select (select(StripPath(cFile)))
endif

// optional...
cTitle  := "Clip-4-Win Browse - " + alias()

oBrowse := WBrowseDef(self, cTitle, cAlias)

return self


METHOD MenuSetup() CLASS MainWindow

MENU IN self
    POPUP "&File"
	MENUITEM "&Browse..."	COMMAND Browse	HELP WHelp{"Browse a file..."}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    POPUP "&Help"
	MENUITEM "&About"					 	;
	         HELP WHelp{"About this application"}			;
	         ACTION MessageBox( , "Demo written by John Skelton",	;
		                   "About", MB_ICONEXCLAMATION + MB_OK)
    ENDPOPUP
ENDMENU

return self

