////////////////////////////
//
//	Clip-4-Win MDI OO browser sample
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Compile and link:  rmake /dNORC browmdi
//
//	or:                rmake /dRC browmdi  (if you have a resource compiler)
//
////////////////////////////

#include "windows.ch"
#include "topclass.ch"
#include "commands.ch"


procedure main()
local	oApp

oApp := BrowseApp{"Clip-4-Win MDI Browser Sample"}
oApp:oWnd:MenuSetup()

oApp:Start()

oApp:Quit()

return


CLASS BrowseApp INHERIT WMDIApp
	METHOD Create(cText)	INLINE ::oWnd := MainWindow{self, cText}
ENDCLASS


CLASS MainWindow INHERIT WMDIFrame
	METHOD Browse()

	METHOD Exit()		INLINE ::oApp:Quit()

	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              self

	METHOD MenuSetup()
ENDCLASS


METHOD Browse() CLASS MainWindow
local	cFile, oTable, oChild
local	cTitle,  ;  // title for browse window
	cAlias      // name of database/alias

if (cFile := GetOpenFileName( , "*.dbf", "Select a database")) == nil
	return nil
endif

oTable := WTable{self, cFile}
cAlias := oTable:Alias

// optional...
cTitle := "Clip-4-Win Browse - " + cAlias

oChild := ::CreateChild( , cTitle)
oChild:Client := WBrowseDef(oChild, , cAlias)

return self


METHOD MenuSetup() CLASS MainWindow

MENU IN self
    POPUP "&File"
	MENUITEM "&Browse..."	COMMAND Browse	HELP WHelp{"Browse a file..."}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    POPUP   "&Window"
	MENUITEM "&Cascade"	COMMAND Cascade				;
	         HELP WHelp{"Cascade child windows"}
	MENUITEM "&Tile"	COMMAND Tile				;
	         HELP WHelp{"Tile child windows"}
	MENUITEM "Arrange &Icons" COMMAND ArrangeIcons			;
	         HELP WHelp{"Arrange Icons of Minimised Children"}
	MENUITEM "Close &All"	COMMAND CloseAll			;
	         HELP WHelp{"Close all child windows"}
    ENDPOPUP
    POPUP "&Help"
	MENUITEM "&About"					 	;
	         HELP WHelp{"About this application"}			;
	         ACTION MessageBox( , "Demo written by John Skelton",	;
		                   "About", MB_ICONEXCLAMATION + MB_OK)
    ENDPOPUP
ENDMENU

return self

