/////////////////////////
//
//	caret.prg - OO Demo of CA-RET Report Engine
//
//	From an original by Hugh Lokey: thanks Hugh!  (See source\contrib\caret.zip)
//
//	Modified by:	John M. Skelton, Apr-95.
//
//	Copyright (C) 1993-1995 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
/////////////////////////

#define	WIN_WANT_CLIPBOARD
#include "windows.ch"
#include "topclass.ch"
#include "commands.ch"


function main()
local	oApp, oWnd

CREATE APPLICATION oApp  CLASS MyApp					;
    WINDOW oWnd								;
    TITLE "Clip-4-Win Makes Windows Apps E-A-S-Y!"			;
    ON INIT oWnd:MenuSetup()

return nil


CLASS MyApp INHERIT WApp
    METHOD Create(cText)    INLINE ::oWnd := MyWindow{self, cText, , .f.}
ENDCLASS


CLASS MyWindow INHERIT WSDIWindow
    PROTECT oDDE AS OBJECT
    METHOD Create(cText)						;
        INLINE super:Create(cText),					;
               ::StatusBar := WStatusBar{self},				;
               self
    METHOD MenuSetup()
    METHOD PrintIt()
    METHOD StartCaret()
    METHOD StartDDE()							;
        INLINE ::oDDE := WDDEClient{self, "CARETRUN", "System"}
    METHOD StopDDE()							;
        INLINE iif(::oDDE == nil, , ::oDDE:Stop()),			;
               ::oDDE := nil
ENDCLASS


METHOD MenuSetup() CLASS MyWindow

MENU IN self
    POPUP "&File"
        MENUITEM "&Run CA-RET"            COMMAND StartCaret
        MENUITEM "&Open DDE Connection"   COMMAND StartDDE
        MENUITEM "&Test DDE Connection"   COMMAND PrintIt
        MENUITEM "&Close DDE Connection"  COMMAND StopDDE
        MENUITEM SEPARATOR
        MENUITEM "E&xit"  ACTION ::App:Quit()  HELP WHelp{"Exit this application"}
    ENDPOPUP
    POPUP "&Help"
        MENUITEM "&About"  ACTION MessageBox( , "Easy!", "Clip-4-Win App") ;
            HELP WHelp{"About this application"}
    ENDPOPUP
ENDMENU

return nil


// StartCaret() - Used to start the CA-RET runtime module.  Needed
// in case the user has closed the application with the last preview.
// If there is a problem starting the runtime module we just QUIT since
// we could not do any reports without it!

METHOD StartCaret() CLASS MyWindow
       LOCAL cOldMsg := ::StatusBar:Text

       ::StatusBar:Text := "Loading Report Engine..."
       IF WinExec("CARETRUN", SW_SHOWMINNOACTIVE) < 32
          ::MsgBox("UNABLE TO START CARETRUN!")
          ::App:Quit()
       ENDIF
       ::StatusBar:Text := cOldMsg
RETURN(NIL)

// This is my generic report printer/previewer.  It is called with
// the name of the report file USERLIST.RET, DISCLIST.RET, etc.
// You will need to adjust the placement of the dialogbox to suit
// your application. To automatically print a series of reports
// you pass the report file names as an array.  For a single report
// the user automatically gets prompted to either send the report
// to the screen (preview), or to the printer. Please note that
// from within the CA-RET runtime module the user can print a
// report after previewing it.  For a series of reports the user
// does NOT have a choice - all reports are automatically sent
// to the printer.  You might want to consider calling the Printer
// setup dialog box first so the user can set any printer options.
// I have not included it at this point since I find it rather
// annoying to have the damn thing pop up every time I want to
// print something in a Windows app! I do have it on the File
// Menu of my app so it is always an option for the user.

// If you use this code then you will need to change the Set.Title()
// command to use the title YOU want displayed in the CA-RET runtime
// window!!

METHOD PrintIt(acReport) CLASS MyWindow
       LOCAL nCtr
       LOCAL oDlg
       LOCAL nSel
       LOCAL lPreview := .F.

       DEFAULT acReport TO "TEST.RET"

       IF ::oDDE == nil
          ::MsgBox("DDE Connection With CA-RET Not Open")
          RETURN NIL
       ENDIF

       IF VALTYPE(acReport) != 'A'
          CREATE DIALOG oDlg  TITLE "Print To?"  AT 70,63 SIZE 142,31	;
              STYLE DS_MODALFRAME+WS_POPUP+WS_CAPTION
          @ ID 1 Button TEXT "&Screen"  ACTION {|| oDlg:EndDialog(1)}  AT 17,12  SIZE 31,14  IN oDlg
          @ ID 2 Button TEXT "&Printer" ACTION {|| oDlg:EndDialog(2)}  AT 55,12  SIZE 31,14  IN oDlg
          @ ID 3 Button TEXT "&Cancel"  ACTION {|| oDlg:EndDialog(3)}  AT 93,12  SIZE 31,14  IN oDlg
          SHOW DIALOG oDlg RESULT nSel	// same as: nSel := oDlg:Create():Result
          IF nSel == 3
             RETURN(NIL)
          ENDIF
          IF nSel == 1
             lPreview := .T.
          ENDIF
       ENDIF

       ::oDDE:Advise("CARETEVENTS", CF_TEXT)
       ::oDDE:Execute('Set.Title(Report Engine)')
       ::oDDE:Execute("App.Maximize")
       IF VALTYPE(acReport) != 'A'
          ::oDDE:Execute('File.Open('+acReport+')',"Report.Opened")
          IF !lPreview
             ::oDDE:Execute("File.Print(0,0)","Report.Complete")
             ::oDDE:Execute("File.Exit","CARET.Close")
          ELSE
             ::oDDE:Execute("File.Preview","CARET.Close")
          ENDIF
       ELSE
          FOR nCtr := 1 TO LEN(acReport)
              ::oDDE:Execute("File.Open("+acReport[nCtr]+')','Report.Opened')
              ::oDDE:Execute("File.Print(0,0)",'Report.Complete')
              ::oDDE:Execute("File.Close",'View.Close')
          NEXT
          ::oDDE:Execute("File.Exit","CARET.Close")
       ENDIF
       SetFocus(::hWnd)
RETURN(NIL)

