//	IconDemo.prg - Icon Demo (OO)
//
//	Written by:	John M. Skelton,  Mar-95.
//
//	Copyright (C) 1995 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.

#define	WIN_WANT_ALL
#include "windows.ch"
#include "commands.ch"
#include "icondemo.ch"


function main()
local	oApp, oWnd

CREATE APPLICATION oApp  WINDOW oWnd  TITLE "Clip-4-Win Icon Demo"	;
	ON INIT (DemoDlg{oWnd, "IconDemoDlg"}, PostQuitMessage(0))

return 0


CLASS DemoDlg INHERIT WDialog
	PROTECT aIcons	AS ARRAY

	METHOD AddIcon()	// not Add() - it's already in WDialog!
	METHOD Hide()	INLINE aeval(::aIcons, {|oIcon| oIcon:Show(SW_HIDE)})
	METHOD Show()	INLINE aeval(::aIcons, {|oIcon| oIcon:Show(SW_SHOW)})

	METHOD OnInitDialog()
ENDCLASS


METHOD OnInitDialog() CLASS DemoDlg

::aIcons = array(1)
@ ID ID_MDIFRAME  ICON  OBJ ::aIcons[1]

@ ID ID_SHOW  BUTTON Show
@ ID ID_HIDE  BUTTON Hide
@ ID ID_ADD   BUTTON AddIcon

return super:OnInitDialog()


METHOD AddIcon() CLASS DemoDlg
local	aNames := {"MDIFRAME",  "MDICHILD",  "MDIDLG"}, i, a, oIcon

for i = 1 to len(aNames)
	if i > len(::aIcons)
		// not there - create it
		a = MapDialogRect(::hWnd, {10, 40, 13, 13})
		oIcon = WSSControl{self, , , CTL_DEFSTYLE + SS_ICON, .f.}
		oIcon:Create(aNames[i], , a[1] * i * 2, a[2], a[3], a[4])
		aadd(::aIcons, oIcon)
		exit
	endif
next i
return nil
