//	mdibars.prg - tool & status bars test program
//
//	Written by:	John M. Skelton,  Jun-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.

//#define	WIN_DEBUG

#define	WIN_WANT_RESOURCE
#include "windows.ch"
#include "topclass.ch"
#include "menu.ch"

#define	IDM_TOOLBAR	1001
#define	IDM_STATBAR	1002
#define	IDM_CTOOLBAR	1011
#define	IDM_CSTATBAR	1012


function main()
local	oApp := MyApp{"Clip-4-Win Sample MDI App"}

oApp:oWnd:MenuSetup()

oApp:Start()
oApp:Quit()

return 0


CLASS MyApp INHERIT WMDIApp
	PROTECT ahObj	AS ARRAY

	METHOD Create(cText)						;
	       INLINE ::ahObj := {},					;
	              ::oWnd := MyMDIWindow{self, cText}

	METHOD GetBmp(cnResID)						;
	       INLINE local	hBmp,					;
	              hBmp := LoadBitmap( , cnResID),			;
	              iif(empty(hBmp), , aadd(::ahObj, hBmp)),		;
	              hBmp

//	METHOD HelpAbout

	METHOD Quit							;
	       INLINE aeval(::ahObj, {|hGDIObj| DeleteObject(hGDIObj)}),;
	              super:Quit()

	METHOD Start							;
	       INLINE ::oWnd:Show(/*_GetnCmdShow()*/ SW_SHOWMAXIMIZED),	;
	              ::Exec()
ENDCLASS


CLASS MyMDIWindow INHERIT WMDIFrame
	METHOD Debug
	METHOD EditCopy			INLINE nil	// not used here
	METHOD EditCut			INLINE nil	// not used here
	METHOD EditPaste		INLINE nil	// not used here
	// EditFind, EditReplace, etc. are undefined so you can see what happens
	METHOD FileExit			INLINE ::oApp:Quit()
	METHOD FileNew
	METHOD FileOpen							;
	       INLINE ::HelpText := "Same as FileNew in this sample",	;
	              MessageBeep(),					;
	              ::FileNew()
	METHOD HelpAbout
	MESSAGE Init(oApp, cTitle)	METHOD MyInit
	METHOD MenuSetup
	METHOD NoChildren()						;
	       INLINE local	oMItem,					;
	              oMItem := ::oMenu:GetItem(IDM_CSTATBAR),		;
	              oMItem:Checked := .f.,				;
	              oMItem:Grayed  := .t.,				;
	              oMItem := ::oMenu:GetItem(IDM_CTOOLBAR),		;
	              oMItem:Checked := .f.,				;
	              oMItem:Grayed  := .t.

	METHOD OnChildNCDestroy(oChild, nAlive)				;
	       INLINE iif(nAlive == 0, ::NoChildren(), )
	METHOD OptCStatBar
	METHOD OptCToolbar
	METHOD OptStatBar
	METHOD OptToolbar
ENDCLASS


METHOD Debug CLASS MyMDIWindow
AltD()
DbgShow()
return nil


METHOD FileNew CLASS MyMDIWindow
return ::oClient:CreateChild(MyMDIChild{::oClient, , , .f.})


METHOD HelpAbout CLASS MyMDIWindow
MessageBox(0, "HelpAbout", "MyMDIWindow")
return nil


METHOD MyInit(oApp, cTitle) CLASS MyMDIWindow
local	aButtons, c := ""

// Here's how to see if a resource exists:
if FindResource( , "open1", RT_BITMAP) != 0
	aButtons :=							;
	{ {10, 3, 25, 22, oApp:GetBmp("open1"), "FileOpen", WHelp{"Open a file..."}},;
	  {38, 3, 25, 22, oApp:GetBmp("print1"), "FilePrint", WHelp{"Print..."}},;
;//	  {66, 3, 25, 22, oApp:GetBmp("browse1"), IDM_TOOLBAR, WHelp{"Toolbar Off"}},;
	  {66, 3, 25, 22, oApp:GetBmp("browse1"), "OptToolbar", WHelp{"Toolbar Off"}},;
	  {110, 3, 25, 22, oApp:GetBmp("exit1"), "FileExit", WHelp{"Exit"}},	;
	  {160, 3, 25, 22, oApp:GetBmp("help1"), "HelpAbout", WHelp{"About this program"}} }
elseif file(c + "open1.bmp") .or. file((c := "..\") + "open1.bmp")
	aButtons :=							;
	{ {10, 3, 25, 22, ReadDIB(c+"open1.bmp"), "FileOpen", WHelp{"Open a file..."}},;
	  {38, 3, 25, 22, ReadDIB(c+"print1.bmp"), "FilePrint", WHelp{"Print..."}},;
;//	  {66, 3, 25, 22, ReadDIB(c+"browse1.bmp"), IDM_TOOLBAR, WHelp{"Toolbar Off"}},;
	  {66, 3, 25, 22, ReadDIB(c+"browse1.bmp"), "OptToolbar", WHelp{"Toolbar Off"}},;
	  {110, 3, 25, 22, ReadDIB(c+"exit1.bmp"), "FileExit", WHelp{"Exit"}},	;
	  {160, 3, 25, 22, ReadDIB(c+"help1.bmp"), "HelpAbout", WHelp{"About this program"}} }
else
	::MsgBox("Can't find bitmaps!!")
endif

super:Init(oApp, cTitle)

::StatusBar = WStatusBar{self}
::ToolBar = WToolBar{self, , , aButtons}

return self


METHOD MenuSetup CLASS MyMDIWindow
    MENU IN self
	POPUP "&File"
	    MENUITEM "&New"		COMMAND FileNew			;
		HELP WHelp{"Create a new file"}
	    MENUITEM "&Open..."		COMMAND FileOpen   		;
		HELP WHelp{"Open a file..."}
	    MENUITEM "&Save"		COMMAND FileSave		;
		HELP WHelp{"Save to current file"}
	    MENUITEM "Save &As..."	COMMAND FileSaveAs		;
		HELP WHelp{"Save to another file..."}
	    MENUITEM SEPARATOR
	    MENUITEM "&Print..."	COMMAND FilePrint		;
		HELP WHelp{"Print to a file..."}
	    MENUITEM SEPARATOR
	    MENUITEM "E&xit"		COMMAND FileExit		;
		HELP WHelp{"Exit the application"}
	ENDPOPUP
	POPUP "&Edit"
	    MENUITEM "Cu&t"		COMMAND EditCut			;
		HELP WHelp{"Cut selected item to clipboard"}
	    MENUITEM "&Copy"		COMMAND EditCopy		;
		HELP WHelp{"Copy selected item to clipboard"}
	    MENUITEM "&Paste"		COMMAND EditPaste		;
		HELP WHelp{"Paste from clipboard"}
	    MENUITEM SEPARATOR
	    MENUITEM "&Find..."		COMMAND EditFind		;
		HELP WHelp{"Find text..."}
	    MENUITEM "&Replace..."	COMMAND EditReplace		;
		HELP WHelp{"Replace text..."}
	ENDPOPUP
	POPUP "&Options"
	    MENUITEM "Main &Toolbar"	 COMMAND OptToolbar	CHECKED	;
		HELP WHelp{"Enable/disable frame toolbar"}	ID IDM_TOOLBAR
	    MENUITEM "Child &Toolbar"	 COMMAND OptCToolbar	GRAYED	;
		HELP WHelp{"Enable/disable child toolbar"}	ID IDM_CTOOLBAR
	    MENUITEM "Main &Status Bar"	 COMMAND OptStatBar	CHECKED	;
		HELP WHelp{"Enable/disable frame status bar"}	ID IDM_STATBAR
	    MENUITEM "Child &Status Bar" COMMAND OptCStatBar	GRAYED	;
		HELP WHelp{"Enable/disable child status bar"}	ID IDM_CSTATBAR
	ENDPOPUP
	MENUITEM "&Debug"		COMMAND Debug			;
		HELP WHelp{"Break to the debugger"}
	MDIWINDOWPOPUP
	POPUP "&Help"
	    MENUITEM "&About"	COMMAND HelpAbout		;
		HELP WHelp{"About this application"}
	ENDPOPUP
    ENDMENU
return self


METHOD OptCStatBar CLASS MyMDIWindow
local	oMenuItem := ::oMenu:GetItem(IDM_CSTATBAR)
local	oBar := ::ActiveChild:StatusBar
if oBar != nil
	oBar:Visible = (oMenuItem:Checked := !oMenuItem:Checked)
endif
return nil


METHOD OptCToolbar CLASS MyMDIWindow
local	oMenuItem := ::oMenu:GetItem(IDM_CTOOLBAR)
local	oBar := ::ActiveChild:Toolbar
if oBar != nil
	oBar:Visible = (oMenuItem:Checked := !oMenuItem:Checked)
endif
return nil


METHOD OptStatBar CLASS MyMDIWindow
local	oMenuItem := ::oMenu:GetItem(IDM_STATBAR)

::oStatusBar:Visible = (oMenuItem:Checked := !oMenuItem:Checked)
return nil


METHOD OptToolbar CLASS MyMDIWindow
local	oMenuItem := ::oMenu:GetItem(IDM_TOOLBAR)
::oToolbar:Visible = iif(oMenuItem != nil,				;
			 (oMenuItem:Checked := !oMenuItem:Checked),	;
			 !::oToolbar:Visible)
return nil


CLASS MyMDIChild INHERIT WMDIChild
	MESSAGE Create(cTitle, nId, nX, nY, nW, nH, cParam)		;
	        METHOD ChildCreate
	METHOD FileExit		INLINE SendMessage(::hWnd, WM_CLOSE)
	ACCESS FrameMenu	INLINE ::oParent:oParent:FrameMenu
//	METHOD HandleMessage(m, w, l)					;
//	       INLINE DbgTrace("MyMDIChild", ::hWnd, DbgPadMsg(m), w, l),;
//	              super:HandleMessage(m, w, l)
	MESSAGE HelpAbout	METHOD ChildHelpAbout

	METHOD OnClose(nwParam, nlParam)				;
	       INLINE iif(MessageBox(::hWnd, "Save ?", "MDIChild",	;
	                             MB_ICONQUESTION + MB_YESNOCANCEL)	;
	                  == IDCANCEL, 0, nil)

	METHOD OnMDIActivate(lAct, hAct, hDeact)			;
	       INLINE iif(lAct, ::UpdateMenu(),	),			;
	              super:OnMDIActivate(lAct, hAct, hDeact)

	METHOD OptToolbar						;
	       INLINE ::oToolbar:Visible := !::oToolbar:Visible
	METHOD UpdateMenu()
ENDCLASS


METHOD ChildCreate(cTitle, nId, nX, nY, nW, nH, cParam) CLASS MyMDIChild
static	n := 0
local	aButtons, c := ""

// Here's how to see if a resource exists:
if FindResource( , "open1", RT_BITMAP) != 0
	aButtons :=							;
	{ {10, 3, 25, 22, ::App:GetBmp("open1"), "FileOpen", WHelp{"Open a file..."}},;
	  {38, 3, 25, 22, ::App:GetBmp("print1"), "FilePrint", WHelp{"Print..."}},;
;//	  {66, 3, 25, 22, ::App:GetBmp("browse1"), IDM_TOOLBAR, WHelp{"Toolbar Off"}},;
	  {66, 3, 25, 22, ::App:GetBmp("browse1"), "OptToolbar", WHelp{"Toolbar Off"}},;
	  {110, 3, 25, 22, ::App:GetBmp("exit1"), "FileExit", WHelp{"Exit"}},	;
	  {160, 3, 25, 22, ::App:GetBmp("help1"), "HelpAbout", WHelp{"About this program"}} }
elseif file(c + "open1.bmp") .or. file((c := "..\") + "open1.bmp")
	aButtons :=							;
	{ {10, 3, 25, 22, ReadDIB(c+"open1.bmp"), "FileOpen", WHelp{"Open a file..."}},;
;//	  {38, 3, 25, 22, ReadDIB(c+"print1.bmp"), IDM_STATBAR, WHelp{"Print..."}},;
	  {38, 3, 25, 22, ReadDIB(c+"print1.bmp"), "FilePrint", WHelp{"Print..."}},;
	  {66, 3, 25, 22, ReadDIB(c+"browse1.bmp"), "OptToolbar", WHelp{"Toolbar Off"}},;
	  {110, 3, 25, 22, ReadDIB(c+"exit1.bmp"), "FileExit", WHelp{"Exit"}},	;
	  {160, 3, 25, 22, ReadDIB(c+"help1.bmp"), "HelpAbout", WHelp{"About this program"}} }
else
	::MsgBox("Can't find bitmaps!!")
endif

super:Create(cTitle, nId, nX, nY, nW, nH, cParam)

if ++n % 3 == 0			// sometimes a status bar
	::StatusBar = WStatusBar{self}
endif
if n % 2 != 0			// sometimes a toolbar
	::ToolBar = WToolBar{self, , , aButtons}
endif

::UpdateMenu()
return self


METHOD ChildHelpAbout CLASS MyMDIChild
MessageBox(::hWnd, "ChildHelpAbout", "MyMDIChild")
return nil


METHOD UpdateMenu() CLASS MyMDIChild
local	oMItem

oMItem := ::FrameMenu:GetItem(IDM_CSTATBAR)
oMItem:Checked := iif(oMItem:Grayed := (::oStatusBar == nil),		;
		      .f., ::oStatusBar:Visible)

oMItem := ::FrameMenu:GetItem(IDM_CTOOLBAR)
oMItem:Checked := iif(oMItem:Grayed := (::oToolbar == nil),		;
		      .f., ::oToolbar:Visible)
return self
