//	MDIBitma.prg - an MDI bitmap viewer
//
//	Written by:	John M. Skelton,  Jun-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.
//

#include "windows.ch"
#include "topclass.ch"
#include "commands.ch"


procedure main()
local	oApp

oApp := BrowseApp{"Clip-4-Win MDI Bitmap Sample"}
oApp:oWnd:MenuSetup()

oApp:Start()

oApp:Quit()

return


CLASS BrowseApp INHERIT WMDIApp
	METHOD Create(cText)	INLINE ::oWnd := MainWindow{self, cText}
ENDCLASS


CLASS MainWindow INHERIT WMDIFrame
	METHOD Bmp()							;
	       INLINE local	cFile,					;
	              local	cDIB,					;
	              cFile := GetOpenFileName(::hWnd, "*.bmp",		;
	                                       "Select a bitmap"),	;
	              iif(cFile == nil .or. (cDIB := ReadDIB(cFile)) == nil, ,;
	                  ::CreateChild(Browser{::Client, cFile, cDIB, .f.})),;
	              0

	METHOD BmpStretch()						;
	       INLINE local	cFile,					;
	              local	cDIB,					;
	              cFile := GetOpenFileName(::hWnd, "*.bmp",		;
	                                       "Select a bitmap"),	;
	              iif(cFile == nil .or. (cDIB := ReadDIB(cFile)) == nil, ,;
	                  ::CreateChild(Browser{::Client, cFile, cDIB, .t.})),;
	              0

	METHOD Exit()			INLINE ::oApp:Quit()

	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              self

	METHOD MenuSetup()
ENDCLASS


CLASS Browser INHERIT WMDIChild

	PROTECT cDIB	// AS STRING OR ARRAY
	PROTECT cFile	AS STRING

	PROTECT lStretch AS LOGIC

	METHOD Close()			INLINE SendMessage(::hWnd, WM_CLOSE)
	METHOD Init(oParent, cFile, cDIB, lStretch)			;
	       INLINE ::cFile := cFile,					;
	              ::cDIB := cDIB,					;
	              ::lStretch := lStretch,				;
	              super:Init(oParent, "Clip-4-Win Bitmap - " + cFile)
	METHOD Paint()							;
	       INLINE local	a,					;
	              a := GetClientRect(::hWnd),			;
	              iif(::lStretch,					;
	                  StretchDIB(::hDC, 0, 0, a[3], a[4],		;
	                              , , , , , ::cDIB),		;
	                  ShowDIB(::hDC, ::cDIB)),			;
	              0
ENDCLASS


METHOD MenuSetup() CLASS MainWindow

MENU IN self
    POPUP "&File"
	MENUITEM "&Bitmap..."  COMMAND Bmp  HELP WHelp{"View a Bitmap..."}
	MENUITEM "&Stretch Bitmap..."  COMMAND BmpStretch  HELP WHelp{"Stretch a Bitmap..."}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    MDIWINDOWPOPUP	// provides Window Cascade, Tile, Arrange Icons, etc.
    POPUP "&Help"
	MENUITEM "&About"					 	;
	         HELP WHelp{"About this application"}			;
	         ACTION {|| MessageBox( , "Demo written by John Skelton", ;
		                       "About", MB_ICONEXCLAMATION + MB_OK) }
    ENDPOPUP
ENDMENU

return self

