////////////////////////////
//
//	Clip-4-Win MDI BListBox sample
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Compile and link:	c4wbuild mdiblist
//
////////////////////////////

#define	WIN_WANT_LBS
#include "windows.ch"
#include "commands.ch"


#define	CR		chr(13)

#define	IDD_BROWSE	101


function main()
local	oApp

oApp = BrowseApp{"Clip-4-Win BListBox Demo"}
oApp:oWnd:MenuSetup()

oApp:Start()

return nil


CLASS BrowseApp INHERIT WMDIApp
	METHOD Create(cText)	INLINE ::oWnd := BrowseWindow{self, cText}
ENDCLASS


CLASS BrowseWindow INHERIT WMDIFrame
	METHOD About()		INLINE ::MsgBox("Nothing interesting yet!")

	METHOD Browse()		INLINE BrowseDialog{self}
	METHOD BrowseRes()	INLINE BrowseDialog{self, "browse"}

	METHOD Exit()		INLINE ::oApp:Quit()

	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              self
	METHOD MenuSetup()
ENDCLASS


CLASS BrowseDialog INHERIT WDialog

	PROTECT oB	AS OBJECT // AS WBListBox

	PROTECT oTable	AS OBJECT // AS WTable

	METHOD Init(oParent, cnId_aDlg, lCreate)

	ACCESS WndStyle							;
	       INLINE DS_MODALFRAME + WS_POPUP + WS_CHILD + WS_VISIBLE	;
	              + WS_CAPTION
ENDCLASS


METHOD Init(oParent, cnId_aDlg, lCreate) CLASS BrowseDialog
local	nArea, cAlias
// Note: you can't use code blocks like
//	             {|| (::oTable:Area)->UserName}
// in aCols, unless you EXPORT oTable.
local	aCols :=							;
{									;
	{"UserName", {|| (nArea)->UserName} },				;
	{"UserID",   {|| (nArea)->UserID  } }				;
}

default lCreate to .t.

super:Init(oParent, cnId_aDlg, .f., .f.)

::oTable = WTable{self, "users.dbf"}
nArea    = ::oTable:Area
cAlias   = ::oTable:Alias

if cnId_aDlg == nil

	INIT DIALOG self						;
		Title "Browse In Dialog"  Style ::WndStyle  At 20,20  Size 250,200

	@ Id IDD_BROWSE  Obj ::oB  BListBox  Columns aCols   Alias cAlias ;
	                                                     At 10,10  Size 180,180
	@ Id IDCANCEL              Button    Title "&Cancel" At 200,10 Size 40,12
else
	@ Id IDD_BROWSE  Obj ::oB  BListBox  Columns aCols
//	@ Id IDCANCEL    Button		// defaults to this, add it if you like
endif

if lCreate
	::Create(cnId_aDlg)
endif

return self


METHOD MenuSetup() CLASS BrowseWindow

MENU IN self
    POPUP "&File"
	MENUITEM "&BListBox Browse"					;
		 COMMAND Browse   HELP WHelp{"A dynamic dialog using BListBox"}
	MENUITEM "BListBox Browse - &Resource"				;
		 COMMAND BrowseRes  HELP WHelp{"A resource dialog using BListBox"}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    MDIWINDOWPOPUP
    POPUP "&Help"
	MENUITEM "&About"	COMMAND About	HELP WHelp{"About this application"}
    ENDPOPUP
ENDMENU

return self

