//	MDIMenus.prg - Changing menus in an MDI application
//
//	Written by:	John M. Skelton,  Jun-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.
//
//	Note: To keep this example simple, it has all the classes in this
//	      one file, and uses very simple classes.  The idea is that you
//	      can see the important things all here, but it does mean that
//	      some use of MESSAGE ... METHOD was needed.

#include "windows.ch"
#include "topclass.ch"
#include "commands.ch"


procedure main()
local	oApp

oApp := MyApp{"Clip-4-Win MDI Menus Sample"}
oApp:oWnd:MenuSetup()

oApp:Start()

oApp:Quit()

return


CLASS MyApp INHERIT WMDIApp
	METHOD Create(cText)	INLINE ::oWnd := MainWindow{self, cText}
ENDCLASS


CLASS MainWindow INHERIT WMDIFrame
	METHOD Exit()							;
	       INLINE ::oApp:Quit()

	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              self

	METHOD MenuSetup()

	METHOD New1()							;
	       INLINE ::CreateChild(Child1{::Client, "MDI Child Type 1"})

	METHOD New2()							;
	       INLINE ::CreateChild(Child2{::Client, "MDI Child Type 2"})

	METHOD New3()							;
	       INLINE ::CreateChild(Child3{::Client, "MDI Child Type 3"})
ENDCLASS


METHOD MenuSetup() CLASS MainWindow

MENU IN self
    POPUP "&File"
	MENUITEM "New Child (type &1)"	COMMAND New1	HELP WHelp{"Child with menu type 1"}
	MENUITEM "New Child (type &2)"	COMMAND New2	HELP WHelp{"Child with menu type 2"}
	MENUITEM "New Child (type &3)"	COMMAND New3	HELP WHelp{"Child with menu type 3"}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    MDIWINDOWPOPUP	// provides Window Cascade, Tile, Arrange Icons, etc.
    POPUP "&Help"
	MENUITEM "&About"					 	;
	         HELP WHelp{"About this application"}			;
	         ACTION {|| DbgShow(), MessageBox( , "Demo written by John Skelton", ;
		                       "About", MB_ICONEXCLAMATION + MB_OK) }
    ENDPOPUP
ENDMENU

return self


CLASS Child1 INHERIT WMDIChild
	METHOD Close()			INLINE SendMessage(::hWnd, WM_CLOSE)
	METHOD Create(oParent, cTitle)					;
	       INLINE super:Create(oParent, cTitle):MenuSetup()
	MESSAGE MenuSetup()		METHOD Menu1()
ENDCLASS

METHOD Menu1() CLASS Child1

MENU IN self
    POPUP "&File"
	MENUITEM "New Child (type &1)"	COMMAND New1	HELP WHelp{"Child with menu type 1"}
	MENUITEM "New Child (type &2)"	COMMAND New2	HELP WHelp{"Child with menu type 2"}
	MENUITEM "New Child (type &3)"	COMMAND New3	HELP WHelp{"Child with menu type 3"}
	MENUITEM SEPARATOR
	MENUITEM "&Close"	COMMAND Close	HELP WHelp{"Close this window"}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    POPUP   "&Child 1 Menu"
	MENUITEM "&Your item"  ACTION {|| nil}  HELP WHelp{"Your menu item here..."}
    ENDPOPUP
    MDIWINDOWPOPUP	// provides Window Cascade, Tile, Arrange Icons, etc.
    POPUP "&Help"
	MENUITEM "&About"					 	;
	         HELP WHelp{"About this application"}			;
	         ACTION {|| DbgShow(), MessageBox( , "Demo written by John Skelton", ;
		                       "About", MB_ICONEXCLAMATION + MB_OK) }
    ENDPOPUP
ENDMENU

return self


CLASS Child2 INHERIT WMDIChild
	METHOD Close()			INLINE SendMessage(::hWnd, WM_CLOSE)
	METHOD Create(oParent, cTitle)					;
	       INLINE super:Create(oParent, cTitle):MenuSetup()
	MESSAGE MenuSetup()		METHOD Menu2()
ENDCLASS

METHOD Menu2() CLASS Child2

MENU IN self
    POPUP "&File"
	MENUITEM "New Child (type &1)"	COMMAND New1	HELP WHelp{"Child with menu type 1"}
	MENUITEM "New Child (type &2)"	COMMAND New2	HELP WHelp{"Child with menu type 2"}
	MENUITEM "New Child (type &3)"	COMMAND New3	HELP WHelp{"Child with menu type 3"}
	MENUITEM SEPARATOR
	MENUITEM "&Close"	COMMAND Close	HELP WHelp{"Close this window"}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    POPUP   "&Child 2 Menu"
	MENUITEM "&Your item"  ACTION {|| nil}  HELP WHelp{"Your menu item here..."}
    ENDPOPUP
    MDIWINDOWPOPUP	// provides Window Cascade, Tile, Arrange Icons, etc.
    POPUP "&Help"
	MENUITEM "&About"					 	;
	         HELP WHelp{"About this application"}			;
	         ACTION {|| DbgShow(), MessageBox( , "Demo written by John Skelton", ;
		                       "About", MB_ICONEXCLAMATION + MB_OK) }
    ENDPOPUP
ENDMENU

return self


CLASS Child3 INHERIT WMDIChild
	METHOD Close()			INLINE SendMessage(::hWnd, WM_CLOSE)
	METHOD Create(oParent, cTitle)					;
	       INLINE super:Create(oParent, cTitle):MenuSetup()
	MESSAGE MenuSetup()		METHOD Menu3()
ENDCLASS

METHOD Menu3() CLASS Child3

MENU IN self
    POPUP "&File"
	MENUITEM "New Child (type &1)"	COMMAND New1	HELP WHelp{"Child with menu type 1"}
	MENUITEM "New Child (type &2)"	COMMAND New2	HELP WHelp{"Child with menu type 2"}
	MENUITEM "New Child (type &3)"	COMMAND New3	HELP WHelp{"Child with menu type 3"}
	MENUITEM SEPARATOR
	MENUITEM "&Close"	COMMAND Close	HELP WHelp{"Close this window"}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    POPUP   "&Child 3 Menu"
	MENUITEM "&Your item"  ACTION {|| nil}  HELP WHelp{"Your menu item here..."}
    ENDPOPUP
    MDIWINDOWPOPUP	// provides Window Cascade, Tile, Arrange Icons, etc.
    POPUP "&Help"
	MENUITEM "&About"					 	;
	         HELP WHelp{"About this application"}			;
	         ACTION {|| DbgShow(), MessageBox( , "Demo written by John Skelton", ;
		                       "About", MB_ICONEXCLAMATION + MB_OK) }
    ENDPOPUP
ENDMENU

return self

