////////////////////////////
//
//	Clip-4-Win WODBC & WBrowse/BListBox bar sample
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Compile and link:	rmake odbcbrow
//
////////////////////////////

#include "topclass.ch"
#define	WIN_WANT_ALL
#define	WIN_WANT_LB
#define	WIN_WANT_LBS
#include "windows.ch"
#include "commands.ch"


#define	CR		chr(13)

#define	IDD_BROWSE	101


function main()
local	oApp

oApp = BrowseApp{"Clip-4-Win ODBC & BListBox Demo"}
oApp:oWnd:MenuSetup()

oApp:Start()

return nil


CLASS BrowseApp INHERIT WApp
	METHOD Create(cText)	INLINE ::oWnd := BrowseWindow{self, cText}
ENDCLASS


CLASS BrowseWindow INHERIT WSDIWindow

	PROTECT oBD	AS OBJECT // AS BrowseDialog

	METHOD Browse()		INLINE ::oBD := BrowseDialog{self}
	METHOD BrowseRes()	INLINE ::oBD := BrowseDialog{self, "browse"}

	METHOD Exit()		INLINE ::oApp:Quit(), self

	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              self
	METHOD MenuSetup()
ENDCLASS


CLASS BrowseDialog INHERIT WDialog

	PROTECT oB	AS OBJECT // AS WBListBox

//	PROTECT oTable	AS OBJECT // AS WODBC
	EXPORT oTable	AS OBJECT // AS WODBC

	METHOD EndDialog(xResult)					;
	       INLINE iif(empty(::oTable), , ::oTable:Axit()),		;
	              ::oTable := nil,					;
	              super:EndDialog(xResult)

	METHOD Init(oParent, cnId_aDlg, lCreate)

	ACCESS WndStyle							;
	       INLINE DS_MODALFRAME + WS_POPUP + WS_CHILD + WS_VISIBLE	;
	              + WS_CAPTION
ENDCLASS


METHOD Init(oParent, cnId_aDlg, lCreate) CLASS BrowseDialog
// Note: you can't use code blocks like
//	             {|| ::oTable:FieldGet(1) }
// in aCols, unless you EXPORT oTable.
local	aCols :=							;
{									;
	{"CourseID",    {|| ::oTable:FieldGet(1) } },			;
	{"CourseTitle", {|| ::oTable:FieldGet(2) } }			;
}

default lCreate to .t.

super:Init(oParent, cnId_aDlg, .f., .f.)

// Like this:   ::oTable = WODBC{self}
//              ::oTable:Select("select * from course")
// or in one statement:
::oTable = WODBC{self, "select * from course"}
::oTable:GoTop()

if cnId_aDlg == nil

	INIT DIALOG self						;
		Title "Browse In Dialog"  Style ::WndStyle  At 20,20  Size 250,200

	@ Id IDD_BROWSE  Obj ::oB  BListBox				;
		Columns aCols						;
		GoBottomBlock {|oB| DoGoBottom(oB, ::oTable) }		;
		GoTopBlock {|oB| DoGoTop(oB, ::oTable) }		;
		SkipBlock {|oB, n| DoSkip(oB, ::oTable, n) }		;
		At 10,10  Size 180,180

	@ Id IDCANCEL              Button    Title "&Cancel" At 200,10 Size 40,12

else

	@ Id IDD_BROWSE  Obj ::oB  BListBox				;
		Columns aCols						;
		GoBottomBlock {|oB| DoGoBottom(oB, ::oTable) }		;
		GoTopBlock {|oB| DoGoTop(oB, ::oTable) }		;
		SkipBlock {|oB, n| DoSkip(oB, ::oTable, n) }

//	@ Id IDCANCEL    Button		// defaults to this, add it if you like
endif

if lCreate
	::Create(cnId_aDlg)
endif

return self


static procedure DoGoTop(oB, oTable)
oTable:GoTop()
oB:nMaxRec   = oTable:LastRec
oB:HitTop    = .t.
oB:HitBottom = .f.
oB:RowPos    := oB:nCurRec := 1
return


static procedure DoGoBottom(oB, oTable)
oTable:GoBottom()
oB:nMaxRec   = oTable:LastRec
oB:HitTop    = .f.
oB:HitBottom = .t.
oB:RowPos    = oB:RowCount
oB:nCurRec   = oTable:LastRec
return


static function DoSkip(oB, oTable, n)
if oTable:Skip(n)
	oB:nCurRec   += n
	oB:nCrecNo   = oTable:RecNo
	oB:HitTop    = .f.
	oB:HitBottom = .f.
	return n
elseif oTable:BOF()
	oB:nCurRec   = 1
	oB:nCrecNo   = oTable:RecNo
	oB:HitTop    = .t.
	oB:HitBottom = oTable:EOF()
elseif oTable:EOF()
	oB:nCurRec   = oTable:LastRec + 1
	oB:nCrecNo   = oTable:LastRec
	oB:HitTop    = oTable:BOF()
	oB:HitBottom = .t.
endif
return 0


METHOD MenuSetup() CLASS BrowseWindow

MENU IN self
    POPUP "&File"
	MENUITEM "&BListBox Browse"					;
		 COMMAND Browse   HELP WHelp{"A dynamic dialog using BListBox"}
	MENUITEM "BListBox Browse - &Resource"				;
		 COMMAND BrowseRes  HELP WHelp{"A resource dialog using BListBox"}
	MENUITEM SEPARATOR
	MENUITEM "&Multiple Inheritance Info"				;
	         ACTION {|| QOut("Possible Multiple Inheritance Problems " ;
	                         + "for WControlWindow and WBrowse:"),	;
	                    QOut(),					;
	                    tc_xPrint(tc_MIInfo("WControlWindow", "WBrowse"))}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
ENDMENU

return self

