////////////////////////////
//
//	Clip-4-Win MDI ODBC & WBrowse sample
//
//	Copyright (C) 1994-1995 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Compile and link:	rmake odbcwbro
//
//	Part of Clip-4-Win.
//
//	Note: To keep this example simple, it has all the classes in this
//	      one file, and uses very simple classes.  The idea is that you
//	      can see the important things all here, but it does mean that
//	      some use of MESSAGE ... METHOD was needed.
//
//	Alternatives
//	============
//
//	You can compile this with or without MI (multiple inheritance).
//	Either:
//			clipper odbcwbro /n /w
//	or:
//			clipper odbcwbro /n /w /dAVOIDMI
//
//	They're not quite equivalent: the first makes the browse itself
//	the MDI child's :oClient, which means that it automatically gets
//	re-sized if the child does.  And, the re-sizing allows for any
//	toolbar / status bar (see framewin.prg).  The non-MI version just
//	uses the child itself, which is all this sample actually needs.
//
////////////////////////////

#include "windows.ch"
#include "topclass.ch"
#include "commands.ch"


procedure main()
local	oApp

oApp = BrowseApp{"Clip-4-Win MDI ODBC & WBrowse(s) Sample"}
oApp:oWnd:MenuSetup()

oApp:Start()

return


CLASS BrowseApp INHERIT WMDIApp
	METHOD Create(cText)	INLINE ::oWnd := MainWindow{self, cText}
ENDCLASS


CLASS MainWindow INHERIT WMDIFrame
	METHOD BrowseNew()						;
	       INLINE local	oTable,					;
	              ; // Like this:   oTable := WODBC{self, , "SAMPLE"}, ;
	              ; //              oTable:Select("select * from course"),;
	              ; // or in one statement:
	              oTable := WODBC{self, "select * from course", "SAMPLE"},;
	              oTable:GoTop(),					;
	              ::CreateChild(Browser{::Client, oTable}),		;
	              0

	METHOD Exit()			INLINE ::oApp:Quit()

	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              self

	METHOD MenuSetup()
ENDCLASS


CLASS Browser INHERIT WMDIChild

#ifdef	AVOIDMI
	PROTECT oBrow	AS OBJECT // AS WBrowse
#endif	// AVOIDMI
//	PROTECT oTable	AS OBJECT // AS WODBC
	EXPORT oTable	AS OBJECT // AS WODBC

	METHOD Browse()
	METHOD Close()			INLINE SendMessage(::hWnd, WM_CLOSE)
	METHOD Create(oParent)						;
	       INLINE super:Create(oParent):MenuSetup():Browse()
	METHOD Init(oParent, oTable)					;
	       INLINE ::oTable := oTable,				;
	              super:Init(oParent)
	MESSAGE MenuSetup()		METHOD BrowserMenu()
	METHOD OnNCDestroy()						;
	       INLINE ::oTable:Axit(),					;
	              super:OnNCDestroy()
#ifdef	AVOIDMI
	METHOD OnSetFocus()						;
	       INLINE iif(::oBrow == nil, , SetFocus(::oBrow:hWnd)), 0
	METHOD OnSize(nType, nWidth, nHeight)				;
	       INLINE iif(::oBrow == nil, ,				;
	                  MoveWindow(::oBrow:hWnd,			;
	                             0, 0, nWidth, nHeight, .t.)),	;
	              ; // This example uses the entire child for the browse,
	              ; // so it uses MoveWindow() above, and doesn't need to
	              ; // call super, but if you had a toolbar you'd want to
	              ; // make the browse be the child's :oClient, and super
	              ; // would size everything for you.
	              super:OnSize(nType, nWidth, nHeight)
#endif	// AVOIDMI
ENDCLASS


#ifdef	AVOIDMI
#else
CLASS BrowseClient INHERIT WWindow, WBrowse
	METHOD Init(oParent, nLeft, nTop, nWidth, nHeight, cTitle, nStyle) ;
	       INLINE ; // Not wanted: (WBrowse makes its own window)
	              ; //     super( WWindow ):Init(oParent),
	              ::oParent := oParent,				;
	              super( WBrowse ):Init(oParent:hWnd,		;
	                                    nLeft, nTop, nWidth, nHeight,;
	                                    cTitle, nStyle),		;
	              self
ENDCLASS
#endif	// AVOIDMI


METHOD Browse() CLASS Browser
// Note: you can't use code blocks like
//	             {|| ::oTable:FieldGet(1) }
// in aCols, unless you EXPORT oTable.
local	aCols :=							;
{									;
	{"CourseID",    {|| ::oTable:FieldGet(1) } },			;
	{"CourseTitle", {|| ::oTable:FieldGet(2) } }			;
}
local	oB, i
local	a := GetClientRect(::hWnd)
local	nLeft := a[1], nTop := a[2], nWidth := a[3], nHeight := a[4]

::Text  := "Clip-4-Win Browse - "  // + ::oTable:Name

#ifdef	AVOIDMI
oB      := ;
::oBrow := ;
WBrowse{::hWnd, nLeft, nTop, nWidth, nHeight, "", ;
        WS_CHILD + WS_HSCROLL + WS_VSCROLL}
        // + WS_VISIBLE is assumed by WBrowse!
#else
oB      := ;
::oClient := ;
BrowseClient{self, nLeft, nTop, nWidth, nHeight, "", ;
        WS_CHILD + WS_HSCROLL + WS_VSCROLL}
        // + WS_VISIBLE is assumed by WBrowse!
#endif	// AVOIDMI

oB:GoBottomBlock := ;
{|oB| ::oTable:GoBottom(),						;
      oB:HitTop    := .f.,						;
      oB:HitBottom := .t.,						;
      oB:RowPos    := oB:nMaxLines,					;
      oB:nCurRec   := ::oTable:RecNo,					;
      oB:nCrecNo   := ::oTable:RecNo,					;
      oB:nMaxRec   := ::oTable:LastRec					;
}
oB:GoTopBlock    := ;
{|oB| ::oTable:GoTop(),							;
      oB:HitTop    := .t.,						;
      oB:HitBottom := .f.,						;
      oB:RowPos    := 1,						;
      oB:nCurRec   := 1,						;
      oB:nCrecNo   := 1,						;
      oB:nMaxRec   := ::oTable:LastRec					;
}
oB:SkipBlock     := {|oB, n| DoSkip(oB, ::oTable, n) }

//oB:Alias  := ::oTable:Alias
oB:Escape := .f.

for i = 1 to len(aCols)
	oB:AddColumn( WBColumn{aCols[i, 1], aCols[i, 2]} )
next i

SetFocus(oB:hWnd)
oB:GoTop()

return self


static function DoSkip(oB, oTable, n)
if oTable:Skip(n)
	oB:nCurRec   += n
	oB:nCrecNo   = oTable:RecNo
	oB:HitTop    = .f.
	oB:HitBottom = .f.
	return n
elseif oTable:BOF()
	oB:nCurRec   = 1
	oB:nCrecNo   = oTable:RecNo
	oB:HitTop    = .t.
	oB:HitBottom = oTable:EOF()
elseif oTable:EOF()
	oB:nCurRec   = oTable:LastRec + 1
	oB:nCrecNo   = oTable:LastRec
	oB:HitTop    = oTable:BOF()
	oB:HitBottom = .t.
endif
return 0


METHOD MenuSetup() CLASS MainWindow

MENU IN self
    POPUP "&File"
	MENUITEM "&Browse..."	COMMAND BrowseNew  HELP WHelp{"Browse a file..."}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    POPUP   "&Window"
	MENUITEM "&Cascade"	COMMAND Cascade				;
	         HELP WHelp{"Cascade child windows"}
	MENUITEM "&Tile"	COMMAND Tile				;
	         HELP WHelp{"Tile child windows"}
	MENUITEM "Arrange &Icons" COMMAND ArrangeIcons			;
	         HELP WHelp{""}
	MENUITEM "Close &All"	COMMAND CloseAll			;
	         HELP WHelp{"Close all child windows"}
    ENDPOPUP
    POPUP "&Help"
	MENUITEM "&About"					 	;
	         HELP WHelp{"About this application"}			;
	         ACTION {|| MessageBox( , "Demo written by John Skelton", ;
		                       "About", MB_ICONEXCLAMATION + MB_OK) }
    ENDPOPUP
ENDMENU

return self


METHOD BrowserMenu() CLASS Browser

MENU IN self
    POPUP "&File"
	MENUITEM "&Browse..."	COMMAND BrowseNew  HELP WHelp{"Browse a file..."}
	MENUITEM SEPARATOR
	MENUITEM "&Close"	COMMAND Close	HELP WHelp{"Close browse window"}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    POPUP   "&View"
	MENUITEM "&Your item"  ACTION {|| nil}  HELP WHelp{"Your menu item here..."}
    ENDPOPUP
    POPUP   "&Window"
	MENUITEM "&Cascade"	COMMAND Cascade				;
	         HELP WHelp{"Cascade child windows"}
	MENUITEM "&Tile"	COMMAND Tile				;
	         HELP WHelp{"Tile child windows"}
	MENUITEM "Arrange &Icons" COMMAND ArrangeIcons			;
	         HELP WHelp{""}
	MENUITEM "Close &All"	COMMAND CloseAll			;
	         HELP WHelp{"Close all child windows"}
    ENDPOPUP
    POPUP "&Help"
	MENUITEM "&About"					 	;
	         HELP WHelp{"About this application"}			;
	         ACTION {|| MessageBox( , "Demo written by John Skelton", ;
		                       "About", MB_ICONEXCLAMATION + MB_OK) }
    ENDPOPUP
ENDMENU

return self

