////////////////////////////
//
//	Clip-4-Win progress bar sample
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Compile and link:	rmake pbar
//
////////////////////////////

#include "topclass.ch"
#define	WIN_WANT_ALL
#include "windows.ch"
#include "commands.ch"


#define	CR	chr(13)


function main()
local	oApp

oApp = UsersApp{"Clip-4-Win Progress Dialog Demo"}
oApp:oWnd:MenuSetup()

oApp:Start()

return nil


CLASS UsersApp INHERIT WApp
	METHOD Create(cText)	INLINE ::oWnd := UsersWindow{self, cText}
ENDCLASS


CLASS UsersWindow INHERIT WSDIWindow

	PROTECT oPD	AS OBJECT // AS WProgressDialog

	PROTECT lFName	AS LOGIC
	PROTECT oFName	AS OBJECT // AS WCenterText

	METHOD Cleanup()	INLINE ::lFName := .f., ::oFName := nil
	METHOD Exit()		INLINE ::oApp:Quit()

	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              self
	METHOD MenuSetup()

	/*
	 *  This demo is driven by a timer, but you'd probably have a loop
	 *  that's printing, or indexing with EVAL ... EVERY ... (you
	 *  wouldn't use a cancel button when indexing, of course).
	 *  Note: Your background loop would monitor oPD:Cancelled.  Because
	 *        oPD is a modeless dialog, you can do that but you must
	 *        keep calling PeekMessage()/GetMessage() to keep your app
	 *        and Windows active.  You can just use W[MDI]App:Exec(WM_USER).
	 *        Don't forget to remove the oPD using oPD:EndDialog()!
	 */
	METHOD OnTimer()						;
	       INLINE iif(::oPD:Cancelled .or. ::oPD:Current == ::oPD:Max,;
	                  KillTimer(::hWnd, 1),				;
	                  ::oPD:Current++),				;
	              iif(empty(::lFName), ,				;
	                  iif(::oPD:Current % 12 < 6,			;
	                      ::oFName:Text := "\your\file\name\here",	;
	                      ::oFName:Text := "\this\is\just\a\demo")),;
	              iif(::oPD:Cancelled, ::oPD:EndDialog(), ),	;
	              0
	METHOD DynPBar()						;
	       INLINE ::Cleanup(),					;
	              ::oPD := WProgressDialog{self},			;
	              ::oPD:Text := "Indexing...",			;
	              SetTimer(::hWnd, 1, 250)
	METHOD HughPBar()						;
	       INLINE ::Cleanup(),					;
	              ::oPD := WProgressDialog{self},			;
	              ::oPD:Text := "Hello Hugh...",			;
	              ::oPD:TextDoneColor := RGB(0,0,0),		;
	              ::oPD:TextToDoColor := RGB(0,0,0),		;
	              SetTimer(::hWnd, 1, 250)
#ifdef RESOURCE
#define	IDD_FNAME	102
	METHOD ResPBar1()						;
	       INLINE ::Cleanup(),					;
	              ::oPD := WProgressDialog{self, "progbar1"},	;
	              SetTimer(::hWnd, 1, 250)
	METHOD ResPBar2()						;
	       INLINE ::Cleanup(),					;
	              ::oPD := WProgressDialog{self, "progbar2"},	;
	              ; // oPD:Text will be set from the resource, but if
	              ; // you want to change it here's how:
	              ::oPD:Text := "Copying Files...",			;
	              ::lFName := .t.,					;
	              ; // it's this easy to "hook into" a control
	              ::oPD:Add( ::oFName := WCenterText{::oPD, IDD_FNAME} ),;
	              SetTimer(::hWnd, 1, 250)
#else
	METHOD ResPBar1()						;
	       INLINE MessageBox(::hWnd, "You need to use" + CR		;
	                         + "     RMAKE  /dRC  PBAR", "PBar")
	METHOD ResPBar2()	INLINE ::ResPBar1()
#endif
ENDCLASS


METHOD MenuSetup() CLASS UsersWindow

MENU IN self
    POPUP "&File"
	MENUITEM "&Dynamic Progress Bar"				;
		 COMMAND DynPBar   HELP WHelp{"A progress bar using a dynamic dialog"}
	MENUITEM "Dynamic Progress Bar for &Hugh"			;
		 COMMAND HughPBar  HELP WHelp{"A progress bar for Hugh Lokey!"}
	MENUITEM "Resource Progress Bar &1"				;
		 COMMAND ResPBar1  HELP WHelp{"A progress bar using a resource dialog"}
	MENUITEM "Resource Progress Bar &2"				;
		 COMMAND ResPBar2  HELP WHelp{"A progress bar using a resource dialog"}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
ENDMENU

return self

