//	Spin.prg - Spin button (OO)
//
//	Written by:	John M. Skelton,  Nov-95.
//
//	Copyright (C) 1995 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.

#define	WIN_WANT_LBS
#define	WIN_WANT_ALL
#include "windows.ch"
#include "commands.ch"


function main()
local	oApp, oWnd

CREATE APPLICATION oApp  WINDOW oWnd  TITLE "Clip-4-Win Spin Button Demo" ;
	ON INIT (DemoDlg{oWnd}, PostQuitMessage(0))

return 0


CLASS DemoDlg INHERIT WDialog
	PROTECT oEdit	AS OBJECT

	EXPORT nCount	AS INT
	PROTECT oGet	AS OBJECT

	PROTECT oLB	AS OBJECT
	PROTECT oSay	AS OBJECT

	PROTECT oSpin2	AS OBJECT
	PROTECT oSpin3	AS OBJECT
	PROTECT oSpin4	AS OBJECT

	METHOD Clicked1()	INLINE ::oSay:Text += "x"

	METHOD Clicked2()						;
	       INLINE ::oSpin2:Position := val(::oEdit:Text)		;
	                                   + ::oSpin2:Change,		;
	              ::oEdit:Text := ltrim(str(::oSpin2:Position))

	METHOD Clicked3()						;
	       INLINE ::oSpin3:Position := (::nCount += ::oSpin3:Change),;
	              ::oGet:UpdateBuffer()

	METHOD Clicked4()						;
	       INLINE local	n,					;
	              n := ::oLB:Len(),					;
	              iif(::oSpin4:Position < 0, ::oSpin4:Position += n,;
	                  ::oSpin4:Position %= n),			;
	              ::oLB:Position := n - ::oSpin4:Position

	METHOD Init(oParent)
ENDCLASS


METHOD Init(oParent) CLASS DemoDlg
local	aList := {"A List Box", "With Nothing", "Much In It", "Unless",	;
                  "You Count This", "BTW", "    Clip-4-Win",		;
                  "            Is", "        Great!"}

super:Init(oParent, , .f., .t.)

::nCount := 0

INIT DIALOG self  TITLE "Clip-4-Win Spin Button Demo"			;
	STYLE ::WndStyle  AT 20,20  SIZE 240,165

@ ID  IDOK    BUTTON Ok      TITLE "&Ok"                AT 180,7  SIZE 50,14
@ ID IDCANCEL BUTTON Cancel  TITLE "&Cancel"            AT 180,25 SIZE 50,14

@ ID   101    SPIN BUTTON Clicked1                      AT 20,30  SIZE 6,16
@ ID   102    SAY ""                      OBJ ::oSay    AT 30,34  SIZE 40,12

@ ID   103    SPIN BUTTON Clicked2        OBJ ::oSpin2  AT 70,80  SIZE 6,12
@ ID   104    EDIT TEXT "0"               OBJ ::oEdit   AT 20,80  SIZE 47,12

@ ID   105    SPIN BUTTON Clicked3        OBJ ::oSpin3  AT 70,120 SIZE 6,12
@ ID   106    GET ::nCount  PICTURE "99"  OBJ ::oGet    AT 20,120 SIZE 47,12

@ ID   107    SPIN BUTTON Clicked4        OBJ ::oSpin4  AT 160,80 SIZE 6,12
@ ID   108    LISTBOX  ITEMS aList        OBJ ::oLB     AT 90,40  SIZE 65,80

::oSpin4:Position := ::oLB:Len() - 1
::oLB:Position    := 1

::Create()

return self

