//	Splash.prg - splash (start-up) screen demo - OO version
//
//	Written by:	John M. Skelton,  Nov-95.
//
//	Copyright (C) 1995 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.

#include "windows.ch"
#include "commands.ch"


function main()
local	oApp, oWnd

oApp := MyApp{"Clip-4-Win Splash Screen Demo", .f.}
(oWnd := oApp:oWnd):Create()

DoInit(oWnd)

oApp:Start()
oApp:Quit()

return 0


CLASS MyApp INHERIT WApp
	METHOD Create(cText)	INLINE ::oWnd := MainWindow{self, cText}
ENDCLASS


CLASS MainWindow INHERIT WSDIWindow
	METHOD Paint()
ENDCLASS


static function DoInit(oWnd)
local	oSplash, t1

ShowWindow(oWnd:hWnd, _GetnCmdShow())

// create a splash window for the user to see
#ifndef	TIMER
oSplash = WDialog{oWnd, "SplashDlg", , .f.}	// a modeless dialog
#else
oSplash = SplashDlg{oWnd}
#endif

// do rest of init (here we just waste some time, as this is only a demo)
t1 = seconds() + 3
do while seconds() <= t1
enddo

#ifndef	TIMER
// remove the splash window, if it's not self-removing (e.g. own timer)
if IsWindow(oSplash:hWnd)
	oSplash:EndDialog()
endif
#endif

return nil


METHOD Paint() CLASS MainWindow
cls
?
? " You can compile with:"
? "    (default)  Splash screen is removed after init done"
? "     /dTIMER   Splash screen with its own timer"
?
#ifndef	TIMER
? "This EXE built without /dTIMER"
#else
? "This EXE built with /dTIMER"
#endif
return nil


#ifdef	TIMER

CLASS SplashDlg INHERIT WDialog

	METHOD Init(oParent)

	METHOD HandleMessage(nMsg, nw, nl)				;
	       INLINE iif(nMsg == WM_TIMER, ::OnTimer(),		;
	                  super:HandleMessage(nMsg, nw, nl))

	METHOD OnTimer()						;
	       INLINE KillTimer(::hWnd, 1),				;
	              ::EndDialog()
ENDCLASS


METHOD Init(oParent) CLASS SplashDlg

super:Init(oParent, "SplashDlg", .t., .f.)

// Here we limit how long the dialog is visible, using a timer.
SetTimer(::hWnd, 1, 5000)	// # milliseconds

return self

#endif	// TIMER

