////////////////////////////
//
//	Clip-4-Win (SDI) OO browser sample
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Compile and link:  c4wbuild tinybrow
//
////////////////////////////

#include "windows.ch"
#include "topclass.ch"
#include "commands.ch"


procedure main()
local	oApp, oWnd

oApp := BrowseApp{"Clip-4-Win Browser Sample"}
oApp:oWnd:MenuSetup()

oApp:Start()

oApp:Quit()

return


CLASS BrowseApp INHERIT WApp
	METHOD Create(cText)	INLINE ::oWnd := MainWindow{self, cText}
ENDCLASS


CLASS MainWindow INHERIT WSDIWindow
	METHOD Browse()

	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              self

	METHOD MenuSetup()
ENDCLASS


METHOD Browse() CLASS MainWindow
local	cFile, oBrowse
local	cPrompt := "Clip-4-Win WDBrowse Demo"  // Displayed in text area

if (cFile := GetOpenFileName( , "*.dbf", "Select a database")) == nil
	return nil
endif

use (cFile) new shared

oBrowse := WDBrowse{self, cPrompt}

close all

return self


METHOD MenuSetup() CLASS MainWindow

MENU IN self
    POPUP "&File"
	MENUITEM "&Browse..."  COMMAND Browse  HELP WHelp{"Browse a file..."}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"       ACTION ::App:Quit()  HELP WHelp{"Exit the application"}
    ENDPOPUP
    POPUP "&Help"
	MENUITEM "&About"					 	;
	         HELP WHelp{"About this application"}			;
	         ACTION MessageBox( , "Demo written by John Skelton",	;
		                   "About", MB_ICONEXCLAMATION + MB_OK)
    ENDPOPUP
ENDMENU

return self

