////////////////////////////
//
//	Clip-4-Win Users form view demo  (using dialog Gets)
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	This one uses a resource file.  But source\users\users.prg does not.
//
//	Compile and link:	c4wbuild usersres
//
//	NOTE: Some people have whether they can distribute CTL3D.DLL
//	      with their apps.  Yes.  Say thanks to Microsoft.  They
//	      want you to use it because it provides the sort of
//	      appearance that's going to be standard in future versions
//	      of Windows.
//
//	For multi-window versions, see modeless.prg or usersmdi.prg
//	(which use the WTable class).
//
//	NOTE: To understand the usage of the dialog resources, you
//	need to look closely at the USERSRES.RC file.  It defines
//	a dialog called "dlguser", containing
//	various controls.  The file is as follows:
/*

//#define WIN_WANT_CB
//#define WIN_WANT_LBS
#include "windows.ch"
#include "usersres.ch"

dlguser DIALOG 20, 20, 183, 127
STYLE DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
CAPTION "User Details"
FONT 10, "MS Sans Serif"
BEGIN
    PUSHBUTTON      "&Ok", IDOK, 132, 13, 37, 12
    PUSHBUTTON      "&Cancel", IDCANCEL, 132, 37, 37, 12
    PUSHBUTTON      "&Next", IDD_NEXT, 132, 61, 37, 12
    PUSHBUTTON      "&Previous", IDD_PREV, 132, 85, 37, 12
    PUSHBUTTON      "&Save", IDD_SAVE, 132, 109, 37, 12
    LTEXT           "User ID:", IDD_TUSERID, 7, 2, 50, 8
    EDITTEXT        IDD_USERID, 7, 13, 115, 13, ES_AUTOHSCROLL
    LTEXT           "User Name:", IDD_TUSERNAME, 7, 28, 50, 8
    EDITTEXT        IDD_USERNAME, 7, 37, 115, 13, ES_AUTOHSCROLL
    LTEXT           "Department:", IDD_TDEPT, 7, 52, 50, 8
    EDITTEXT        IDD_DEPT, 7, 61, 115, 13, ES_AUTOHSCROLL
    LTEXT           "Phone:", IDD_TPHONE, 7, 76, 50, 8
    EDITTEXT        IDD_PHONE, 7, 85, 115, 13, ES_AUTOHSCROLL
    LTEXT           "Extension:", IDD_T_EXT, 7, 100, 50, 8
    EDITTEXT        IDD_EXT, 7, 109, 115, 13, ES_AUTOHSCROLL
END

*/
//
////////////////////////////

#include "topclass.ch"
#define	WIN_WANT_ALL
#define	WIN_WANT_GETDEVCAPS
#include "windows.ch"
#include "font.ch"
#include "usersres.ch"
#include "commands.ch"


static	cFontName := "MS Sans Serif"
static	nPointSize := 8


function main()
local	oApp

oApp = UsersApp{"Clip-4-Win Users (Object-Oriented & Resource) Demo"}
oApp:oWnd:MenuSetup()

oApp:Start()

return nil


CLASS UsersApp INHERIT WApp
	METHOD Create(cText)	INLINE ::oWnd := UsersWindow{self, cText}
ENDCLASS


CLASS UsersWindow INHERIT WSDIWindow
	METHOD Exit(oMenuItem)
	METHOD Font(oMenuItem)
	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              self
	METHOD Menu3d(oMenuItem)					;
	       INLINE ;               // want opposite of current
	              ::oApp:Ctl3d := oMenuItem:Checked := !oMenuItem:Checked,;
	              self
	METHOD MenuSetup()
	METHOD Users()
ENDCLASS


// This isn't actually used in this sample
METHOD Font() CLASS UsersWindow
local	aFont[14], nPt, hDC := GetDC(::hWnd)
aFont[LF_FaceName] = cFontName
// the following scales the font from point size to screen size:
aFont[LF_Height] = - GetDeviceCaps(hDC, LOGPIXELSY) * nPointSize / 72
ReleaseDC(::hWnd, hDC)
if ChooseFont(aFont, @nPt) != nil
	cFontName = aFont[LF_FaceName]
	// the returned value is in tenths of a point
	nPointSize = nPt / 10
endif
return self


METHOD Exit(oMenuItem) CLASS UsersWindow
MessageBox(::hWnd, "Thanks for running this Clip-4-Win demo!", "Exiting", ;
	   MB_ICONHAND + MB_OK)
::oApp:Quit()
return self


METHOD Users() CLASS UsersWindow
local	i

// This demonstrates stepping through a DBF file.  It doesn't
// return anything much, but if you wanted just to have a
// dialog for a single set of values (and return any alterations),
// use instance vars, or pass them by reference (e.g. @cVar) in a
// code block below (after "dlguser" makes most sense).

i = UsersDialog{self, "dlguser"}:Result

if i == IDCANCEL
	// MessageBox( , "Results ignored", "Cancel")
endif
return self


CLASS UsersDialog INHERIT WDialog

	// the input fields
	EXPORT	cUserID, cUserName, cDept, cPhone, cExt

	// the WGet GUI objects
	PROTECT	oUserID, oUserName, oDept, oPhone, oExt

	METHOD Gather()
	METHOD Scatter()
	METHOD Update()

	// buttons
	METHOD Ok()
	METHOD Cancel()
	METHOD Next()
	METHOD Previous()
	METHOD Save()

	METHOD OnInitDialog()
	METHOD OnSysCommand(nType, nX, nY)
ENDCLASS


METHOD Scatter() CLASS UsersDialog
::cUserID   := users->UserID
::cUserName := users->UserName
::cDept     := users->Department
::cPhone    := users->Phone
::cExt      := users->Extension
return self


METHOD Gather() CLASS UsersDialog
users->UserID     := ::cUserID
users->UserName   := ::cUserName
users->Department := ::cDept
users->Phone      := ::cPhone
users->Extension  := ::cExt
return self


METHOD Update() CLASS UsersDialog

::Scatter()

::oUserID  :UpdateBuffer()
::oUserName:UpdateBuffer()
::oDept    :UpdateBuffer()
::oPhone   :UpdateBuffer()
::oExt     :UpdateBuffer()
return self


METHOD Next() CLASS UsersDialog

// Don't define NOT_DEFINED !!!   (It's just used for commenting)

#ifdef NOT_DEFINED	// this is to avoid using /* ... */ over many lines
			// which causes problems if you have another
			// /* ... */ comment within the code

	/*
	 *  This code is commented out because it's NOT the
	 *  way to do it!!  You're not closing the dialog.
	 *  You're just moving to a new record.  If you use
	 *  this code you get very confused edit controls.
	 */

	// need to cancel current GETs, skip, and re-issue them

	::Cancel()		// cancel any GETs

	users->( dbSkip(1) )
	if users->( Eof() )
		users->( dbGoBottom() )
	endif

	::Scatter()		// fetch fields to static vars

	@ Id IDD_USERID   Obj ::oUserID   Get ::cUserID
	@ Id IDD_USERNAME Obj ::oUserName Get ::cUserName
	@ Id IDD_DEPT     Obj ::oDept     Get ::cDept
	@ Id IDD_PHONE    Obj ::oPhone    Get ::cPhone
	@ Id IDD_EXT      Obj ::oExt      Get ::cExt     Picture "9999"
#else

	/*
	 *  Here's how to make moving to a different record work.
	 */

	// need to skip, then update GETs

	users->( dbSkip(1) )
	if users->( Eof() )
		users->( dbGoBottom() )
	endif

	::Update()		// update the GETs and vars

#endif // NOT_DEFINED

return 1		// means msg has been processed


METHOD Previous() CLASS UsersDialog

// need to skip, then update GETs

users->( dbSkip(-1) )
if users->( Bof() )
	users->( dbGoTop() )
endif

::Update()		// update the GETs and vars
return 1		// means msg has been processed


METHOD Save() CLASS UsersDialog
if ::Valid
	users->( RLock() )
	::Gather()	// update the fields from the vars
	users->( dbUnlock() )
endif
return 1		// means msg has been processed


METHOD OnInitDialog() CLASS UsersDialog

use users new shared
users->( dbGoTop() )

::Scatter()		// fetch fields

/////////////
//
//  The code below does validation using GET objects.
//
//  The objects need to be saved because we want to change
//  them as we move from record to record.
//
/////////////

@ Id IDD_USERID   Obj ::oUserID   Get ::cUserID
@ Id IDD_USERNAME Obj ::oUserName Get ::cUserName
@ Id IDD_DEPT     Obj ::oDept     Get ::cDept
@ Id IDD_PHONE    Obj ::oPhone    Get ::cPhone
@ Id IDD_EXT      Obj ::oExt      Get ::cExt     Picture "9999"

// buttons: (Ok & Cancel can default)

@ Id IDD_NEXT  PushButton Next
@ Id IDD_PREV  PushButton Previous
@ Id IDD_SAVE  PushButton Save

// Here are some alternatives:
//	::Add( WPushButton{self, IDD_NEXT}, "Next" )
//	::Add( WPushButton{self, IDD_PREV}, "Previous" )
//	::Add( WPushButton{self, IDD_SAVE}, "Save" )
// or:
//	::Add( WPushButton{self, IDD_NEXT}, {|| ::Next()} )
//	::Add( WPushButton{self, IDD_PREV}, {|| ::Previous()} )
//	::Add( WPushButton{self, IDD_SAVE}, {|oDlg, oBtn| oDlg:Save()} )
// or:
//	@ Id IDD_NEXT  Button Next  ACTION ::Next()
//	@ Id IDD_PREV  Button       ACTION {|oDlg, oBtn| oDlg:Previous()}
//	@ Id IDD_SAVE  Button Save  ACTION {|oDlg, oBtn| oDlg:Save()}

return 1			// want system to set the focus


METHOD OnSysCommand(nType, nX, nY) CLASS UsersDialog
if nType == SC_CLOSE		// system menu double click, or Alt-F4
#ifdef ThisIsTheDefault
	// By default, Windows sends a WM_CLOSE, which defaults to sending
	// WM_COMMAND with IDCANCEL, which does the same as this code:
	::Cancel()
	return 1		// means msg has been processed
#endif // ThisIsTheDefault
endif
return super:OnSysCommand(nType, nX, nY)


METHOD Ok() CLASS UsersDialog
// don't change record (it's only done if SAVE button pressed, i.e. IDD_SAVE)
users->( dbCloseArea() )
return super:Ok()	// same as ::EndDialog(IDOK) and return 1


METHOD Cancel() CLASS UsersDialog
// don't change record
users->( dbCloseArea() )
return super:Cancel()	// same as ::EndDialog(IDCANCEL) and return 1


static function ToggleItem(oItem)
return oItem:Checked := !oItem:Checked


METHOD MenuSetup() CLASS UsersWindow

MENU IN self
    POPUP "&File"
	MENUITEM "&Open..."						    ;
	         HELP WHelp{"Open a file..."}				    ;
	         ACTION {|o| MessageBox( , "This demo uses USERS.DBF only", ;
		                        "Open", MB_ICONEXCLAMATION + MB_OK) }
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    POPUP "&View"
	MENUITEM "&User details" COMMAND Users	HELP WHelp{"View/edit user details"}
    ENDPOPUP
    POPUP "&Options"
	MENUITEM "&Font"	COMMAND Font	HELP WHelp{"Choose font"}
	MENUITEM "3&d Effects"	COMMAND Menu3d	CHECKED			;
	         HELP WHelp{"Turn 3-D effects on/off"}
	MENUITEM "&Status Bar"	CHECKED					;
	         HELP WHelp{"Turn status bar on/off"}			;
	         ACTION {|oMI| ::StatusBar:Visible := ToggleItem(oMI)}
    ENDPOPUP
    POPUP "&Help"
	MENUITEM "&About"						  ;
	         HELP WHelp{"About this application"}			  ;
	         ACTION {|| MessageBox( , "Demo written by John Skelton", ;
		                       "About", MB_ICONEXCLAMATION + MB_OK) }
    ENDPOPUP
ENDMENU

return self

