////////////////////////////
//
//	Clip-4-Win VBX class generator
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Compile and link:	c4wbuild vbxgen
//
////////////////////////////

#include "topclass.ch"
#define	WIN_WANT_ALL
#define	WIN_WANT_GETDEVCAPS
#include "windows.ch"
#include "commands.ch"
#include "vbxgen.ch"


#define	CRLF		chr(13) + chr(10)
#define	TAB		"	"

#define	PF_DTMASK	255
#define	PDT_ENUM	6

function main()
local	oApp

oApp = MyApp{"Clip-4-Win VBX Class Generator"}
oApp:oWnd:MenuSetup()

oApp:Start()

return nil


CLASS MyApp INHERIT WApp
	METHOD Create(cText)	INLINE ::oWnd := MainWindow{self, cText}
ENDCLASS


CLASS MainWindow INHERIT WSDIWindow
	METHOD Exit()		INLINE ::oApp:Quit(), self
	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              self
	METHOD MenuSetup()
	METHOD VBXNew()		INLINE VBXDialog{self, "vbxgen"}
ENDCLASS


CLASS VBXDialog INHERIT WDialog

	PROTECT hFont	AS INT

	// some Edit controls
	PROTECT	oVBXName, oPRGName, oCHName, oSource, oCHSrc

	METHOD OnNCDestroy()						;
	       INLINE DeleteObject(::hFont),				;
	              super:OnNCDestroy()

	// buttons - Ok() & Cancel() can default
	METHOD Files()
	METHOD Generate()
	METHOD Save()

	METHOD OnInitDialog()
ENDCLASS


METHOD OnInitDialog() CLASS VBXDialog
local	aFont := {-19, 0, 0, 0, 0, .F., .F., .F., 1, 0, 0, 0, 0, "Courier"}
local	hDC

hDC = GetDC(0)
aFont[1] = -C4W_Int(10 * GetDeviceCaps(hDC, LOGPIXELSY) / 72)	// 10 point
::hFont = CreateFont(aFont)
ReleaseDC(0, hDC)

@ Id IDD_VBXNAME  Obj ::oVBXName  Edit
@ Id IDD_PRGNAME  Obj ::oPRGName  Edit
@ Id IDD_CHNAME   Obj ::oCHName   Edit
@ Id IDD_SOURCE   Obj ::oSource   MultiLine Edit
@ Id IDD_CHSRC    Obj ::oCHSrc    MultiLine Edit
// or	::Add( ::oCHSrc := WMLEdit{self, IDD_CHSRC} )

SendMessage(::oSource:hWnd, WM_SETFONT, ::hFont, 0)
SendMessage(::oCHSrc:hWnd,  WM_SETFONT, ::hFont, 0)

// buttons: (Ok & Cancel can default)

@ Id IDD_FILES PushButton Files
@ Id IDD_GEN   PushButton Generate
@ Id IDD_SAVE  PushButton Save
// or	::Add( WPushButton{self, IDD_SAVE}, "Save" )
// or	::Add( WPushButton{self, IDD_SAVE},  {|| ::Save()} )
// or	::Add( WPushButton{self, IDD_SAVE}, {|oDlg, oBtn| oDlg:Save()} )
// or	@ Id IDD_SAVE  Button Save  ACTION ::Save()
//	@ Id IDD_SAVE  Button Save  ACTION {|oDlg, oBtn| oDlg:Save()}

return super:OnInitDialog()


METHOD Files() CLASS VBXDialog
local	cFile

if (cFile := GetOpenFileName(::hWnd, "*.VBX", "Select a VBX file",	;
			     {{"VBX Files (*.VBX)", "*.VBX"}})) != nil
	::oVBXName:Text = cFile
	::oPRGName:Text = substr(cFile, 1, rat('.', cFile)) + "PRG"
	::oCHName:Text = substr(cFile, 1, rat('.', cFile)) + "CH"
	::oSource:Text = ""
	//SetFocus(GetDlgItem(::hWnd, IDD_GEN))
	::Generate()
endif

return 1		// means msg has been processed


METHOD Generate() CLASS VBXDialog
local	cSource, cCHSrc, cVBX := ::oVBXName:Text
local	hVBX := LoadLibrary(cVBX)
local	nModelPtr := C4W_InitVB(hVBX), i, j, n := 0, cName, nType, cType
local	aTypes := {"ANY", "STRING", "SHORT", "INT",	; // LONG
		   "LOGIC",		;
		   "INT", "SHORT",	; // COLOR, ENUM
		   "REAL",		;
		   "LONG", "LONG",	; // XPOS, XSIZE (twips)
		   "LONG", "LONG",	; // YPOS, YSIZE (twips)
		   "STRING",		; // PICTURE
		   "STRING"}
local	cHung := "xcnnlnnnnnnncc", cVar, acEnum, aEvPInfo, cProto, c, cEnum
local	cEvHung := "nnnnnccc", cSetParams, cEvPTypes
local	hCursor := SetCursor(LoadCursor( , IDC_WAIT))

cSource := "// Generated by VBXGEN from " + cVBX + CRLF			;
	 + '#include "windows.ch"'		+ CRLF			;
	 + '#include "topclass.ch"'		+ CRLF			;
	 + '#include "commands.ch"'		+ CRLF			;
	 + 					+ CRLF			;
	 + "CLASS WVBX" + C4W_VBClassName(nModelPtr) + " INHERIT WVBXControl" ;
	 + "    // "							;
	 + iif(empty(cName := C4W_VBPClassName(nModelPtr)), "",		;
	       "Parent Class " + cName + ", ")				;
	 + "DefCtlName " + VB_DefCtlName(nModelPtr)			;
	 + 					CRLF + CRLF		;
	 + "	ACCESS ClassStyle	;"	+ CRLF			;
	 + "	       INLINE " + ltrim(str(C4W_PeekW(nModelPtr + 10))) + CRLF ;
	 + "	ACCESS WndStyle		;"	+ CRLF			;
	 + "	       INLINE " + ltrim(str(C4W_PeekL(nModelPtr + 12))) + CRLF ;
	 + CRLF

do while !empty(cName := VB_PropName(nModelPtr, ++n))
//	::MsgBox(str(VB_PropType(nModelPtr, n)), "Prop Type for: " + cName)
	nType = C4W_And(VB_PropType(nModelPtr, n), PF_DTMASK) + 1
	cType = aTypes[nType]
	cVar = substr(cHung, nType, 1)
	cSource += ;
  "	ACCESS " + cName + "	; // AS " + cType + CRLF ;
+ "	       INLINE VBXGetProp(::hCtl, "		;
+	                         str(n - 1, 3) + ")"
	if nType == PDT_ENUM + 1
		if empty(cCHSrc)
			cCHSrc = "// Generated by VBXGEN from " + cVBX + CRLF ;
			         + CRLF
		endif
		c = ""
		acEnum = VB_EnumArray(nModelPtr, n)
		if valtype(acEnum) != "A"
//			::MsgBox(str(acEnum), "VB_EnumArray for " + cName)
			acEnum = {}
		endif
		for i = 1 to len(acEnum)
			cEnum = acEnum[i]
			c += cEnum + iif(i == len(acEnum), "", ", ")
			if (j := at(" - ", cEnum)) != 0 		;
			.and. val(cEnum) == i - 1
				cEnum = substr(cEnum, j + 3)
			elseif (j := at("-", cEnum)) != 0		;
			.and. val(cEnum) == i - 1
				cEnum = substr(cEnum, j + 1)
			endif
			cEnum = "_" + strtran(cEnum, " ", "_")
			cEnum = strtran(cEnum, "-", "_")
			cCHSrc += "#define " + cName + cEnum + TAB	;
			        + ltrim(str(i - 1)) + CRLF
		next i
		cSource += "	// " + c
		cCHSrc  += CRLF
	endif
	cSource += CRLF
	cSource += ;
  "	ASSIGN " + cName + "(" + cVar + ")	; // AS " + cType + CRLF ;
+ "	       INLINE VBXSetProp(::hCtl, "				;
+	                         str(n - 1, 3) + ", "			;
+	                         cVar + "),	;"		+ CRLF	;
+ "	              " + cVar					+ CRLF
enddo
cSource += CRLF

n = 0
do while !empty(cName := VB_EvName(nModelPtr, ++n))
	cSetParams = ""
	cEvPTypes  = ""
	if valtype(aEvPInfo := VB_EvPInfo(nModelPtr, n, @cProto)) != "A"
		cSource += "	// std:" + str(aEvPInfo) + CRLF
		aEvPInfo = {}
	endif
	cSource += ;
  "	METHOD " + cName + "( ; // " + cProto + CRLF		;
+ "	       " + space(len(cName) + 2)
	for i=1 to len(aEvPInfo)
		c = left(cProto, at(",", cProto))
		c = iif(len(c) == 0, cProto, c)
		cProto = ltrim(substr(cProto, len(c) + 1))
		if at(" ", c) != 0
			c = left(c, at(" ", c) - 1)
		endif
		if at(",", c) != 0
			c = left(c, at(",", c) - 1)
		endif
//		if valtype(aEvPInfo[i]) != "N"
//			::MsgBox(tc_AsString(aEvPInfo[i]), "valtype != N")
//		endif
		cSource += iif(i == 1, "", ", ")			;
		         + iif(aEvPInfo[i] < len(cEvHung),		;
		               substr(cEvHung, aEvPInfo[i], 1), "x")	;
		         + c
		cSetParams += ", @"					;
		            + iif(aEvPInfo[i] < len(cEvHung),		;
		                  substr(cEvHung, aEvPInfo[i], 1), "x")	;
		            + c
		cEvPTypes += iif(i == 1, "", ", ")			;
		           + ltrim(str(aEvPinfo[i]))
	next i
	cSource += " )	;"			+ CRLF			;
+ "	       INLINE "							;
+	            iif(empty(cSetParams), "",				;
	                "VBXSetParams(::aVBXEventStruct, {" + cEvPTypes + "}" ;
	                             + cSetParams + "),	;" + CRLF	;
	                + "	              ")			;
+	            "NIL  // <-- Your Code Here <--" + CRLF + CRLF
enddo

cSource +=					+ CRLF			;
	 + "ENDCLASS"				+ CRLF

::oSource:Text = cSource
::oCHSrc:Text  = cCHSrc
FreeLibrary(hVBX)
SetFocus(GetDlgItem(::hWnd, IDD_SOURCE))
EditSetSel(::oSource:hWnd, 0, 0)
SetCursor(hCursor)
return 1		// means msg has been processed


METHOD Save() CLASS VBXDialog
local	cFile, i
if (cFile := GetSaveFileName(::hWnd, ::oPRGName:Text, "Save as PRG",	;
			     {{"Clip-4-Win Source (*.PRG)", "*.PRG"},	;
			      {"All Files (*.*)", "*.*"}})) != nil
	if !(upper(::oPRGName:Text) == upper(cFile))
		::oPRGName:Text = cFile
		i = iif((i := rat(".", cFile)) == 0, len(cFile), i - 1)
		::oCHName:Text = left(cFile, i) + ".CH"
	endif
	if memowrit(cFile, ::oSource:Text)
		::oParent:HelpText := "Source Saved"
	else
		::MsgBox("Unable to save!", "VBXGen", MB_ICONHAND)
	endif

	if ::oCHName:Text == ""
		i = iif((i := rat(".", cFile)) == 0, len(cFile), i - 1)
		::oCHName:Text = left(cFile, i) + ".CH"
	endif
	if (cFile := GetSaveFileName(::hWnd, ::oCHName:Text, "Save as CH",  ;
				     {{"Clip-4-Win Header (*.CH)", "*.CH"}, ;
				      {"All Files (*.*)", "*.*"}})) != nil
		if memowrit(cFile, ::oCHSrc:Text)
			::oParent:HelpText := "Header Saved"
		else
			::MsgBox("Unable to save!", "VBXGen", MB_ICONHAND)
		endif
	endif
endif
return 1		// means msg has been processed


METHOD MenuSetup() CLASS MainWindow

MENU IN self
    POPUP "&File"
	MENUITEM "&New VBX..."	COMMAND VBXNew	HELP WHelp{"Examine a VBX"}
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit	HELP WHelp{"Exit the application"}
    ENDPOPUP
    POPUP "&Help"
	MENUITEM "&About"					 	  ;
	         HELP WHelp{"About this application"}			  ;
	         ACTION {|| MessageBox( , "Demo written by John Skelton", ;
		                       "About", MB_ICONEXCLAMATION + MB_OK) }
    ENDPOPUP
ENDMENU

return self

