////////////////////////////
//
//	Clip-4-Win PickList using BListBox sample
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Compile and link:	c4wbuild picklist
//
////////////////////////////

#define	WIN_WANT_LBS
#include "windows.ch"
#define	NO_C4WCLASS
#include "commands.ch"
#include "inkey.ch"

#define	CR		chr(13)

#define	IDD_BROWSE	101
#define	IDD_SAY		102
#define	IDD_SEEK	103


static cUserID
static cScan
static oSeek
static oB
static nArea
static nPickRec

function main()
local	oApp, oWnd

CREATE APPLICATION oApp  WINDOW oWnd					;
	TITLE "Clip-4-Win PickList using BListBox Demo"			;
	ON INIT MenuSetup(oWnd)

return nil


static function Browse()
local	cAlias, aDlg, nRet
local	aCols :=							;
{									;
	{"UserID",   {|| (nArea)->UserID  }, , , , , 100},		;
	{"UserName", {|| (nArea)->UserName}, , , , , 250}		;
}

cScan = ""

USE users NEW SHARED
nArea    = Select()
cAlias   = Alias()
if !file(cAlias + ".NTX")
	(nArea)->( dbCreateIndex(cAlias, "USERID", {|| (nArea)->UserID}) )
else
	(nArea)->( dbSetIndex(cAlias) )
endif

CREATE DIALOG aDlg							;
	Title "Browse In Dialog"					;
	Style DS_MODALFRAME + WS_POPUP + WS_CHILD + WS_VISIBLE + WS_CAPTION ;
	At 20,20  Size 250,160

@ Id IDD_BROWSE  Obj oB  BListBox					;
                 Columns aCols  Alias cAlias    At 10,10  Size 180,140
@ Id IDOK        Button  OnOk   Title "&Ok"     At 200,10 Size 40,14
@ Id IDCANCEL    Button         Title "&Cancel" At 200,28 Size 40,14
@ Id IDD_SAY     Say "Search for:"              At 200,56 Size 40,14
@ Id IDD_SEEK    Say ""                         At 210,68 Size 40,14

SHOW DIALOG aDlg							;
	ON INIT {|hDlg| OnInitDialog(hDlg)}				;
	RESULT nRet

if nRet == IDOK
	(nArea)->( dbGoto(nPickRec) )
	MessageBox( , "Record:" + str(nPickRec) + chr(13)		;
	              + "User: " + (nArea)->UserName, "Result")
endif

USE

return nil


static function OnInitDialog(hDlg)
oB:KeyBlock = {|oB, nMsg, nKey, nl|					;
               iif(nKey == K_BS, (Scan(chr(K_BS), hDlg), .t.), .f.)}
oB:ScanBlock = {|oB, cKey| Scan(cKey, hDlg)}
return 1


static function Scan(cKey, hDlg)
local	nKey := asc(cKey)
if nKey == K_BS
	cScan = left(cScan, len(cScan) - 1)
	cKey = ""
endif
if (nArea)->( dbSeek(cScan + cKey, .t.) )
	cScan += cKey
else
	MessageBeep()	// signal not found & ignore key
	if (nArea)->( Eof() )
		(nArea)->( dbSkip(-1) )
	endif
endif

SetWindowText(GetDlgItem(hDlg, IDD_SEEK), cScan)

// WARNING: NTX only!!  In 5.3, use OrdKeyNo() or dbOrderInfo(DBOI_POSITION).
oB:nCurRec = NtxPos((nArea)->(IndexOrd()), (nArea)->(RecNo()))

oB:RowPos = min(oB:nCurRec, 4)
oB:nCRecNo = (nArea)->( RecNo() )
oB:HitTop  = (nArea)->( Bof() )
oB:HitBottom = (nArea)->( Eof() )
oB:ShowData()		// or oB:RefreshAll()
return nil


static function OnOk(hDlg)
nPickRec = oB:nCRecNo
return nil


static function MenuSetup(oWnd)

MENU IN oWnd
    POPUP "&File"
	MENUITEM "&BListBox Browse"					;
		 COMMAND Browse
//	MENUITEM "BListBox Browse - &Resource"				;
//		 COMMAND BrowseRes
	MENUITEM SEPARATOR
	MENUITEM "E&xit"	COMMAND Exit
    ENDPOPUP
    POPUP "&Help"
	MENUITEM "&About"	COMMAND About
    ENDPOPUP
ENDMENU

return nil


static function About()
MessageBox( , "Nothing interesting yet!", "Demo")
return nil


static function Exit()
PostQuitMessage(0)
return nil

