////////////////////////////
//
//	Clip-4-Win scrollbar demo
//
//	Copyright (C) 1992 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//
//	Compile:	scrollbar /n /w
//	Link:		/se:600 scrollbar winsetup,,,,clip4win.def
//
////////////////////////////


#include "windows.ch"


// these need to be different so we know which scrollbar was selected
#define	VBAR	1
#define	HBAR	2

#define	nstr(i)	 alltrim(str(i))


static	hWnd, hInst, hPrevInst, nCmdShow
static	cAppName := "Clip-4-Win"


function main()
local	hVScrollBar, hHScrollBar
local	ev, nScrollBar, nScrollCmd
local	n, nVPos := 0, nHPos := 0
local	hDC

hWnd = WinSetup(cAppName, "Clip-4-Win scrollbar demo")
hInst = _GetInstance()
HideCaret(hWnd)

hVScrollBar = CreateWindow("scrollbar",		;	// scrollbar class name
			   "VScrollBar",	;	// title text
			   WS_CHILD		;	// child window
			   + WS_VISIBLE		;	// ... that can be seen
			   + SBS_VERT,		;	// ... vert scrollbar
			   400, 50,		;	// x,y position
			   25, 200,		;	// width, height
			   hWnd,		;	// parent window
			   VBAR,		;	// unique child id
			   hInst)			// parent's instance

hHScrollBar = CreateWindow("scrollbar",		;	// scrollbar class name
			   "HScrollBar",	;	// title text
			   WS_CHILD		;	// child window
			   + WS_VISIBLE		;	// ... that can be seen
			   + SBS_HORZ, 		;	// ... horiz scrollbar
			   100, 250,		;	// x,y position
			   300, 25,		;	// width, height
			   hWnd,		;	// parent window
			   HBAR,		;	// unique child id
			   hInst)			// parent's instance

SetScrollRange(hVScrollBar, SB_CTL, 0, 100, .F.)	// range 0..100
SetScrollRange(hHScrollBar, SB_CTL, 0, 100, .F.)
SetFocus(hVScrollBar)

do while .t.
	do while (ev := ChkEvent()) == EVENT_NONE
	enddo

	do case
	case ev == EVENT_HSCROLL

		nScrollCmd = _lastwParam()	// from Windows

		n = nHPos		// current position
		do case
		case nScrollCmd == SB_LEFT
			n = 0
		case nScrollCmd == SB_RIGHT
			n = 100
		case nScrollCmd == SB_LINERIGHT
			n = min(n + 1, 100)
		case nScrollCmd == SB_PAGERIGHT
			n = min(n + 10, 100)
		case nScrollCmd == SB_LINELEFT
			n = max(n - 1, 0)
		case nScrollCmd == SB_PAGELEFT
			n = max(n - 10, 0)
		case nScrollCmd == SB_THUMBPOSITION	;
		.or. nScrollCmd == SB_THUMBTRACK
			n = _lastlolParam()	// from Windows
		case nScrollCmd == SB_ENDSCROLL
			// ignore
		endcase
		nHPos = n

		SetScrollPos(hHScrollBar, SB_CTL, n, .t.)

		hDC = GetDC(hWnd)
		TextOut(hDC, 10, 10, "horiz" + str(nHPos) + " ")
		ReleaseDC(hWnd, hDC)

	case ev == EVENT_VSCROLL

		nScrollCmd = _lastwParam()

		n = nVPos		// current position
		do case
		case nScrollCmd == SB_TOP
			n = 0
		case nScrollCmd == SB_BOTTOM
			n = 100
		case nScrollCmd == SB_LINEDOWN
			n = min(n + 1, 100)
		case nScrollCmd == SB_PAGEDOWN
			n = min(n + 10, 100)
		case nScrollCmd == SB_LINEUP
			n = max(n - 1, 0)
		case nScrollCmd == SB_PAGEUP
			n = max(n - 10, 0)
		case nScrollCmd == SB_THUMBPOSITION	;
		.or. nScrollCmd == SB_THUMBTRACK
			n = _lastlolParam()	// from Windows
		case nScrollCmd == SB_ENDSCROLL
			// ignore
		endcase
		nVPos = n

		SetScrollPos(hVScrollBar, SB_CTL, n, .t.)

		hDC = GetDC(hWnd)
		TextOut(hDC, 10, 30, "vert" + str(nVPos) + " ")
		ReleaseDC(hWnd, hDC)
	endcase
enddo

return 0


