////////////////////////////
//
//	Clip-4-Win Users form view demo  (using dialog Gets)
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	This one uses NO resource file.  But source\usersres\userscmd.prg does.
//
//	Compile and link:	c4wbuild userscmd
//
//	NOTE: Some people have whether they can distribute CTL3D.DLL
//	      with their apps.  Yes.  Say thanks to Microsoft.  They
//	      want you to use it because it provides the sort of
//	      appearance that's going to be standard in future versions
//	      of Windows.
//
////////////////////////////

#define	WIN_WANT_ALL
#include "windows.ch"
#include "font.ch"
#include "dialog.ch"
#include "users.ch"
#define	NO_C4WCLASS
#include "commands.ch"


static	cAppName := "Users"
static	hWnd
static	cFontName := "MS Sans Serif"
static	nPointSize := 8


function main()
local	hApp

CREATE APPLICATION hApp  WINDOW hWnd					;
    TITLE "Clip-4-Win Users Demo"					;
    ON INIT MenuSetup()							;
    ON EXIT DoExit()

return nil


static procedure DoAbout()
MessageBox( , "Demo written by John Skelton", "About", ;
	       MB_ICONEXCLAMATION + MB_OK)
return


static procedure DoOpen()
MessageBox(0 , "This demo uses USERS.DBF only", cAppName, ;
	       MB_ICONEXCLAMATION + MB_OK)
return


static procedure DoFont()
local	aFont[14], nPt
aFont[LF_FaceName] = cFontName
aFont[LF_Height] = nPointSize * 4 / 3	// I don't know why this is needed!
if ChooseFont(aFont, @nPt) != nil
	cFontName = aFont[LF_FaceName]
	// the returned value is in tenths of a point
	nPointSize = nPt / 10
endif
return


procedure DoExit()
MessageBox(0, "Thanks for running this Clip-4-Win demo!", cAppName, ;
	   MB_ICONHAND + MB_OK)
PostQuitMessage(0)
return


// This demonstrates stepping through a DBF file.

function DoUsers()
local	GetList
local	cUserID, cUserName, cDept, cPhone, cExt
local	oUserID, oUserName, oDept, oPhone, oExt
// these are tiny functions/procedures to make the code shorter:
local	bScatter := {|| cUserID   := users->UserID,	;
			cUserName := users->UserName,	;
			cDept     := users->Department,	;
			cPhone    := users->Phone,	;
			cExt      := users->Extension }
local	bGather := {||	users->UserID     := cUserID,	;
			users->UserName   := cUserName,	;
			users->Department := cDept,	;
			users->Phone      := cPhone,	;
			users->Extension  := cExt }
local	bUpdate := {|hWndDlg|					;
			oUserID   :killFocus()			;
				  :varPut( users->UserID     ),	;
			oUserName :killFocus()			;
				  :varPut( users->UserName   ),	;
			oDept     :killFocus()			;
				  :varPut( users->Department ),	;
			oPhone    :killFocus()			;
				  :varPut( users->Phone      ),	;
			oExt      :killFocus()			;
				  :varPut( users->Extension  ),	;
			; // See GETSYS.PRG for the function DReadSetInfo().
			; // The idea here is to tell the GET system that the
			; // data has changed.
			DReadSetInfo(hWndDlg, IDD_USERID,   GetList, 1), ;
			DReadSetInfo(hWndDlg, IDD_USERNAME, GetList, 2), ;
			DReadSetInfo(hWndDlg, IDD_DEPT,     GetList, 3), ;
			DReadSetInfo(hWndDlg, IDD_PHONE,    GetList, 4), ;
			DReadSetInfo(hWndDlg, IDD_EXT,      GetList, 5)  }
local	i, aDlg

CREATE DIALOG aDlg  TITLE "User Details"				  ;
    STYLE DS_MODALFRAME + WS_POPUP + WS_VISIBLE + WS_CAPTION + WS_SYSMENU ;
    AT 20,20  SIZE 183, 127  FONT cFontName  POINTSIZE nPointSize

@ ID IDOK      BUTTON UserDone          TEXT "&Ok"       AT 132,13  SIZE 37,12
@ ID IDCANCEL  BUTTON UserDone          TEXT "&Cancel"   AT 132,37  SIZE 37,12
@ ID IDD_NEXT  BUTTON UserNext(bUpdate) TEXT "&Next"     AT 132,61  SIZE 37,12
@ ID IDD_PREV  BUTTON UserPrev(bUpdate) TEXT "&Previous" AT 132,85  SIZE 37,12
@ ID IDD_SAVE  BUTTON UserSave(bGather) TEXT "&Save"     AT 132,109 SIZE 37,12

@ ID IDD_TUSERID    SAY  "User &ID:"    AT 7,2  SIZE 50,8
@ ID IDD_USERID     EDIT                AT 7,13  SIZE 115,13

@ ID IDD_TUSERNAME  SAY  "&User Name:"  AT 7,28  SIZE 50,8
@ ID IDD_USERNAME   EDIT                AT 7,37  SIZE 115,13

@ ID IDD_TDEPT      SAY  "&Department:" AT 7,52  SIZE 50,8
@ ID IDD_DEPT       EDIT                AT 7,61  SIZE 115,13

@ ID IDD_TPHONE     SAY  "P&hone:"      AT 7,76  SIZE 50,8
@ ID IDD_PHONE      EDIT                AT 7,85  SIZE 115,13

@ ID IDD_T_EXT      SAY  "&Extension:"  AT 7,100  SIZE 50,8
@ ID IDD_EXT        EDIT                AT 7,109  SIZE 115,13

SHOW DIALOG aDlg  RESULT i						;
    ON INIT {|hWndDlg| UserOnInit(hWndDlg, bScatter, @GetList,		;
                          @cUserID, @cUserName, @cDept, @cPhone, @cExt,	;
                          @oUserID, @oUserName, @oDept, @oPhone, @oExt)}

if i == 0
	// MessageBox( , "Cancelled", cAppName)
endif
return nil


static function UserOnInit(hWndDlg, bScatter, GetList,			;
                           cUserID, cUserName, cDept, cPhone, cExt,	;
                           oUserID, oUserName, oDept, oPhone, oExt)
use users new shared
users->( dbGoTop() )

eval(bScatter)		// fetch fields to static vars

/////////////
//
//  The code below does validation using GET objects.
//
//  The objects need to be saved because we want to change
//  them as we move from record to record.
//
/////////////

GetList = {}
//cUserID = space(8)
@ dialog hWndDlg id IDD_USERID   get cUserID
oUserID = ATail(GetList)
@ dialog hWndDlg id IDD_USERNAME get cUserName				;
         WHEN iif(len(ltrim(cUserID)) != 0, .t.,			;
                  (PostMessage(hWndDlg, WM_NEXTDLGCTL, 0, 0), .t.))
oUserName = ATail(GetList)
@ dialog hWndDlg id IDD_DEPT     get cDept
oDept = ATail(GetList)
@ dialog hWndDlg id IDD_PHONE    get cPhone
oPhone = ATail(GetList)
@ dialog hWndDlg id IDD_EXT      get cExt	picture "9999" ;
//				WHEN val(cExt) > 1001
oExt = ATail(GetList)
return nil


static function UserDone(hWndDlg, hCtrl, nCode, nId)
// don't change record (it's only done if SAVE button pressed, i.e. IDD_SAVE)
CANCEL DIALOG hWndDlg		// cancel any GETs
close users
return nil


static function UserNext(bUpdate, hWndDlg, hCtrl, nCode, nId)

// Don't define NOT_DEFINED !!!   (It's just used for commenting)

#ifdef NOT_DEFINED	// this is to avoid using /* ... */ over many lines
			// which causes problems if you have another
			// /* ... */ comment within the code

/*
 *  This code is commented out because it's NOT the
 *  way to do it!!  You're not closing the dialog.
 *  You're just moving to a new record.  If you use
 *  this code you get very confused edit controls.
 */

	// need to cancel current GETs, skip, and re-issue them

	CANCEL DIALOG hWndDlg		// cancel any GETs

	users->( dbSkip(1) )
	if users->( Eof() )
		users->( dbGoBottom() )
	endif

	eval(bScatter)		// fetch fields to static vars

	GetList = {}
	@ dialog hWndDlg id IDD_USERID   get cUserID
	@ dialog hWndDlg id IDD_USERNAME get cUserName
	@ dialog hWndDlg id IDD_DEPT     get cDept
	@ dialog hWndDlg id IDD_PHONE    get cPhone
	@ dialog hWndDlg id IDD_EXT      get cExt	picture "9999"
#else
	/*
	 *  Here's how to make moving to a different record work.
	 */

	// need to skip, then update GETs

	users->( dbSkip(1) )
	if users->( Eof() )
		users->( dbGoBottom() )
	endif

	eval(bUpdate, hWndDlg)	// update the GETs and vars

#endif // NOT_DEFINED
return nil


static function UserPrev(bUpdate, hWndDlg, hCtrl, nCode, nId)

// need to skip, then update GETs

users->( dbSkip(-1) )
if users->( Bof() )
	users->( dbGoTop() )
endif

eval(bUpdate, hWndDlg)	// update the GETs and vars

return nil


static function UserSave(bGather, hWndDlg, hCtrl, nCode, nId)
if IsDialogOK(hWndDlg, nId)
	users->( RLock() )
	eval(bGather)	// update the fields from the vars
	users->( dbUnlock() )
endif
return nil


static procedure Menu3dUpdate()
local cItem := "o_3d", hMenu := GetMenu(hWnd)    // get main menu
CheckMenuItem(hMenu, cItem, iif(Ctl3d(), MF_CHECKED, MF_UNCHECKED))
return


static procedure DoMenu3d(cItem)
local hMenu := GetMenu(hWnd)			// get main menu
local nCheck := CheckMenuItem(hMenu, cItem)	// current state
Ctl3d(nCheck != MF_CHECKED)			// want opposite of current
Menu3dUpdate()
return


static function MenuSetup()
local	hWnd := SelectWindow(), hMenu

// Ampersand (&) indicates the trigger letter (accelerator key).
// You don't need to use ID <x>, unless you later want to refer to the
//      menu item - e.g. to enable/disable/gray/check/uncheck it.

MENU hMenu IN hWnd
    POPUP "&File"  // ID "file"
        MENUITEM "&Open..."     ACTION DoOpen()          // ID "f_open"
        MENUITEM SEPARATOR
        MENUITEM "E&xit"        ACTION DoExit()          // ID "f_exit"
    ENDPOPUP
    POPUP "&View"  // ID "view"
        MENUITEM "&User details"  ACTION DoUsers()       // ID "v_users"
    ENDPOPUP
    POPUP "&Options"  // ID "options"
        MENUITEM "&Font"        ACTION DoFont()          // ID "o_font"
        MENUITEM "3&d Effects"  ACTION {|c| DoMenu3d(c)}  ID "o_3d"
    ENDPOPUP
    POPUP "&Help"  // ID "help"
        MENUITEM "&About"       ACTION DoAbout()         // ID "h_about"
    ENDPOPUP
ENDMENU

Menu3dUpdate()
return hMenu

