////////////////////////////
//
//	Clip-4-Win Users form view demo  (using dialog Gets)
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	This one uses a resource file.  But source\users\userscmd.prg does not.
//
//	Compile and link:	rmake userscmd
//
//	NOTE: Some people have whether they can distribute CTL3D.DLL
//	      with their apps.  Yes.  Say thanks to Microsoft.  They
//	      want you to use it because it provides the sort of
//	      appearance that's going to be standard in future versions
//	      of Windows.
//
//	NOTE: To understand the usage of the dialog resources, you
//	need to look closely at the USERSRES.RC file.  It defines
//	a dialog called "dlguser", containing
//	various controls.  The file is as follows:
/*

//#define WIN_WANT_CB
//#define WIN_WANT_LBS
#include "windows.ch"
#include "usersres.ch"

dlguser DIALOG 20, 20, 183, 127
STYLE DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
CAPTION "User Details"
FONT 10, "MS Sans Serif"
BEGIN
    PUSHBUTTON      "&Ok", IDOK, 132, 13, 37, 12
    PUSHBUTTON      "&Cancel", IDCANCEL, 132, 37, 37, 12
    PUSHBUTTON      "&Next", IDD_NEXT, 132, 61, 37, 12
    PUSHBUTTON      "&Previous", IDD_PREV, 132, 85, 37, 12
    PUSHBUTTON      "&Save", IDD_SAVE, 132, 109, 37, 12
    LTEXT           "User &ID:", IDD_TUSERID, 7, 2, 50, 8
    EDITTEXT        IDD_USERID, 7, 13, 115, 13, ES_AUTOHSCROLL
    LTEXT           "&User Name:", IDD_TUSERNAME, 7, 28, 50, 8
    EDITTEXT        IDD_USERNAME, 7, 37, 115, 13, ES_AUTOHSCROLL
    LTEXT           "&Department:", IDD_TDEPT, 7, 52, 50, 8
    EDITTEXT        IDD_DEPT, 7, 61, 115, 13, ES_AUTOHSCROLL
    LTEXT           "P&hone:", IDD_TPHONE, 7, 76, 50, 8
    EDITTEXT        IDD_PHONE, 7, 85, 115, 13, ES_AUTOHSCROLL
    LTEXT           "&Extension:", IDD_T_EXT, 7, 100, 50, 8
    EDITTEXT        IDD_EXT, 7, 109, 115, 13, ES_AUTOHSCROLL
END

*/
//
////////////////////////////

#define	WIN_WANT_ALL
#define	WIN_WANT_GETDEVCAPS
#include "windows.ch"
#include "font.ch"
#include "dialog.ch"
#include "usersres.ch"
#define	NO_C4WCLASS
#include "commands.ch"


static	cAppName := "Users"
static	hWnd
static	cFontName := "MS Sans Serif"
static	nPointSize := 8


function main()
local	hApp

CREATE APPLICATION hApp  WINDOW hWnd					;
    TITLE "Clip-4-Win Users Demo"					;
    ON INIT MenuSetup()							;
    ON EXIT DoExit()

return nil


static procedure DoAbout()
MessageBox( , "Demo written by John Skelton", "About", ;
	       MB_ICONEXCLAMATION + MB_OK)
return


static procedure DoOpen()
MessageBox(0 , "This demo uses USERS.DBF only", cAppName, ;
	       MB_ICONEXCLAMATION + MB_OK)
return


static procedure DoFont()
local	aFont[14], nPt, hDC := GetDC(hWnd)
aFont[LF_FaceName] = cFontName
// the following scales the font from point size to screen size:
aFont[LF_Height] = - GetDeviceCaps(hDC, LOGPIXELSY) * nPointSize / 72
ReleaseDC(hWnd, hDC)
if ChooseFont(aFont, @nPt) != nil
	cFontName = aFont[LF_FaceName]
	// the returned value is in tenths of a point
	nPointSize = nPt / 10
endif
return


procedure DoExit()
MessageBox(0, "Thanks for running this Clip-4-Win demo!", cAppName, ;
	   MB_ICONHAND + MB_OK)
PostQuitMessage(0)
return


// This demonstrates stepping through a DBF file.

function DoUsers()
local	GetList
local	cUserID, cUserName, cDept, cPhone, cExt
local	oUserID, oUserName, oDept, oPhone, oExt
// these are tiny functions/procedures to make the code shorter:
local	bScatter := {|| cUserID   := users->UserID,	;
			cUserName := users->UserName,	;
			cDept     := users->Department,	;
			cPhone    := users->Phone,	;
			cExt      := users->Extension }
local	bGather := {||	users->UserID     := cUserID,	;
			users->UserName   := cUserName,	;
			users->Department := cDept,	;
			users->Phone      := cPhone,	;
			users->Extension  := cExt }
local	bUpdate := {|hWndDlg|					;
			oUserID   :killFocus()			;
				  :varPut( users->UserID     ),	;
			oUserName :killFocus()			;
				  :varPut( users->UserName   ),	;
			oDept     :killFocus()			;
				  :varPut( users->Department ),	;
			oPhone    :killFocus()			;
				  :varPut( users->Phone      ),	;
			oExt      :killFocus()			;
				  :varPut( users->Extension  ),	;
			; // See GETSYS.PRG for the function DReadSetInfo().
			; // The idea here is to tell the GET system that the
			; // data has changed.
			DReadSetInfo(hWndDlg, IDD_USERID,   GetList, 1), ;
			DReadSetInfo(hWndDlg, IDD_USERNAME, GetList, 2), ;
			DReadSetInfo(hWndDlg, IDD_DEPT,     GetList, 3), ;
			DReadSetInfo(hWndDlg, IDD_PHONE,    GetList, 4), ;
			DReadSetInfo(hWndDlg, IDD_EXT,      GetList, 5)  }
local	i, aDlg

CREATE DIALOG aDlg  RESOURCE "dlguser"

@ ID IDOK      BUTTON UserDone
@ ID IDCANCEL  BUTTON UserDone
@ ID IDD_NEXT  BUTTON UserNext(bUpdate)
@ ID IDD_PREV  BUTTON UserPrev(bUpdate)
@ ID IDD_SAVE  BUTTON UserSave(bGather)

// with just the clauses shown, these aren't needed (the resource is enough):
@ ID IDD_USERID     EDIT
@ ID IDD_USERNAME   EDIT
@ ID IDD_DEPT       EDIT
@ ID IDD_PHONE      EDIT
@ ID IDD_EXT        EDIT

SHOW DIALOG aDlg  RESULT i						;
    ON INIT {|hWndDlg| UserOnInit(hWndDlg, bScatter, @GetList,		;
                          @cUserID, @cUserName, @cDept, @cPhone, @cExt,	;
                          @oUserID, @oUserName, @oDept, @oPhone, @oExt)}

if i == 0
	// MessageBox( , "Cancelled", cAppName)
endif
return nil


static function UserOnInit(hWndDlg, bScatter, GetList,			;
                           cUserID, cUserName, cDept, cPhone, cExt,	;
                           oUserID, oUserName, oDept, oPhone, oExt)
use users new shared
users->( dbGoTop() )

eval(bScatter)		// fetch fields to static vars

/////////////
//
//  The code below does validation using GET objects.
//
//  The objects need to be saved because we want to change
//  them as we move from record to record.
//
/////////////

GetList = {}
//cUserID = space(8)
@ dialog hWndDlg id IDD_USERID   get cUserID
oUserID = ATail(GetList)
@ dialog hWndDlg id IDD_USERNAME get cUserName				;
         WHEN iif(len(ltrim(cUserID)) != 0, .t.,			;
         	  (PostMessage(hWndDlg, WM_NEXTDLGCTL, 0, 0), .t.))
oUserName = ATail(GetList)
@ dialog hWndDlg id IDD_DEPT     get cDept
oDept = ATail(GetList)
@ dialog hWndDlg id IDD_PHONE    get cPhone
oPhone = ATail(GetList)
@ dialog hWndDlg id IDD_EXT      get cExt	picture "9999" ;
//				WHEN val(cExt) > 1001
oExt = ATail(GetList)
return nil


static function UserDone(hWndDlg, hCtrl, nCode, nId)
// don't change record (it's only done if SAVE button pressed, i.e. IDD_SAVE)
CANCEL DIALOG hWndDlg		// cancel any GETs
close users
return nil


static function UserNext(bUpdate, hWndDlg, hCtrl, nCode, nId)

// Don't define NOT_DEFINED !!!   (It's just used for commenting)

#ifdef NOT_DEFINED	// this is to avoid using /* ... */ over many lines
			// which causes problems if you have another
			// /* ... */ comment within the code

/*
 *  This code is commented out because it's NOT the
 *  way to do it!!  You're not closing the dialog.
 *  You're just moving to a new record.  If you use
 *  this code you get very confused edit controls.
 */

	// need to cancel current GETs, skip, and re-issue them

	CANCEL DIALOG hWndDlg		// cancel any GETs

	users->( dbSkip(1) )
	if users->( Eof() )
		users->( dbGoBottom() )
	endif

	eval(bScatter)		// fetch fields to static vars

	GetList = {}
	@ dialog hWndDlg id IDD_USERID   get cUserID
	@ dialog hWndDlg id IDD_USERNAME get cUserName
	@ dialog hWndDlg id IDD_DEPT     get cDept
	@ dialog hWndDlg id IDD_PHONE    get cPhone
	@ dialog hWndDlg id IDD_EXT      get cExt	picture "9999"
#else
	/*
	 *  Here's how to make moving to a different record work.
	 */

	// need to skip, then update GETs

	users->( dbSkip(1) )
	if users->( Eof() )
		users->( dbGoBottom() )
	endif

	eval(bUpdate, hWndDlg)	// update the GETs and vars

#endif // NOT_DEFINED
return nil


static function UserPrev(bUpdate, hWndDlg, hCtrl, nCode, nId)

// need to skip, then update GETs

users->( dbSkip(-1) )
if users->( Bof() )
	users->( dbGoTop() )
endif

eval(bUpdate, hWndDlg)	// update the GETs and vars

return nil


static function UserSave(bGather, hWndDlg, hCtrl, nCode, nId)
if IsDialogOK(hWndDlg, nId)
	users->( RLock() )
	eval(bGather)	// update the fields from the vars
	users->( dbUnlock() )
endif
return nil


static procedure Menu3dUpdate()
local cItem := "o_3d", hMenu := GetMenu(hWnd)    // get main menu
CheckMenuItem(hMenu, cItem, iif(Ctl3d(), MF_CHECKED, MF_UNCHECKED))
return


static procedure DoMenu3d(cItem)
local hMenu := GetMenu(hWnd)    		// get main menu
local nCheck := CheckMenuItem(hMenu, cItem)	// current state
Ctl3d(nCheck != MF_CHECKED)			// want opposite of current
Menu3dUpdate()
return


static function MenuSetup()
local	hWnd := SelectWindow(), hMenu

// Ampersand (&) indicates the trigger letter (accelerator key).
// You don't need to use ID <x>, unless you later want to refer to the
//      menu item - e.g. to enable/disable/gray/check/uncheck it.

MENU hMenu IN hWnd
    POPUP "&File"  // ID "file"
        MENUITEM "&Open..."     ACTION DoOpen()          // ID "f_open"
        MENUITEM SEPARATOR
        MENUITEM "E&xit"        ACTION DoExit()          // ID "f_exit"
    ENDPOPUP
    POPUP "&View"  // ID "view"
        MENUITEM "&User details"  ACTION DoUsers()       // ID "v_users"
    ENDPOPUP
    POPUP "&Options"  // ID "options"
        MENUITEM "&Font"        ACTION DoFont()          // ID "o_font"
        MENUITEM "3&d Effects"  ACTION {|c| DoMenu3d(c)}  ID "o_3d"
    ENDPOPUP
    POPUP "&Help"  // ID "help"
        MENUITEM "&About"       ACTION DoAbout()         // ID "h_about"
    ENDPOPUP
ENDMENU

Menu3dUpdate()
return hMenu

