////////////////////////////
//
//	Clip-4-Win Users form view demo  (using dialog Gets)
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	This one uses a resource file.  But source\users\users.prg does not.
//
//	Compile and link:	rmake usersres
//
//	NOTE: Some people have whether they can distribute CTL3D.DLL
//	      with their apps.  Yes.  Say thanks to Microsoft.  They
//	      want you to use it because it provides the sort of
//	      appearance that's going to be standard in future versions
//	      of Windows.
//
//	NOTE: To understand the usage of the dialog resources, you
//	need to look closely at the USERSRES.RC file.  It defines
//	a dialog called "dlguser", containing
//	various controls.  The file is as follows:
/*

//#define WIN_WANT_CB
//#define WIN_WANT_LBS
#include "windows.ch"
#include "usersres.ch"

dlguser DIALOG 20, 20, 183, 127
STYLE DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
CAPTION "User Details"
FONT 10, "MS Sans Serif"
BEGIN
    PUSHBUTTON      "&Ok", IDOK, 132, 13, 37, 12
    PUSHBUTTON      "&Cancel", IDCANCEL, 132, 37, 37, 12
    PUSHBUTTON      "&Next", IDD_NEXT, 132, 61, 37, 12
    PUSHBUTTON      "&Previous", IDD_PREV, 132, 85, 37, 12
    PUSHBUTTON      "&Save", IDD_SAVE, 132, 109, 37, 12
    LTEXT           "User &ID:", IDD_TUSERID, 7, 2, 50, 8
    EDITTEXT        IDD_USERID, 7, 13, 115, 13, ES_AUTOHSCROLL
    LTEXT           "&User Name:", IDD_TUSERNAME, 7, 28, 50, 8
    EDITTEXT        IDD_USERNAME, 7, 37, 115, 13, ES_AUTOHSCROLL
    LTEXT           "&Department:", IDD_TDEPT, 7, 52, 50, 8
    EDITTEXT        IDD_DEPT, 7, 61, 115, 13, ES_AUTOHSCROLL
    LTEXT           "P&hone:", IDD_TPHONE, 7, 76, 50, 8
    EDITTEXT        IDD_PHONE, 7, 85, 115, 13, ES_AUTOHSCROLL
    LTEXT           "&Extension:", IDD_T_EXT, 7, 100, 50, 8
    EDITTEXT        IDD_EXT, 7, 109, 115, 13, ES_AUTOHSCROLL
END

*/
//
////////////////////////////

#define	WIN_WANT_ALL
#define	WIN_WANT_GETDEVCAPS
#include "windows.ch"
#include "font.ch"
#include "dialog.ch"
#include "usersres.ch"


#define	CR	chr(13)


static	cAppName := "UsersRes"
static	hWnd
static	cFontName := "MS Sans Serif"
static	nPointSize := 8
static	hLibCtl3d


function main()
local	hMenu, nEvent

set scoreboard off
SetColor("n/w,+w/n,+w,+w,+w/n")
hWnd = WinSetup(cAppName, "Clip-4-Win Users (Resource) Demo")
hMenu = MenuSetup()
Ctl3d(.t.)			// default to 3D controls
HideCaret(hWnd)
AddHandler(hWnd, {|nEvent| MainEvent(nEvent)})

do while .t.
   do while (nEvent := ChkEvent()) == EVENT_NONE
   enddo
   HandleEvent(nEvent)
   if nEvent == EVENT_QUIT
	DoExit()
   endif
enddo
return nil



static procedure MainEvent(nEvent)
return


static procedure DoAbout()
MessageBox( , "Demo written by John Skelton", "About", ;
	       MB_ICONEXCLAMATION + MB_OK)
return


static procedure DoOpen()
MessageBox(0 , "This demo uses USERS.DBF only", "Open", ;
	       MB_ICONEXCLAMATION + MB_OK)
return


static procedure DoFont()
local	aFont[14], nPt, hDC := GetDC(hWnd)
aFont[LF_FaceName] = cFontName
// the following scales the font from point size to screen size:
aFont[LF_Height] = - GetDeviceCaps(hDC, LOGPIXELSY) * nPointSize / 72
ReleaseDC(hWnd, hDC)
if ChooseFont(aFont, @nPt) != nil
	cFontName = aFont[LF_FaceName]
	// the returned value is in tenths of a point
	nPointSize = nPt / 10
endif
return


procedure DoExit(c)
MessageBox(0, "Thanks for running this Clip-4-Win demo!", "Exiting", ;
	   MB_ICONHAND + MB_OK)
Ctl3d(.f.)			// stop using 3D controls
if IsWindow(hWnd)
	DestroyWindow(hWnd)
endif
UnregisterClass(cAppName)
quit
return



function DoUsers()
local	i

// This demonstrates stepping through a DBF file.  It doesn't
// return anything much, but if you wanted just to have a
// dialog for a single set of values (and return any alterations),
// pass them by reference (i.e. @cVar) in the code block below,
// (_after_ lparam makes most sense).

i = DialogBox( ,"dlguser" , hWnd,			;
		{|hDlg, msg, wparam, lparam|		;
		 UserDlgModal(hDlg, msg, wparam, lparam)})
if i == -1
	MessageBox( , "Did you forget to add the resources to the EXE?", "Error")
endif

if i == IDCANCEL
	// MessageBox( , "Results ignored", "Cancel")
endif
return nil




function UserDlgModal(hWndDlg, nMsg, nwParam, nlParam)
static	GetList
static	cUserID, cUserName, cDept, cPhone, cExt
static	oUserID, oUserName, oDept, oPhone, oExt
// these are tiny functions/procedures to make the code shorter:
static	bScatter := {|| cUserID   := users->UserID,	;
			cUserName := users->UserName,	;
			cDept     := users->Department,	;
			cPhone    := users->Phone,	;
			cExt      := users->Extension }
static	bGather := {||	users->UserID     := cUserID,	;
			users->UserName   := cUserName,	;
			users->Department := cDept,	;
			users->Phone      := cPhone,	;
			users->Extension  := cExt }
static	bUpdate := {||	oUserID   :killFocus()			;
				  :varPut( users->UserID     ),	;
			oUserName :killFocus()			;
				  :varPut( users->UserName   ),	;
			oDept     :killFocus()			;
				  :varPut( users->Department ),	;
			oPhone    :killFocus()			;
				  :varPut( users->Phone      ),	;
			oExt      :killFocus()			;
				  :varPut( users->Extension  ) }

do case
case nMsg == WM_INITDIALOG

	use users new shared
	users->( dbGoTop() )

	eval(bScatter)		// fetch fields to static vars

	/////////////
	//
	//  The code below does validation using GET objects.
	//
	//  The objects need to be saved because we want to change
	//  them as we move from record to record.
	//
	/////////////

	GetList = {}
	@ dialog hWndDlg id IDD_USERID   get cUserID
	oUserID = ATail(GetList)
	@ dialog hWndDlg id IDD_USERNAME get cUserName
	oUserName = ATail(GetList)
	@ dialog hWndDlg id IDD_DEPT     get cDept
	oDept = ATail(GetList)
	@ dialog hWndDlg id IDD_PHONE    get cPhone
	oPhone = ATail(GetList)
	@ dialog hWndDlg id IDD_EXT      get cExt	picture "9999"
	oExt = ATail(GetList)

	return 1			// want system to set the focus

case nMsg == WM_SYSCOMMAND
	if nwParam == SC_CLOSE		// system menu double click, or Alt-F4
#ifdef ThisIsTheDefault
		// By default, Windows sends a WM_COMMAND with IDCANCEL,
		// which does the same as this code:

		// cancel the GETs
		CANCEL DIALOG hWndDlg
		close users
		EndDialog(hWndDlg, IDCANCEL)	// *not* DestroyWindow()
		return 1		// means msg has been processed
#endif // ThisIsTheDefault
	endif

case nMsg == WM_COMMAND
	do case
	case nwParam == IDOK
		// don't change record
		// (it's only done if SAVE button pressed, i.e. IDD_SAVE)
		CANCEL DIALOG hWndDlg		// cancel any GETs
		close users
		EndDialog(hWndDlg, nwParam)	// *not* DestroyWindow()
		return 1		// means msg has been processed

	case nwParam == IDCANCEL
		// don't change record
		CANCEL DIALOG hWndDlg		// cancel any GETs
		close users
		EndDialog(hWndDlg, nwParam)	// *not* DestroyWindow()
		return 1		// means msg has been processed

	case nwParam == IDD_NEXT


// Don't define NOT_DEFINED !!!   (It's just used for commenting)

#ifdef NOT_DEFINED	// this is to avoid using /* ... */ over many lines
			// which causes problems if you have another
			// /* ... */ comment within the code

	/*
	 *  This code is commented out because it's NOT the
	 *  way to do it!!  You're not closing the dialog.
	 *  You're just moving to a new record.  If you use
	 *  this code you get very confused edit controls.
	 */

		// need to cancel current GETs, skip, and re-issue them

		CANCEL DIALOG hWndDlg		// cancel any GETs

		users->( dbSkip(1) )
		if users->( Eof() )
			users->( dbGoBottom() )
		endif

		eval(bScatter)		// fetch fields to static vars

		GetList = {}
		@ dialog hWndDlg id IDD_USERID   get cUserID
		@ dialog hWndDlg id IDD_USERNAME get cUserName
		@ dialog hWndDlg id IDD_DEPT     get cDept
		@ dialog hWndDlg id IDD_PHONE    get cPhone
		@ dialog hWndDlg id IDD_EXT      get cExt	picture "9999"
#else

	/*
	 *  Here's how to make moving to a different record work.
	 */

		// need to skip, then update GETs

		users->( dbSkip(1) )
		if users->( Eof() )
			users->( dbGoBottom() )
		endif

		eval(bUpdate)		// update the GETs and vars

#ifdef YouCanDoItThisWay
		// this way is a little slower, but uses the PICTURE
		// (if any) -- see GETSYS.PRG for the function
		// DReadSetInfo().
		DReadSetInfo(hWndDlg, IDD_USERID,   GetList, 1)
		DReadSetInfo(hWndDlg, IDD_USERNAME, GetList, 2)
		DReadSetInfo(hWndDlg, IDD_DEPT,     GetList, 3)
		DReadSetInfo(hWndDlg, IDD_PHONE,    GetList, 4)
		DReadSetInfo(hWndDlg, IDD_EXT,      GetList, 5)
#else // OrThisWay
		// This is good enough for char vars with no picture.
		//
		// For the general-case, use:
		//	SetDlgItem(hWndDlg, IDD_xxx,	;
		//		   transform(oXXX:varGet(), oXXX:picture))
		// which currently works even if the picture is nil.
		// CA may "fix" that, of course, in which case you
		// need cautious code as in DReadSetInfo().
		SetDlgItem(hWndDlg, IDD_USERID,   oUserID  :varGet())
		SetDlgItem(hWndDlg, IDD_USERNAME, oUserName:varGet())
		SetDlgItem(hWndDlg, IDD_DEPT,     oDept    :varGet())
		SetDlgItem(hWndDlg, IDD_PHONE,    oPhone   :varGet())
		SetDlgItem(hWndDlg, IDD_EXT,      oExt     :varGet())
#endif

#endif // NOT_DEFINED

		return 1		// means msg has been processed

	case nwParam == IDD_PREV

		// need to skip, then update GETs

		users->( dbSkip(-1) )
		if users->( Bof() )
			users->( dbGoTop() )
		endif

		eval(bUpdate)		// update the GETs and vars

		SetDlgItem(hWndDlg, IDD_USERID,   oUserID  :varGet())
		SetDlgItem(hWndDlg, IDD_USERNAME, oUserName:varGet())
		SetDlgItem(hWndDlg, IDD_DEPT,     oDept    :varGet())
		SetDlgItem(hWndDlg, IDD_PHONE,    oPhone   :varGet())
		SetDlgItem(hWndDlg, IDD_EXT,      oExt     :varGet())

		return 1		// means msg has been processed

	case nwParam == IDD_SAVE
		if IsDialogOK(hWndDlg, nwParam)
			users->( RLock() )
			eval(bGather)	// update the fields from the vars
			users->( dbUnlock() )
		endif
		return 1		// means msg has been processed

	endcase
endcase
return 0	// means msg not processed (and want default action)





static procedure Ctl3dColorChange()
local	cDLL := GetProcAddress(hLibCtl3d, "Ctl3dColorChange", "Pascal",   ;
			       "void", "")
CallDLL(cDLL)
return


static procedure Ctl3dRegister(hInst)
local	cDLL := GetProcAddress(hLibCtl3d, "Ctl3dRegister", "Pascal",   ;
			       "void", "int")
CallDLL(cDLL, hInst)
return


static procedure Ctl3dAutoSubclass(hInst)
local	cDLL := GetProcAddress(hLibCtl3d, "Ctl3dAutoSubclass", "Pascal",   ;
			       "void", "int")
CallDLL(cDLL, hInst)
return


static procedure Ctl3dUnregister(hInst)
local	cDLL := GetProcAddress(hLibCtl3d, "Ctl3dUnregister", "Pascal",   ;
			       "void", "int")
CallDLL(cDLL, hInst)
return



static procedure Ctl3d(lOn)
local	hInst := _GetInstance()

if lOn .and. hLibCtl3d == nil
	hLibCtl3d := LoadLibrary("ctl3d.dll")
	if hLibCtl3d == nil .or. hLibCtl3d < 32
		MessageBox( , "Unable to find CTL3D.DLL", "Error", MB_ICONSTOP)
		hLibCtl3d := nil
	else
		Ctl3dRegister(hInst)
		Ctl3dAutoSubclass(hInst)
	endif
elseif !lOn .and. hLibCtl3d != nil
	Ctl3dUnregister(hInst)
	FreeLibrary(hLibCtl3d)
	hLibCtl3d := nil
endif
Menu3dUpdate()
return


static procedure Menu3dUpdate()
local cItem := "o_3d"
local hMenu

if !IsWindow(hWnd)
	return
endif

hMenu := GetMenu(hWnd)    		// get reference to main menu
if hLibCtl3d == nil
	// either turned it off, or an error (e.g. no DLL)
	CheckMenuItem(hMenu, cItem, MF_UNCHECKED)
else
	// 3d is now on
	CheckMenuItem(hMenu, cItem, MF_CHECKED)
endif
return


static procedure DoMenu3d(cItem)
local hMenu := GetMenu(hWnd)    		// get reference to main menu
local nCheck := CheckMenuItem(hMenu, cItem)	// current state
Ctl3d(nCheck != MF_CHECKED)			// want opposite of current
return



function nstr(n)
return alltrim(str(n)) + " "



function asString(x)
local	v := valtype(x), i, n, c
do case
   case v == "C"
   case v == "N"
      return nstr(x)
   case v == "L"
      return iif(x, ".T.", ".F.")
   case v == "D"
      return dtoc(x)
   case v == "U"
      return "NIL"
   case v == "A"
	c = "{"
	n := len(x)
	for i = 1 to n
		c += asString(x[i])
		if i != n
			c += ", "
		endif
	next i
	c += "}"
	return c
   case v == "O"
      return x:classname() + " {...}"
   case v == "B"
      return "{|| ...}"
   otherwise
      return ""
end case
return x



static function ToggleItem(cItem)
local hMenu := GetMenu(hWnd)       // retrieve reference to main menu
local nCheck := CheckMenuItem(hMenu, cItem)
CheckMenuItem(hMenu, cItem, if(nCheck == MF_CHECKED, MF_UNCHECKED, MF_CHECKED))
return nil



function MenuSetup()
local	hWnd := SelectWindow(), hMenu, hPopupMenu

if (hMenu := GetMenu(hWnd)) != nil
	DestroyMenu(hMenu)
endif

// do new one (forget old value)
hMenu = CreateMenu()
hPopupMenu = CreatePopupMenu()
AppendMenu(hMenu, "file", MF_ENABLED + MF_POPUP, "&File", hPopupMenu)
AppendMenu(hPopupMenu, "f_open", MF_ENABLED + MF_STRING, "&Open...", {|c| DoOpen(c) })
AppendMenu(hPopupMenu, "f_exit", MF_ENABLED + MF_STRING, "E&xit", {|c| DoExit(c) })
hPopupMenu = CreatePopupMenu()
AppendMenu(hMenu, "view", MF_ENABLED + MF_POPUP, "&View", hPopupMenu)
AppendMenu(hPopupMenu, "v_users", MF_ENABLED + MF_STRING, "&User details", {|| DoUsers()})
hPopupMenu = CreatePopupMenu()
AppendMenu(hMenu, "options", MF_ENABLED + MF_POPUP, "&Options", hPopupMenu)
AppendMenu(hPopupMenu, "o_font", MF_ENABLED + MF_STRING, "&Font", {|| DoFont()})
AppendMenu(hPopupMenu, "o_3d", MF_ENABLED + MF_STRING, "3&d Effects", {|c| DoMenu3d(c)})
hPopupMenu = CreatePopupMenu()
AppendMenu(hMenu, "help", MF_ENABLED + MF_POPUP, "&Help", hPopupMenu)
AppendMenu(hPopupMenu, "h_about", MF_ENABLED + MF_STRING, "&About", {|| DoAbout()})
SetMenu(hWnd, hMenu)
return hMenu


