/*
 *	c4w.h - support header for Clip-4-Win
 *
 *	Written by:	John M. Skelton,  Sep-93.  For 5.2, extracted from *.c.
 *	Modified by:	John M. Skelton,  Feb-94.  Added lengthy comments.
 *
 *	Copyright (C) 1993,1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP.
 *	All Rights Reserved.
 */


#ifndef	C4W_H
#define	C4W_H

// This is the generic way to rename Windows API functions:

#include "unwindow.h"		// in \CLIP4WIN\INCLUDE

// That renames all the names with 10 or fewer chars when the
//	#include "windows.h"
// is done.  See readme.txt.


#define	STRICT
#include <windows.h>


// Clipper's header (#include) files conflict with windows.h, so
// here's some mess to improve things:  (note that 5.2 conflicts
// more than 5.01)

#undef	NULL
#define	PBYTE	CLIP_PBYTE
// Can't do this for WORD, as Clipper uses it both as typedef
// and #define.  Must be a mistake!  We want the Windows typedef,
// with a different name for the #define (CLIPWORD, here).
// Yes, this is ugly.
//#define	WORD	CLIP_WORD
#define	PWORD	CLIP_PWORD
#define	LONG	CLIP_LONG
#define	PLONG	CLIP_PLONG
#define	PDWORD	CLIP_PDWORD
#define	BOOL	CLIP_BOOL
#define	HANDLE	CLIP_HANDLE

#include "extend.h"

#undef	PBYTE
//#undef	WORD
#undef	PWORD
#undef	LONG
#undef	PLONG
#undef	PDWORD
#undef	BOOL
#undef	HANDLE
#define	CLIPNULL 0L
#undef	NULL

#define	NULL	0

#define	CLIPWORD	128
#undef	WORD				// extend.h wants this as #define

#endif	// C4W_H

