/////////////////////////
//
//	devmode.prg - Windows API: ExtDeviceMode()
//
//	Written by:	John M. Skelton, 24-Mar-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
/////////////////////////

#include "windows.ch"
#include "print.ch"


#define	CR	chr(13)

#define	DMMINLEN	(CCHDEVICENAME + 2*4 + 4 + 2*12)	// min length

static	hWnd, hInst, hPrevInst, nCmdShow
static	cAppName := "ExtDevMd"


function main()
local	aDM

hWnd = WinSetup(cAppName, "ExtDeviceMode")

//? "Length of driver's DEVMODE structure =", ExtDeviceMode(hWnd)
//wait

// This gets the current settings
//? "Result of DM_COPY =", ExtDeviceMode(hWnd, , @aDM, , , , , DM_COPY)
//wait

//? "at(chr(0), aDM[DM_DeviceName])", at(chr(0), aDM[DM_DeviceName])
//? asString(aDM)
//wait

/*
 *  To change a setting:
 *
 *	1. Get current setting
 *	2. Change aDM[...]
 *	3. Set the bit in aDM[DM_Fields]
 *	4. Call ExtDeviceMode() with DM_MODIFY.
 *	Use DM_UPDATE if you want to make a change for all apps.
 */

ExtDeviceMode(hWnd, , @aDM, , , , , DM_COPY)

// Here's a useful change!
aDM[DM_Orientation] = DMORIENT_LANDSCAPE
aDM[DM_Fields] = C4W_Or(aDM[DM_Fields], DM_ORIENTATION)

// Paper length
//aDM[DM_PaperSize] = DMPAPER_A4
//aDM[DM_Fields] = C4W_Or(aDM[DM_Fields], DM_PAPERSIZE)

//? "Result of DM_UPDATE & MODIFY =", ;
//  ExtDeviceMode(hWnd, , @aDM, , , aDM, , DM_UPDATE + DM_MODIFY)
? "Result of DM_MODIFY =", ;
  ExtDeviceMode(hWnd, , @aDM, , , aDM, , DM_MODIFY)

PrintTest(aDM)

return nil


function ExtDeviceMode(hWnd, hDriver, aDMOut, cDevice, cPort, aDMIn,	;
                       cFile, nMode)
local	cPrintInfo, cPrintDriver, cPrintDevice, cPrintPort, hPrintDC
local	cDMIn, cDMOut
local	cEDM, nRet
local	nDMLen			// # bytes in total DEVMODE structure

cPrintInfo = GetProfString("windows", "device", "")
//? cPrintInfo

// separate the fields, which are delimitted by commas (",")
cPrintDevice = alltrim(left(cPrintInfo, at(",", cPrintInfo) - 1))
cPrintInfo   = substr(cPrintInfo, at(",", cPrintInfo) + 1)
cPrintDriver = alltrim(left(cPrintInfo, at(",", cPrintInfo) - 1))
cPrintInfo   = substr(cPrintInfo, at(",", cPrintInfo) + 1)
cPrintPort   = cPrintInfo
//? cPrintDriver, "  ", cPrintDevice, "  ", cPrintPort

if hDriver == nil
	hDriver = LoadLibrary(cPrintDriver + ".DRV")
//	? "hDriver", hDriver
endif

if cDevice == nil
	cDevice = cPrintDevice
endif

if cPort == nil
	cPort = cPrintPort
endif

if cFile == nil
	cFile = "WIN.INI"
endif

cFile += chr(0)

if nMode == nil
	nMode = 0
endif

if !empty(hDriver)
	cEDM = GetProcAddress(hDriver, PROC_EXTDEVICEMODE, "Pascal",	;
			      "int", "hwnd,handle,str,str,str,str,str,word")
			      // see CallDLL() below for these params
//	? valtype(cEDM)
endif

if !empty(cEDM)
	if aDMIn == nil
		afill(aDMIn := array(DM_LENGTH), 0)
		aDMIn[DM_DeviceName] = space(CCHDEVICENAME)
		aDMIn[DM_DeviceDependent] = chr(0)	// enough for now
		// get the correct length of this device's DEVMODE structure
		cDMIn = DM2Bin(aDMIn)
		cDMOut = cDMIn
		nDMLen = CallDLL(cEDM, hWnd, hDriver, @cDMOut, cDevice, cPort,;
				 cDMIn, cFile, 0)
	else
		nDMLen = len(cDMIn := DM2Bin(aDMIn))
	endif

	if nMode == 0
		nRet = nDMLen
	else
		cDMOut = replicate(chr(0), nDMLen)
//		? "len(cDMOut)", len(cDMOut)
//		wait
		nRet = CallDLL(cEDM, hWnd, hDriver, @cDMOut, cDevice, cPort,;
			       cDMIn, cFile, nMode)
//		? nRet
//		wait
//		? "len(cDMOut)", len(cDMOut)
//		wait
		if aDMOut == nil
			aDMOut = array(DM_LENGTH)
		endif
		acopy(Bin2DM(cDMOut), aDMOut)
	endif
endif

return nRet


function DM2Bin(aDM)	// DEVMODE to binary (string)
return A2Bin(aDM, DM_IN_DEF)


function Bin2DM(cDM)	// binary (string) to DEVMODE
return Bin2A(cDM, DM_OUT_DEF ;
		  + ",str[" + ltrim(str(len(cDM) - DMMINLEN)) + "]")


static function PrintTest(aDevMode)
local	cDevMode := DM2Bin(aDevMode)
local	cPrintInfo, cPrintDriver, cPrintDevice, cPrintPort, hPrintDC
local	ch

cPrintInfo = GetProfString("windows", "device", "")
? cPrintInfo
// separate the fields, which are delimitted by commas (",")
cPrintDevice = alltrim(left(cPrintInfo, at(",", cPrintInfo) - 1))
cPrintInfo   = substr(cPrintInfo, at(",", cPrintInfo) + 1)
cPrintDriver = alltrim(left(cPrintInfo, at(",", cPrintInfo) - 1))
cPrintInfo   = substr(cPrintInfo, at(",", cPrintInfo) + 1)
cPrintPort   = cPrintInfo
? cPrintDriver, "  ", cPrintDevice, "  ", cPrintPort

hPrintDC = CreateDC(cPrintDriver, cPrintDevice, cPrintPort, cDevMode)
? "hPrintDC", hPrintDC

wait "Type p to print..." to ch
if ch == "p"
	? "StartDoc", StartDoc(hPrintDC, "TestOutput")
	wait

	? "StartPage", StartPage(hPrintDC)
	wait

	TextOut(hPrintDC, 10, 10, ".")
	TextOut(hPrintDC, 0, 0, "At 0,0")
	TextOut(hPrintDC, 0, 500, "At 0,500")
	TextOut(hPrintDC, 100, 100, "At 100,100")
	TextOut(hPrintDC, 0, 200, "At 0,200")

	wait

	? "EndPage", EndPage(hPrintDC)
	wait

	? "EndDoc", EndDoc(hPrintDC)
	wait
endif

DeleteDC(hPrintDC)

return nil


function nstr(n)
return alltrim(str(n)) + " "


function asString(x)
local	i, s, v := valtype(x)

do case
case v == "C"
case v == "N"
	return nstr(x)
case v == "L"
	if x
		return ".T."
	else
		return ".F."
	endif
case v == "D"
	return "date"
case v == "U"
	return "NIL"
case v == "A"
	s = "{"
	for i = 1 to len(x)
		if i >= 2
			s += ", "
		endif
		s += asString(x[i])
	next i
	s += "}"
	return s
case v == "O"
	return "<Object " + x:classname() + ">"
case v == "B"
	return "<Block>"
otherwise
	return ""
end case

return x



// From:
//	createdc.prg - Windows API: CreateDC() with awkward params


#xtranslate	ADD PARAM <p> TO <c>				;
		=>	if <p> == nil				;
		;		<p> := 0			;
		;	end					;
		;	<c> += iif(valtype(<p>) == "C", ",str", ",long")


// This is complicated by allowing the cnXXX params to be char, numeric or nil

static function CreateDC(cDriver, cnDevice, cnOutput, cnParams)
local hLib := LoadLibrary("GDI.EXE")
local c := "str"

ADD PARAM cnDevice TO c
ADD PARAM cnOutput TO c
ADD PARAM cnParams TO c
c := GetProcAddress(hLib, "CreateDC", "Pascal", "int", c)
return CallDLL(c, cDriver, cnDevice, cnOutput, cnParams)
