/////////////////////////
//
//	dibbrush.prg - Windows API: CreateDIBPatternBrush()
//			and more useful CreateDIBBrush() and LoadDIBBrush()
//
//	Written by:	John M. Skelton, 2-June-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
/////////////////////////

#define	WIN_WANT_RESOURCE
#include "windows.ch"

#ifndef	RT_BITMAP
#define	RT_BITMAP	2
#endif	// RT_BITMAP

#ifndef	GMEM_MOVEABLE
#define	GMEM_MOVEABLE	2
#endif	// GMEM_MOVEABLE

#ifndef	DIB_RGB_COLORS
#define	DIB_RGB_COLORS	0
#define	DIB_PAL_COLORS	1
#endif	// DIB_RGB_COLORS


static function CreateDIBPatternBrush(hGlobal, nColor)
local hLib := LoadLibrary("GDI.EXE")
local c := GetProcAddress(hLib, "CreateDIBPatternBrush", "Pascal", ;
			  "int", "int,uint")
if nColor == nil
	nColor = DIB_RGB_COLORS
endif
return CallDLL(c, hGlobal, nColor)


static function CreateDIBBrush(cDIB, nColor)
local	hGlb, hBrush
if valtype(cDIB) == "A"
	// too big
else
	hGlb = GlobalAlloc(GMEM_MOVEABLE, len(cDIB))
	GlobalData(hGlb, cDIB)		// no need for + CHR(0)
	hBrush = CreateDIBPatternBrush(hGlb, nColor)
	GlobalFree(hGlb)
endif
return hBrush


static function LoadDIBBrush(hInst, cnId, nColor)	// --> hBrush
local	hRes, hGlb, hBrush
hRes = FindResource(hInst, cnId, RT_BITMAP)
hGlb = LoadResource(hInst, hRes)
LockResource(hGlb)
hBrush = CreateDIBPatternBrush(hGlb, nColor)
UnlockResource(hGlb)
return hBrush

