/////////////////////////
//
//	drawbmp.prg - draw a bitmap from a resource file
//
//	Written by:	John M. Skelton, 12-May-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
/////////////////////////


#include "windows.ch"


// BITMAP structure (as Clipper array)

#define	BM_Type		1
#define	BM_Width	2
#define	BM_Height	3
#define	BM_WidthBytes	4
#define	BM_Planes	5
#define	BM_BitsPixel	6
#define	BM_Bits		7

#ifndef	SRCCOPY
#define	SRCCOPY		13369376	// 0x00CC0020L
#endif	// SRCCOPY


function start()
local	hWnd := WinSetup("test", "test")
local	hBmp := LoadBitmap( , "mybmp")
local	cBmp := left(GetObject(hBmp), 14)	// BITMAP structure
local	aBmp := Bin2A(cBmp, "int,int,int,int,byte,byte,long")
local	hDC, hMemDC, nEvent, hOldBmp

do while (nEvent := ChkEvent()) != EVENT_QUIT
	if nEvent == EVENT_REDRAW
		hDC := GetDC(hWnd)
		hMemDC := CreateCompatibleDC(hDC)
		hOldBmp := SelectObject(hMemDC, hBmp)
		BitBlt(hDC, 100, 100, aBmp[BM_Width], aBmp[BM_Height],	;
		       hMemDC, 0, 0, SRCCOPY)
		SelectObject(hMemDC, hOldBmp)
		DeleteDC(hMemDC)
		ReleaseDC(hWnd, hDC)
	endif
enddo

DeleteObject(hBmp)
return 0


/////////////////////////
//
//	bitblt.prg - Windows API: BitBlt()
//
//	>>> NOW IN CLIP4WIN.LIB <<<
//
//	Written by:	John M. Skelton, 9-Mar-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
/////////////////////////


//#include "windows.ch"


static function BitBlt(hdcDst, nXDst, nYDst, nW, nH, hdcSrc, nXSrc, nYSrc, nROP)
local hLib := LoadLibrary("GDI.EXE")
local c := GetProcAddress(hLib, "BitBlt", "Pascal", ;
			  "bool", "int,int,int,int,int,int,int,int,long")
return CallDLL(c, hdcDst, nXDst, nYDst, nW, nH, hdcSrc, nXSrc, nYSrc, nROP)



/////////////////////////
//
//	crecmpdc.prg - Windows API: CreateCompatibleDC()
//
//	Written by:	John M. Skelton, 9-Mar-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
/////////////////////////


//#include "windows.ch"


static function CreateCompatibleDC(hDC)
local hLib := LoadLibrary("GDI.EXE")
local c := GetProcAddress(hLib, "CreateCompatibleDC", "Pascal", ;
			  "int", "int")
return CallDLL(c, hDC)
