/*
 *	enableha.c - support routine for Clip-4-Win
 *
 *	Written by:	John M. Skelton,  Feb-93.
 *
 *	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP.
 *	All Rights Reserved.
 *
 *	This isn't a function that you're likely to want: it's just
 *	a sample.
 */


// Clipper's header (#include) files conflict with windows.h (note that
// 5.2 conflicts more than 5.01), so there's a generic header that has:
//
//	1. #include "unwindow.h", to rename things
//	2. #define STRICT, to encourage careful coding
//	3. #include <windows.h>
//	4. #include "extend.h", with much mess to overcome the
//	   the conflicts between 5.2 and Windows.

#include "c4w.h"


static const char	*copyright[] =
{
	"Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.",
	"All Rights Reserved."
};


// Because Clipper names are limited to 10 chars, we have to shorten
// the name here.  You can still use the full name in your Clip-4-Win
// program: it makes it more readable, and makes it easy to see the
// proper name of the function ultimately being called.
//
// The "CLIPPER" type makes the function name all upper-case, but I
// find mixed-case more readable.

CLIPPER EnableHard/*wareInput*/(void)	// (lEnable) --> lOldEnable
{
	_retl(EnableHardwareInput(_parl(1)));
}
