////////////////////////////
//
//	menu.prg
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Menu functions, for use with window procedures.
//	These are more trouble to use than the built-in Clip-4-Win
//	functions, but are the standard Windows way.  So, you get
//	WM_COMMAND messages, and it's up to you what you do with them.
//
//	TO USE:
//		#define	WIN_WANT_MF
//		#include "windows.ch"
//		. . .
//		#include "winapi\menu.prg"
//
//	These functions are STATIC because they have the same names
//	as the ones in the Clip-4-Win library.  To use them, use
//	#include, as above.
//
////////////////////////////


#ifndef	WIN_WANT_MF
  // try to sort it out
  #define	WIN_WANT_MF		// want menu flags
  #include "windows.ch"
  #ifndef MF_BYCOMMAND
    #error Clip-4-Win error: you need to define WIN_WANT_MF
  #endif // MF_BYCOMMAND
#endif	// WIN_WANT_MF


////////////////////////////
//
//  Here's how to call some underlying Windows functions
//
/////////////////////////////


//
//  For programs not using ChkEvent(), i.e. those using Window Procedures,
//  you have to use Windows' functions for menus
//  (instead of the convenient Clip-4-Win functions, with their code blocks)
//
//  This is more work, but that's what using Window Procedures is like.
//
//  WARNING: This is aimed at advanced users only!!
//


static function AppendMenu(hMenu, nFlags, nId, cText_hBmp_nOwnerDraw)
static	cAM, cBM
if cAM == nil
	// AppendMenu() is just a little awkward from Clipper...
	cAM = GetProcAddress( , "AppendMenu", "Pascal", ; // in USER.EXE
			      "bool", "int,uint,uint,string")
	cBM = GetProcAddress( , "AppendMenu", "Pascal", ; // in USER.EXE
			      "bool", "int,uint,uint,long")
endif
if nFlags == nil
	nFlags = MF_BYCOMMAND
endif
return CallDLL(iif(valtype(cText_hBmp_nOwnerDraw) == "C", cAM, cBM),	;
	       hMenu, nFlags, nId, cText_hBmp_nOwnerDraw)


static function CheckMenuItem(hMenu, nId, nFlags)
static	cCMI
if cCMI == nil
	cCMI = GetProcAddress( , "CheckMenuItem", "Pascal", ;  // in USER.EXE
			      "bool", "int,uint,uint")
endif
if nFlags == nil
	nFlags = MF_BYCOMMAND
endif
return CallDLL(cCMI, hMenu, nId, nFlags)


static function CreateMenu()
static	cCM
if cCM == nil
	cCM = GetProcAddress( , "CreateMenu", "Pascal", ; // in USER.EXE
			      "int", "void")	// or "hmenu", ""
endif
return CallDLL(cCM)


static function CreatePopupMenu()
static	cCM
if cCM == nil
	cCM = GetProcAddress( , "CreatePopupMenu", "Pascal", ; // in USER.EXE
			      "int", "void")	// or "hmenu", ""
endif
return CallDLL(cCM)


static function DeleteMenu(hMenu, nId, nFlags)
static	cDM
if cDM == nil
	cDM = GetProcAddress( , "DeleteMenu", "Pascal", ;  // in USER.EXE
			      "bool", "int,uint,uint")
endif
if nFlags == nil
	nFlags = MF_BYCOMMAND
endif
return CallDLL(cDM, hMenu, nId, nFlags)


static function DestroyMenu(hMenu)
static	cDM
if cDM == nil
	cDM = GetProcAddress( , "DestroyMenu", "Pascal", ; // in USER.EXE
			      "bool", "int")
endif
return CallDLL(cDM, hMenu)


static function DrawMenuBar(hWnd)
static	cDM
if cDM == nil
	cDM = GetProcAddress( , "DrawMenuBar", "Pascal", ; // in USER.EXE
			      "void", "int")	// use "", "hWnd" if you like
endif
return CallDLL(cDM, hWnd)


static function EnableMenuItem(hMenu, nId, nFlags)
static	cEMI
if cEMI == nil
	cEMI = GetProcAddress( , "EnableMenuItem", "Pascal", ;  // in USER.EXE
			      "bool", "int,uint,uint")
endif
if nFlags == nil
	nFlags = MF_BYCOMMAND
endif
return CallDLL(cEMI, hMenu, nId, nFlags)


static function GetMenu(hWnd)
static	cGM
if cGM == nil
	cGM = GetProcAddress( , "GetMenu", "Pascal", ;	// actually in USER.EXE
			     "int", "int")
endif
return CallDLL(cGM, hWnd)


static function GetMenuCheckMarkDimensions()
static	cM
if cM == nil
	cM = GetProcAddress( , "GetMenuCheckMarkDimensions", "Pascal", ; // in USER.EXE
			      "dword", "void")	// or "dword", ""
endif
return CallDLL(cM)


static function GMenuItemCount(hMenu)
static	cM
if cM == nil
	cM = GetProcAddress( , "GetMenuItemCount", "Pascal", ; // in USER.EXE
			      "int", "int")
endif
return CallDLL(cM, hMenu)


static function GMenuItemID(hMenu, nPos)
static	cM
if cM == nil
	cM = GetProcAddress( , "GetMenuItemID", "Pascal", ; // in USER.EXE
			      "uint", "int,int")
endif
return CallDLL(cM, hMenu, nPos)


static function GetMenuState(hMenu, nId, nFlags)
static	cM
if cM == nil
	cM = GetProcAddress( , "GetMenuState", "Pascal", ;  // in USER.EXE
			      "uint", "int,uint,uint")
endif
if nFlags == nil
	nFlags = MF_BYCOMMAND
endif
return CallDLL(cM, hMenu, nId, nFlags)


static function GetMenuString(hMenu, nId, nFlags)
static	cM
local	i, cBuf := space(80)
if cM == nil
	cM = GetProcAddress( , "GetMenuString", "Pascal", ;  // in USER.EXE
			      "int", "int,uint,str,int,uint")
endif
if nFlags == nil
	nFlags = MF_BYCOMMAND
endif
i = CallDLL(cM, hMenu, nId, @cBuf, len(cBuf), nFlags)
return left(cBuf, i)


static function GetSubMenu(hMenu, nPos)
static	cGSM
if cGSM == nil
	cGSM = GetProcAddress( , "GetSubMenu", "Pascal", ; // in USER.EXE
			      "int", "int,int")
endif
return CallDLL(cGSM, hMenu, nPos)


static function GSystemMenu(hWnd, lRevert)
static	cM
if cM == nil
	cM = GetProcAddress( , "GetSystemMenu", "Pascal", ;  // in USER.EXE
			      "int", "int,bool")
endif
return CallDLL(cM, hWnd, lRevert)


static function HiliteMenuItem(hWnd, hMenu, nId, nFlags)
static	cHMI
if cHMI == nil
	cHMI = GetProcAddress( , "HiliteMenuItem", "Pascal", ;  // in USER.EXE
			      "bool", "HWND,HMENU,uint,uint")
endif
if nFlags == nil
	nFlags = MF_BYCOMMAND
endif
return CallDLL(cHMI, hWnd, hMenu, nId, nFlags)


static function IsMenu(hMenu)
static	cM
if cM == nil
	cM = GetProcAddress( , "IsMenu", "Pascal", ; // in USER.EXE
			      "bool", "int")
endif
return CallDLL(cM, hMenu)


static function LoadMenu(hInst, cnId)
static	cLM1, cLM2
if cLM1 == nil
	// LoadMenu() is just a little awkward from Clipper...
	cLM1 = GetProcAddress( , "LoadMenu", "Pascal", ; // in USER.EXE
			      "hmenu", "int,string")
	cLM2 = GetProcAddress( , "LoadMenu", "Pascal", ; // in USER.EXE
			      "hmenu", "int,long")
endif
if hInst == nil
	hInst = _GetInstance()
endif
return CallDLL(iif(valtype(cnId) == "C", cLM1, cLM2),	;
	       hInst, cnId)


static function RemoveMenu(hMenu, nId, nFlags)
static	cM
if cM == nil
	cM = GetProcAddress( , "RemoveMenu", "Pascal", ;  // in USER.EXE
			      "bool", "int,uint,uint")
endif
if nFlags == nil
	nFlags = MF_BYCOMMAND
endif
return CallDLL(cM, hMenu, nId, nFlags)


static function SetMenu(hWnd, hMenu)
static	cSM
if cSM == nil
	cSM = GetProcAddress( , "SetMenu", "Pascal", ;	// actually in USER.EXE
			     "int", "int,int")
endif
return CallDLL(cSM, hWnd, hMenu)


static function SetMenuItemBitmaps(hMenu, nId, nFlags, hBmpUnchecked, hBmpChecked)
static	cM
if cM == nil
	cM = GetProcAddress( , "SetMenuItemBitmaps", "Pascal", ;  // in USER.EXE
			      "bool", "int,uint,uint,uint,uint")
endif
if nFlags == nil
	nFlags = MF_BYCOMMAND
endif
return CallDLL(cM, hMenu, nId, nFlags, hBmpUnchecked, hBmpChecked)


static function TrackPopupMenu(hMenu, nFlags, nX, nY, nReserved, hWnd, aRect)
static	cTPM1, cTPM2
if cTPM1 == nil
	cTPM1 = GetProcAddress( , "TrackPopupMenu", "Pascal", ;  // in USER.EXE
			      "bool", "hmenu,uint,int,int,int,hwnd,string")
	cTPM2 = GetProcAddress( , "TrackPopupMenu", "Pascal", ;  // in USER.EXE
			      "bool", "hmenu,uint,int,int,int,hwnd,long")
endif
return CallDLL(iif(aRect == nil, cTPM2, cTPM1),		;
	       hMenu, nFlags, nX, nY, 0, hWnd,		;
	       iif(aRect == nil, 0, a2bin(aRect, "int[4]")))

