//	setsysco.prg - SetSysColors() Windows API function
//
//	Written by:	John M. Skelton, 13-Sep-93.
//
//	Copyright (C) 1993 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.


#ifdef TESTING

#include "windows.ch"

#define	APPNAME	"SetSysCo"

function main()
local	nBg := GetSysColor(COLOR_BACKGROUND)	// desktop
local	nCap := GetSysColor(COLOR_CAPTIONTEXT)
local	hWnd

hWnd = WinSetup(APPNAME, "Clip-4-Win sample: SetSysColors( )")
GetAKey()

// this will be horrible...
SetSysColors({COLOR_BACKGROUND, COLOR_CAPTIONTEXT},	;
             {RGB(255,0,0),     RGB(0,255,0)})

GetAKey()

// restore
SetSysColors({COLOR_BACKGROUND, COLOR_CAPTIONTEXT},	;
             {nBG,              nCap})
GetAKey()

if IsWindow(hWnd)
	DestroyWindow(hWnd)
endif
UnregisterClass(APPNAME)

return 0

static procedure GetAKey()
local	nEvent
@ 10,10 say "Press a key ..."
do while (nEvent := ChkEvent()) != EVENT_KEY
	if nEvent == EVENT_REDRAW
		@ 10,10 say "Press a key ..."
	endif
enddo
return

#endif // TESTING



// The C function prototype is:
//
//	void SetSysColors(int cDspElements,
//			  const int FAR *lpnDspElements,
//			  const COLORREF FAR *lpdwRgbValues);
//
// where cDspElements is the length of the arrays lpnDspElements
//			and lpdwRgbValues
//	 lpnDspElements is a pointer to an array of system colours
//			to be changed
//	 lpdwRgbValues is a pointer to an array of new RGB colour values
//			(one for each of lpnDspElements)
//
// This can be simplified a bit in Clipper.  I'll keep the same
// kind of arrays to keep the code simple, but you'd be better with a single
// array containing arrays that are each a { COLOR_*, RGB() } pair.

function SetSysColors(aDspElements, aRgbValues)
//
// aDspElements is e.g. {COLOR_BTNFACE, COLOR_BTNTEXT, COLOR_MENU}
// aRgbValues is a parallel array of RGB values,
// e.g. {RGB(255,0,0), RGB(0,0,255), RGB(0,255,0)}
//
// We'll have to change these Clipper arrays into C arrays,
// which will actually be stored in Clipper string variables.
//
local	hLib := LoadLibrary("USER.EXE")
local	cSSC := GetProcAddress(hLib, "SetSysColors", "Pascal", ;
			"void", "int,string,string")
// I use "int,string,string" because we're having to use Clipper
// strings instead of the C int and DWORD (long) arrays.

local	nLen := len(aDspElements)
local	cInt := "int[" + ltrim(str(nLen)) + "]"
local	cLong := "long[" + ltrim(str(nLen)) + "]"
//
// cInt is e.g. "int[3]" if the array is length 3.
// cLong would be "long[3]".

CallDLL(cSSC,				;
	nLen,				;
	a2bin(aDspElements, cInt),	;
	a2bin(aRgbValues, cLong))
return nil

