//	textmetr.prg - sample implementation of Windows GetTextMetrics() via DLL
//
//	Written by:	John M. Skelton, 13-Jan-93.
//
//	Copyright (C) 1993 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Compile:	/n /w

#include "windows.ch"
#include "textmetr.ch"


// Windows GetTextMetrics(), via DLL
//
// GetTextMetrics( <hDC>, <@aTextMetric> )  -->  lSuccess

function GetTextMetrics(hDC, aTM)
local	hLib, cGetTM, cTM, lSuccess
if (hLib := LoadLibrary("GDI.EXE")) < 32				;
   .or. (cGetTM := GetProcAddress(hLib, "GetTextMetrics", "Pascal",	;
				  "bool", "int,str")) == nil
	return .f.
endif
// make an empty TEXTMETRIC structure
cTM = a2bin({0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},  ;
	    "int[8], BYTE[9], int[3]")
// same as replicate(chr(0), 31), in this case, as each int is 2 bytes

// Remember to pass cTM by reference (@cTM), so it can be changed
if (lSuccess := CallDLL(cGetTM, hDC, @cTM))
	aTM = bin2a(cTM, "int[8], BYTE[9], int[3]")
endif
FreeLibrary(hLib)
return lSuccess
