/////////////////////////
//
//	wnet.prg - Windows API: WNet*()
//
//	Written by:	John M. Skelton, 6-Oct-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
/////////////////////////

#include "windows.ch"
#include "wnet.ch"
#include "dll.ch"

#define	BUFLEN	512

#xtranslate	sizeof(int)	=>	2


#ifdef	TESTING

function main()
local	hWnd := WinSetup("WNet", "WNet Test")

? C4W_GetUser(), C4W_NetErr()
wait
? C4W_BrowseDialog(), C4W_NetErr()
wait

return 0

#endif	// TESTING



/*
 *  Get network user name
 */

_DLL FUNCTION WNetGetUser(@cUser AS STRING, @cLenPtr AS STRING) ;
	AS INT PASCAL:USER.WNetGetUser


function C4W_GetUser()			// --> cUser or nil
local	cBuf := space(BUFLEN)
local	cLen := c4w_i2bin(BUFLEN)	// space(sizeof(int))
local	nRet

if (nRet := WNetGetUser(@cBuf, @cLen)) == WN_SUCCESS
	cBuf = left(cBuf, c4w_bin2i(cLen))
else
#ifdef	TESTING
	? "Error code", nRet
#endif	// TESTING
	cBuf = nil
endif
return cBuf



_DLL FUNCTION WNetGetError(@cError AS STRING) AS INT PASCAL:USER.WNetGetError

/*
 *  Get network status code
 */

function C4W_NetStatus()		// --> nStatus or nil
local	cErr := space(sizeof(int))
local	nRet

if (nRet := WNetGetError(@cErr)) == WN_SUCCESS
	nRet = c4w_bin2i(cErr)
else
#ifdef	TESTING
	? "Error code", nRet
#endif	// TESTING
endif
return nRet



_DLL FUNCTION WNetGetErrorText(nError AS INT,				;
			       @cBuf AS STRING, @cLenPtr AS STRING)	;
	AS INT PASCAL:USER.WNETGetErrorText
			// ^^^^ different capitals to fool #define in wnet.ch
/*
 *  Get text description of network error
 */

function C4W_NetErr(nError)		// --> cErrorText or nil
local	cBuf := space(BUFLEN)
local	cLen := c4w_i2bin(BUFLEN)	// space(sizeof(int))
local	nRet

default nError to C4W_NetStatus()
if nError == nil
	nError = WN_SUCCESS
endif
if (nRet := WNetGetErrorText(nError, @cBuf, @cLen)) == WN_SUCCESS
	cBuf = left(cBuf, c4w_bin2i(cLen))
else
#ifdef	TESTING
	? "Error code", nRet
#endif	// TESTING
	cBuf = nil
endif
return cBuf



_DLL FUNCTION WNetBrowseDialog(hWnd AS HWND, nType AS WORD, @cPath AS STRING) ;
	AS INT PASCAL:USER.WNetBrowseDialog

/*
 *  Dialog for user to select a network resource (default: printer).
 */

function C4W_BrowseDialog(hWnd, nType)	// --> cPath or nil
local	cBuf := space(BUFLEN)
local	cLen := c4w_i2bin(BUFLEN)	// space(sizeof(int))
local	nRet

default hWnd  to 0
default nType to WNBD_CONN_PRINTQ
if (nRet := WNetBrowseDialog(hWnd, nType, @cBuf)) == WN_SUCCESS
	cBuf = left(cBuf, c4w_bin2i(cLen))
else
#ifdef	TESTING
	? "Error code", nRet
#endif	// TESTING
	cBuf = nil
endif
return cBuf



_DLL FUNCTION WNetConnectDialog(hWnd AS HWND, nType AS WORD) ;
	AS INT PASCAL:USER.WNetConnectDialog

/*
 *  Dialog for user to select a network resource (default: printer).
 */

function C4W_ConnectDialog(hWnd, nType)
local	cBuf
local	nRet

default hWnd  to 0
default nType to WNTYPE_PRINTER
if (nRet := WNetConnectDialog(hWnd, nType)) == WN_SUCCESS
	cBuf = C4W_GetLastConnection(nType)
else
#ifdef	TESTING
	? "Error code", nRet
#endif	// TESTING
endif
return cBuf



_DLL FUNCTION WNetAddConnection(cPath AS STRING, cPassword AS STRING, ;
				cLocalDevice AS STRING) ;
	AS INT PASCAL:USER.WNetAddConnection

/*
 *  Re-direct a local device across the network (default: LPT1:).
 */

function C4W_AddConnection(cPath, cPassword, cLocalDevice)
default cPassword to ""
cPassword += chr(0)
default cLocalDevice to "LPT1:"
cLocalDevice += chr(0)
return WNetAddConnection(cPath, cPassword, cLocalDevice)



_DLL FUNCTION WNetCancelConnection(cLocalDevice AS STRING, lForce AS BOOL) ;
	AS INT PASCAL:USER.WNetCancelConnection

/*
 *  Cancel a C4W_AddConnection().
 */

function C4W_CancelConnection(cLocalDevice, lForce)
default cLocalDevice to "LPT1:"
cLocalDevice += chr(0)
default lForce to .t.
return WNetCancelConnection(cLocalDevice, lForce)



_DLL FUNCTION WNetGetConnection(cLocalDevice AS STRING,			;
				@cRemote AS STRING, @cLenPtr AS STRING)	;
	AS INT PASCAL:USER.WNetGetConnection

/*
 *  Get remote name for a redirected device (default: LPT1:).
 */

function C4W_GetConnection(cLocalDevice)	// --> cRemoteName or nil
local	cBuf := space(BUFLEN)
local	cLen := c4w_i2bin(BUFLEN)	// space(sizeof(int))
local	nRet

default cLocalDevice to "LPT1:"
cLocalDevice += chr(0)
if (nRet := WNetGetConnection(cLocalDevice, @cBuf, @cLen)) == WN_SUCCESS
	cBuf = left(cBuf, c4w_bin2i(cLen))
else
#ifdef	TESTING
	? "Error code", nRet
#endif	// TESTING
	cBuf = nil
endif
return cBuf



_DLL FUNCTION WNetGetLastConnection(nType AS WORD,			;
				    @cDevNumPtr AS STRING)		;
	AS INT PASCAL:USER.WNetGetLastConnection

/*
 *  Get remote name for last redirected device (default: printer).
 */

function C4W_GetLastConnection(nType)	// --> cDeviceName or nil
local	cDev := c4w_i2bin(BUFLEN)	// space(sizeof(int))
local	nDev
local	nRet

default nType to WNTYPE_PRINTER
if (nRet := WNetGetLastConnection(nType, @cDev)) == WN_SUCCESS
	nDev = c4w_bin2i(cDev)
	if nDev == -1
#ifdef	TESTING
		? "No connection"
#endif	// TESTING
	elseif nType == WNTYPE_PRINTER
		cDev = "LPT" + alltrim(str(nDev)) + ":"
	elseif nType == WNTYPE_DRIVE
		cDev = chr(asc("A") + nDev) + ":"
	endif
else
#ifdef	TESTING
	? "Error code", nRet
#endif	// TESTING
endif
return cDev


