////////////////////////////
//
//      Clip-4-Win DEVMODE definitions
//
//      Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//      All Rights Reserved.
//
//      For use with, e.g. CreateDC().
//
////////////////////////////

#ifndef C4W_PRINT_CH
#define C4W_PRINT_CH


// Array elements of aDevMode[], which can be passed to CreateDC(),
// DeviceCapabilities() or ExtDeviceMode() to control printers
// (actually, a2bin(aDevMode, DM_IN_DEF) is passed)
//
// (these correspond to the members of the Windows DEVMODE structure)

#define DM_DeviceName           1       // 32-char name (null-padded on input)
#define DM_SpecVersion          2       //
#define DM_DriverVersion        3       //
#define DM_Size                 4       //
#define DM_DriverExtra          5       //
#define DM_Fields               6       //
#define DM_Orientation          7       //
#define DM_PaperSize            8       //
#define DM_PaperLength          9       //
#define DM_PaperWidth           10      //
#define DM_Scale                11      //
#define DM_Copies               12      //
#define DM_DefaultSource        13      //
#define DM_PrintQuality         14      //
#define DM_Color                15      //
#define DM_Duplex               16      //
#define DM_YResolution          17      //
#define DM_TTOption             18      //

#define DM_LENGTH       18      // length of array

#define CCHDEVICENAME   32

#define DM_IN_DEF       "str[32],uint[4],long,int[12]"  // for a2bin()
#define DM_OUT_DEF      "str[32],uint[4],long,int[12]"  // for bin2a()


// Fields
#define DM_ORIENTATION          1
#define DM_PAPERSIZE            2
#define DM_PAPERLENGTH          4
#define DM_PAPERWIDTH           8
#define DM_SCALE                16
#define DM_COPIES               256
#define DM_DEFAULTSOURCE        512
#define DM_PRINTQUALITY         1024
#define DM_COLOR                2048
#define DM_DUPLEX               4096
#define DM_YRESOLUTION          8192
#define DM_TTOPTION             16384

// Orientation options
#define DMORIENT_PORTRAIT       1
#define DMORIENT_LANDSCAPE      2

// Print resolution options
#define DMRES_DRAFT     (-1)
#define DMRES_LOW       (-2)
#define DMRES_MEDIUM    (-3)
#define DMRES_HIGH      (-4)

// TrueType options
#define DMTT_BITMAP     1       // print TT fonts as graphics
#define DMTT_DOWNLOAD   2       // download TT fonts as soft fonts
#define DMTT_SUBDEV     3       // substitute device fonts for TT fonts

// Mode options
#define DM_UPDATE       1
#define DM_COPY         2
#define DM_PROMPT       4
#define DM_MODIFY       8

#define DM_IN_BUFFER    DM_MODIFY
#define DM_IN_PROMPT    DM_PROMPT
#define DM_OUT_BUFFER   DM_COPY
#define DM_OUT_DEFAULT  DM_UPDATE


// Exported ordinals
#define PROC_EXTDEVICEMODE      (90)
#define PROC_DEVICECAPABILITIES (91)
#define PROC_OLDDEVICEMODE      (13)

// Paper options
#define DMPAPER_FIRST       DMPAPER_LETTER
#define DMPAPER_LETTER      1
#define DMPAPER_LETTERSMALL 2
#define DMPAPER_TABLOID     3
#define DMPAPER_LEDGER      4
#define DMPAPER_LEGAL       5
#define DMPAPER_STATEMENT   6
#define DMPAPER_EXECUTIVE   7
#define DMPAPER_A3          8
#define DMPAPER_A4          9
#define DMPAPER_A4SMALL     10
#define DMPAPER_A5          11
#define DMPAPER_B4          12
#define DMPAPER_B5          13
#define DMPAPER_FOLIO       14
#define DMPAPER_QUARTO      15
#define DMPAPER_10X14       16
#define DMPAPER_11X17       17
#define DMPAPER_NOTE        18
#define DMPAPER_ENV_9       19
#define DMPAPER_ENV_10      20
#define DMPAPER_ENV_11      21
#define DMPAPER_ENV_12      22
#define DMPAPER_ENV_14      23
#define DMPAPER_CSHEET      24
#define DMPAPER_DSHEET      25
#define DMPAPER_ESHEET      26
#define DMPAPER_ENV_DL      27
#define DMPAPER_ENV_C5      28
#define DMPAPER_ENV_C3      29
#define DMPAPER_ENV_C4      30
#define DMPAPER_ENV_C6      31
#define DMPAPER_ENV_C65     32
#define DMPAPER_ENV_B4      33
#define DMPAPER_ENV_B5      34
#define DMPAPER_ENV_B6      35
#define DMPAPER_ENV_ITALY   36
#define DMPAPER_ENV_MONARCH 37
#define DMPAPER_ENV_PERSONAL 38
#define DMPAPER_FANFOLD_US  39
#define DMPAPER_FANFOLD_STD_GERMAN  40
#define DMPAPER_FANFOLD_LGL_GERMAN  41
#define DMPAPER_LAST        DMPAPER_FANFOLD_LGL_GERMAN
#define DMPAPER_USER        256

// bin selections
#define DMBIN_FIRST         DMBIN_UPPER
#define DMBIN_UPPER         1
#define DMBIN_ONLYONE       1
#define DMBIN_LOWER         2
#define DMBIN_MIDDLE        3
#define DMBIN_MANUAL        4
#define DMBIN_ENVELOPE      5
#define DMBIN_ENVMANUAL     6
#define DMBIN_AUTO          7
#define DMBIN_TRACTOR       8
#define DMBIN_SMALLFMT      9
#define DMBIN_LARGEFMT      10
#define DMBIN_LARGECAPACITY 11
#define DMBIN_CASSETTE      14
#define DMBIN_LAST          DMBIN_CASSETTE
#define DMBIN_USER          256

#endif  // C4W_PRINT_CH
