***************************************************************************
*Askforit International
*Amaury du Mesnil CIS: 100117,3327
***************************************************************************
*Here comes a Calendar and Useful date functions
*Get xxx Valid GetDate(hDlg, var, Range1, Range2)
*it is system Modal since it is used in gets
*
*NEEDS THE RESOURCE DIARY IN ASK4IT.RES
***************************************************************************
#define WIN_WANT_ALL
#include "windows.ch"
#include "dialog.ch"

#define AFRENCHMONTH {  "Janvier","Fvrier","Mars","Avril","Mai","Juin",;
                        "Juillet","Aot","Septembre","Octobre","Novembre","Dcembre"}
*===========================================================================
Func GetDate(hParent,dDate,R1,R2)                     //Range inf et sup
    Local d

    If dDate = Nil .or. Empty(dDate)
        dDate := Date()
    Endif
   
    d:= DialogBox(  _GetInstance(),;
                    "DIARY",;                         //Resource in Ask4it.Res
                    hParent,;
                    {|hDlg, msg, wparam, lparam|;
                     DiaryEvent(hDlg, msg, wparam, lparam,@dDate,R1,R2)})

    if d == IDCANCEL
        dDate:=CtoD("  /  /  ")                       //Default Return on Cancel
    endif
    Return dDate

*======================================
Static Func DiaryEvent(hWndDlg, nMsg, nWparam, nLparam,dDate)
    Static aDays
    Local i
    do case
    case nMsg == WM_SYSCOMMAND
        if nwParam == SC_CLOSE                        // system menu double click, or Alt-F4
            EndDialog(hWndDlg, IDCANCEL)              // *not* DestroyWindow()
        endif
    case nMsg == WM_INITDIALOG
        *Init des ScrollBar
        SetScrollRange(hWndDlg, SB_HORZ, 1, 12, .f.)
        SetScrollPos(hWndDlg, SB_HORZ, Month(dDate), .t.)

        SetScrollRange(hWndDlg, SB_VERT, 1, 200, .f.)
        SetScrollPos(hWndDlg, SB_VERT, 100, .t.)

        *Init Variables
        aDays   := Array(42)
        showWindow(hWndDlg,SW_SHOWNORMAL)
        PostMessage(hWndDlg,98,0,0)        
        return 1                                      // want system to set the focus

    case nMsg == 98
        CalendMonth(hWndDlg,@dDate,@aDays)

    case nMsg == WM_VSCROLL
        do case
        case nWParam == SB_LINEDOWN                   //Year+1
            CalendMonth(hWndDlg,Inc_Year(@dDate,1),@aDays)
        case nWParam == SB_PAGEDOWN                   //Year+10
            CalendMonth(hWndDlg,Inc_Year(@dDate,10),@aDays)
        case nWParam == SB_LINEUP                     //Year-1
            CalendMonth(hWndDlg,Inc_Year(@dDate,-1),@aDays)
        case nWParam == SB_PAGEUP                     //Year-10
            CalendMonth(hWndDlg,Inc_Year(@dDate,-10),@aDays)
        endcase

    case nMsg == WM_HSCROLL
        do case
        case nWParam == SB_TOP                        //First Month of the Year
            CalendMonth(hWndDlg,Boy(@dDate,.f.),@aDays)

        case nWParam == SB_BOTTOM                     //Last Month of th Year
            CalendMonth(hWndDlg,Eoy(@dDate,.f.),@aDays)
            
        case nWParam == SB_LINEDOWN                   //Month+1
            CalendMonth(hWndDlg,Inc_Mois(@dDate,1),@aDays)
            
        case nWParam == SB_PAGEDOWN                   //Month+3
            CalendMonth(hWndDlg,Inc_Mois(@dDate,3),@aDays)

        case nWParam == SB_LINEUP                     //Month-1
            CalendMonth(hWndDlg,Inc_Mois(@dDate,-1),@aDays)
        case nWParam == SB_PAGEUP                     //Month-3
            CalendMonth(hWndDlg,Inc_Mois(@dDate,-3),@aDays)
        endcase
        SetScrollPos(hWndDlg, SB_HORZ, Month(dDate), .t.)

    case nMsg == WM_COMMAND
        If (i:=Ascan(aDays,{|a| a[1]=nWParam}))>0
            dDate:=CtoD( aDays[i,2] + Right(Dtoc(dDate),6) )
            EndDialog(hWndDlg,1)                      // *not* DestroyWindow()
        Endif
    endcase
    return 0                                          // means msg not processed (and want default action)
    
*======================================
Static Func CalendMonth(hWndDlg,dDate,aDays)
    Static nPrevDef
    Local  i
    Local d1st
    Local nNbDays
    Local nFocus
    Local cDay

    *Titre du Calendrier
    SendMessage(hWndDlg,WM_SETTEXT,0,AFRENCHMONTH[Month(dDate)]+" "+Transform(Year(dDate),"9999"))
    d1st    :=Dow(Bom(dDate))                         //get first day of the Month Dim=1 Sam=7
    nNbDays :=Bom(Inc_Mois(dDate,1)) - Bom(dDate)

    For i:=1 to 42
        if i<d1st
            aDays[i]:={999+i,"-",.F.}
        Elseif i>=d1st+nNbDays
            aDays[i]:={999+i,"-",.F.}
        Else
            aDays[i]:={999+i,Transform(i-d1st+1,"99"),.t.}
            if (i-d1st+1)=Day(dDate)
                SendDlgItemMessage(hWndDlg,;
                                    aDays[i,1],;
                                    BM_SETSTYLE,;
                                    BS_DEFPUSHBUTTON,;
                                    1)
                SetFocus(GetDlgItem(hWndDlg,aDays[i,1]))
            Else
                SendDlgItemMessage(hWndDlg,;
                                    aDays[i,1],;
                                    BM_SETSTYLE,;
                                    BS_PUSHBUTTON,;
                                    1)
            Endif
        Endif
            
        SendDlgItemMessage(hWndDlg,aDays[i,1],WM_SETTEXT,0,aDays[i,2])
        ShowWindow(GetDlgItem(hWndDlg,aDays[i,1]),If(aDays[i,3],SW_SHOW,SW_HIDE))//Enable Cancel 1=enable, 0 Disable
    Next i
    Return Nil

*============================================================================
Func Bom(dDate)                                       // BOM(dDate) Dbut de Mois
    Return( Ctod("01"+right(Dtoc(dDate),6)) )

*============================================================================
Func Eom(dDate)                                       // BOM(dDate) Dbut de Mois
    Return( Inc_Mois(Ctod("01"+right(Dtoc(dDate),6)),1)-1 )

*============================================================================
Func Elapmois(dDate1,dDate2)                          // retour nb mois
    Return( (year(dDate2) - year(dDate1))*12 +;
            (Month(dDate2)-Month(dDate1))+1 )

*============================================================================
Func mois_an(dDate)                                   // Mois_an(dDate) Returns mm/yy 
    Return( strZero(Month(dDate),2)+"/"+right(dtoc(dDate),2) )


*======================================
Static Func Boy(dDate,lFirstDay)                      // BOY(dDate) Dbut de l'Anne
    Local nJour :=Day(dDate)
    Local nMois :=Month(dDate)
    Local nAn   :=Year(dDate)
    If Valtype(lFirstDay)#"L"
        lFirstDay:=.t.
    Endif
        lFirstDay:=.t.
    If lFirstDay
        Tone(30,1)
        Ctod("01/01/"+Transform(Year(dDate),"99"))
    Else
        dDate:=Dtoc(dDate)
        Ctod( Left(dDate,2)+"/01/"+right(dDate,2) )
    Endif
    Return(dDate)

*======================================
Static Func Eoy(dDate,lLastDay)                       // EOY(dDate) Fin de l'Anne
    If Valtype(lLastDay)#"L"
        lLastDay:=.t.
    Endif
    If lLastDay
        Ctod("31/12/"+right(Dtoc(dDate),2))
    Else
        dDate:=Dtoc(dDate)
        Ctod( Left(dDate,3)+"12"+right(dDate,3) )
    Endif
    Return(dDate)

*============================================================================
Func FrenchDate(dDate)
    Return if(!Empty(dDate),Transform(Day(dDate),"99")+"  "+;
                                AFRENCHMONTH[Month(dDate)]+"  "+;
                                Transform(Year(dDate),"9999"),;
                            "  /  /  ")
*============================================================================
Func Inc_Mois(dDate,nTime)                            // Func Inc_Mois(dDate,nTime) Increment or decrement nTime Month
    Local nJour
    Local nMois
    Local nAn
    Local nI
    Local aMaxjour:={31,28,31,30,31,30,31,31,30,31,30,31}

    nTime:=if(pcount()<2,1,nTime)
    nJour:=day(dDate)
    nMois:=month(dDate)
    nAn  :=year(dDate)

    If nTime>0
        for nI:=1 to nTime
            nAn  :=if( nMois=12,nAn+1,nAn )           // inc one year if month=12
            nMois:=if( nMois=12,1,nMois+1 )
        next nI
    Elseif nTime<0
        for nI:=1 to -(nTime)
            nAn  :=if( nMois=1,nAn-1,nAn )            // dec one year if month=1
            nMois:=if( nMois=1,12,nMois-1 )
        next nI
    Endif
    nJour:=If( nMois>0.and.nJour > aMaxjour[nMois],aMaxjour[nMois],nJour)
    dDate:=ctod( strzero(nJour,2)+"/"+str(nMois,2)+"/"+right(str(nAn),2) )
    return(dDate)

*======================================
Static Func Inc_Year(dDate,nTime)
    Local nYear
    If Valtype(nTime)#"N"                             //Sould be numeric
        nTime:=1                                      //default to 1
    Endif
    nYear:=Year(dDate)
    nYear+=nTime                                      //Increment year
    dDate:=Dtoc(dDate)                                //work on tring
    dDate:=CtoD( Left(dDate,6)+Right(Transform(nYear,"9999"),4) )//new date
    return(dDate)
    
